﻿namespace MapleServer2.Enums;

public enum ItemStringTag
{
    None = 0,
    LulluKey = 26,
    LulluBox = 27, // Mystery Box
    LulluKey03 = 32, // Luxurious Style Key
    LulluBox03 = 33, // Holiday Mystery Box
    LulluKey04 = 34, // Golden Jewel Key
    LulluBox04 = 35, // Mystery Style Box
    LulluBox05 = 37, // Mystery Jewel Box
    LulluBox08 = 43, // Style Crate
    SkinCrystal = 92, // Special Outfit Crystal
    MetaCell = 96,
    RedCrystal = 97,
    GreenCrystal = 98,
    BlueCrystal = 99,
    CrystalPiece = 100, // Crystal Fragment
    Onix = 101, // Onyx Crystal
    ChaosOnix = 102, // Chaos Onyx Crystal
    CrystalGemstone = 103, // Crystal Ore
    LockItemOptionWeapon = 105, // Epic Weapon Attribute Lock Scroll
    LockItemOptionArmor = 106, // Epic Armor Attribute Lock Scroll
    LockItemOptionAccessory = 107, // Epic Accessory Attribute Lock Scroll
    LockItemOptionPet = 108, // Pet Talent Lock Candy
    UGCEventOxOpen = 109, // UGC OX Quiz Host Ticket
    ExpenseRewardTicket = 112, // Dungeon Reward Booster
    AutoMastery = 113, // Instant Gathering Voucher
    EpicCharmStone = 123,
    EpicProtectStone = 124,
    GemstoneA01 = 127, // Tier 1 Wisdom Gemstone
    GemstoneA02 = 128, // Tier 2 Wisdom Gemstone
    GemstoneA03 = 129, // Tier 3 Wisdom Gemstone
    GemstoneA04 = 130, // Tier 4 Wisdom Gemstone
    GemstoneA05 = 131, // Tier 5 Wisdom Gemstone
    GemstoneA06 = 132, // Tier 6 Wisdom Gemstone
    GemstoneA07 = 133, // Tier 7 Wisdom Gemstone
    GemstoneA08 = 134, // Tier 8 Wisdom Gemstone
    GemstoneA09 = 135, // Tier 9 Wisdom Gemstone
    GemstoneA10 = 136, // Tier 10 Wisdom Gemstone
    GemstoneB01 = 137, // Tier 1 Luck Gemstone
    GemstoneB02 = 138, // Tier 2 Luck Gemstone
    GemstoneB03 = 139, // Tier 3 Luck Gemstone
    GemstoneB04 = 140, // Tier 4 Luck Gemstone
    GemstoneB05 = 141, // Tier 5 Luck Gemstone
    GemstoneB06 = 142, // Tier 6 Luck Gemstone
    GemstoneB07 = 143, // Tier 7 Luck Gemstone
    GemstoneB08 = 144, // Tier 8 Luck Gemstone
    GemstoneB09 = 145, // Tier 9 Luck Gemstone
    GemstoneB10 = 146, // Tier 10 Luck Gemstone
    GemstoneC01 = 147, // Tier 1 Destruction Gemstone
    GemstoneC02 = 148, // Tier 2 Destruction Gemstone 
    GemstoneC03 = 149, // Tier 3 Destruction Gemstone
    GemstoneC04 = 150, // Tier 4 Destruction Gemstone
    GemstoneC05 = 151, // Tier 5 Destruction Gemstone
    GemstoneC06 = 152, // Tier 6 Destruction Gemstone
    GemstoneC07 = 153, // Tier 7 Destruction Gemstone
    GemstoneC08 = 154, // Tier 8 Destruction Gemstone
    GemstoneC09 = 155, // Tier 9 Destruction Gemstone
    GemstoneC10 = 156, // Tier 10 Destruction Gemstone
    GemstoneD01 = 157, // Tier 1 Life Gemstone
    GemstoneD02 = 158, // Tier 2 Life Gemstone 
    GemstoneD03 = 159, // Tier 3 Life Gemstone
    GemstoneD04 = 160, // Tier 4 Life Gemstone
    GemstoneD05 = 161, // Tier 5 Life Gemstone
    GemstoneD06 = 162, // Tier 6 Life Gemstone
    GemstoneD07 = 163, // Tier 7 Life Gemstone
    GemstoneD08 = 164, // Tier 8 Life Gemstone
    GemstoneD09 = 165, // Tier 9 Life Gemstone
    GemstoneD10 = 166, // Tier 10 Life Gemstone
    GemstoneE01 = 167, // Tier 1 Power Gemstone
    GemstoneE02 = 168, // Tier 2 Power Gemstone
    GemstoneE03 = 169, // Tier 3 Power Gemstone
    GemstoneE04 = 170, // Tier 4 Power Gemstone
    GemstoneE05 = 171, // Tier 5 Power Gemstone
    GemstoneE06 = 172, // Tier 6 Power Gemstone
    GemstoneE07 = 173, // Tier 7 Power Gemstone
    GemstoneE08 = 174, // Tier 8 Power Gemstone
    GemstoneE09 = 175, // Tier 9 Power Gemstone
    GemstoneE10 = 176, // Tier 10 Power Gemstone
    GemstoneF01 = 177, // Tier 1 Dex Gemstone
    GemstoneF02 = 178, // Tier 2 Dex Gemstone
    GemstoneF03 = 179, // Tier 3 Dex Gemstone
    GemstoneF04 = 180, // Tier 4 Dex Gemstone
    GemstoneF05 = 181, // Tier 5 Dex Gemstone
    GemstoneF06 = 182, // Tier 6 Dex Gemstone
    GemstoneF07 = 183, // Tier 7 Dex Gemstone
    GemstoneF08 = 184, // Tier 8 Dex Gemstone
    GemstoneF09 = 185, // Tier 9 Dex Gemstone
    GemstoneF10 = 186, // Tier 10 Dex Gemstone
    GemstoneG01 = 187, // Tier 1 Accuracy Gemstone
    GemstoneG02 = 188, // Tier 2 Accuracy Gemstone
    GemstoneG03 = 189, // Tier 3 Accuracy Gemstone
    GemstoneG04 = 190, // Tier 4 Accuracy Gemstone
    GemstoneG05 = 191, // Tier 5 Accuracy Gemstone
    GemstoneG06 = 192, // Tier 6 Accuracy Gemstone
    GemstoneG07 = 193, // Tier 7 Accuracy Gemstone
    GemstoneG08 = 194, // Tier 8 Accuracy Gemstone
    GemstoneG09 = 195, // Tier 9 Accuracy Gemstone
    GemstoneG10 = 196, // Tier 10 Accuracy Gemstone
    GemstoneH01 = 197, // Tier 1 Offense Gemstone
    GemstoneH02 = 198, // Tier 2 Offense Gemstone 
    GemstoneH03 = 199, // Tier 3 Offense Gemstone
    GemstoneH04 = 200, // Tier 4 Offense Gemstone
    GemstoneH05 = 201, // Tier 5 Offense Gemstone
    GemstoneH06 = 202, // Tier 6 Offense Gemstone
    GemstoneH07 = 203, // Tier 7 Offense Gemstone
    GemstoneH08 = 204, // Tier 8 Offense Gemstone
    GemstoneH09 = 205, // Tier 9 Offense Gemstone
    GemstoneH10 = 206, // Tier 10 Offense Gemstone
    EnchantJockerItemNormal = 207, // Toad's Toolkit
    EnchantJockerItemRare = 208, // Toad's Toolkit
    EnchantJockerItemElite = 209, // Toad's Toolkit
    EnchantJockerItemExcellent = 210, // Toad's Toolkit
    EnchantJockerItemLegendary = 211, // Toad's Toolkit
    EnchantJockerItemEpic = 212, // Toad's Toolkit
    FameCompletionTicket = 213, // Daily Mission Insta-Completion Voucher
    PrismShard = 214,
    PrismStone = 215,
    WeddingHallCoupon_Grade1 = 216,
    WeddingHallCoupon_Grade2 = 217,
    WeddingHallCoupon_Grade3 = 218
}
