﻿--
-- Table structure for table `banners`
--

DROP TABLE IF EXISTS `banners`;
CREATE TABLE `banners`
(
    `id`         int    NOT NULL AUTO_INCREMENT,
    `name`       text,
    `type`       text   NOT NULL,
    `sub_type`   text   NOT NULL,
    `image_url`  text,
    `language`   int    NOT NULL,
    `begin_time` bigint NOT NULL,
    `end_time`   bigint NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Table structure for table `meretmarketitems`
--

DROP TABLE IF EXISTS `meret_market_items`;
CREATE TABLE `meret_market_items`
(
    `market_id`                   int      NOT NULL AUTO_INCREMENT,
    `section`                     int      NOT NULL,
    `banner_id`                   int DEFAULT NULL,
    `bonus_quantity`              int      NOT NULL,
    `category`                    int      NOT NULL,
    `duration`                    int      NOT NULL,
    `flag`                        tinyint unsigned NOT NULL,
    `item_id`                     int      NOT NULL,
    `item_name`                   text,
    `job_requirement`             int      NOT NULL,
    `max_level_requirement`       smallint NOT NULL,
    `min_level_requirement`       smallint NOT NULL,
    `pc_cafe`                     tinyint(1) NOT NULL,
    `parent_market_id`            int      NOT NULL,
    `price`                       bigint   NOT NULL,
    `promo_banner_begin_time`     bigint   NOT NULL,
    `promo_banner_end_time`       bigint   NOT NULL,
    `promo_flag`                  int      NOT NULL,
    `promo_name`                  text,
    `quantity`                    int      NOT NULL,
    `rarity`                      tinyint unsigned NOT NULL,
    `required_achievement_grade`  int      NOT NULL,
    `required_achievement_id`     int      NOT NULL,
    `restock_unavailable`         tinyint(1) NOT NULL,
    `sale_price`                  bigint   NOT NULL,
    `sell_begin_time`             bigint   NOT NULL,
    `sell_end_time`               bigint   NOT NULL,
    `show_sale_time`              tinyint(1) NOT NULL,
    `token_type`                  tinyint unsigned NOT NULL,
    `sales_count`                 int      NOT NULL,
    `creation_time`               bigint   NOT NULL,
    PRIMARY KEY (`market_id`),
    KEY                           `ix_meretmarketitems_bannerid` (`banner_id`),
    CONSTRAINT `fk_meretmarketitems_banners_bannerid` FOREIGN KEY (`banner_id`) REFERENCES `banners` (`id`) ON DELETE RESTRICT
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

INSERT INTO `banners` (`id`, `name`, `type`, `sub_type`, `image_url`, `language`, `begin_time`, `end_time`)
VALUES (1, 'homeproduct_emulator', 'merat', 'cash', 'https://i.imgur.com/TV47C2m.png', -1, 1262304000, 4102444800);

INSERT INTO `meret_market_items` (`market_id`, `section`, `banner_id`, `bonus_quantity`, `category`, `duration`, `flag`, `item_id`,
                                  `item_name`, `job_requirement`, `max_level_requirement`,
                                  `min_level_requirement`, `pc_cafe`, `parent_market_id`,
                                  `price`, `promo_banner_begin_time`, `promo_banner_end_time`, `promo_flag`,
                                  `promo_name`, `quantity`, `rarity`, `required_achievement_grade`,
                                  `required_achievement_id`, `restock_unavailable`, `sale_price`, `sell_begin_time`,
                                  `sell_end_time`, `show_sale_time`, `token_type`, `sales_count`, `creation_time`)
VALUES (10000, 100000, 1, 0, 10, 0, 0, 22002001, 'Slime Variety Capsule', 4095, 0, 0, 0, 0, 120, 1262304000, 4102444800, 0, '', 1, 4, 0, 0,
        0, 100, 1262304000, 4102444800, 1, 1, 0, 0),
       (10001, 100000, NULL, 0, 0, 0, 0, 22002001, 'Slime Variety Capsule', 4095, 0, 0, 0, 10000, 1200, 0, 0, 0, '', 10, 4, 0, 0, 0,
        900, 1262304000, 4102444800, 0, 1, 0, 0),
       (10002, 100000, NULL, 0, 0, 0, 0, 22002001, 'Slime Variety Capsule', 4095, 0, 0, 0, 10000, 6000, 0, 0, 0, '', 50, 4, 0, 0, 0,
        5000, 1262304000, 4102444800, 0, 1, 0, 0),
       (10010, 100000, NULL, 0, 10, 0, 0, 22001010, 'Ducky Outfit Capsule', 4095, 0, 0, 0, 0, 130, 1262304000, 4102444800, 1, '', 1, 4, 0,
        0, 0, 100, 1262304000, 4102444800, 0, 1, 0, 0),
       (10011, 100000, NULL, 0, 0, 0, 0, 22001010, 'Ducky Outfit Capsule', 4095, 0, 0, 0, 10010, 1300, 0, 0, 0, '', 10, 4, 0, 0, 0,
        950, 1262304000, 4102444800, 0, 1, 0, 0),
       (10012, 100000, NULL, 0, 0, 0, 0, 22001010, 'Ducky Outfit Capsule', 4095, 0, 0, 0, 10010, 6500, 0, 0, 0, '', 50, 4, 0, 0, 0,
        5200, 1262304000, 4102444800, 0, 1, 0, 0),
       (143010, 100000, NULL, 0, 40300, 0, 0, 70100005, 'Auto-Gathering Badge (30 Day)', 4095, 0, 0, 0, 0, 360, 0, 0, 0, '', 1, 1, 0, 0, 0, 360,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143020, 100000, NULL, 0, 40300, 0, 0, 70100004, 'Auto-Gathering Badge (7 Day)', 4095, 0, 0, 0, 0, 140, 0, 0, 0, '', 1, 1, 0, 0, 0, 140,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143025, 100000, NULL, 0, 40300, 0, 0, 70100001, 'Transparency Badge', 4095, 0, 0, 0, 0, 1450, 0, 0, 0, '', 1, 1, 0, 0, 0, 1450,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143030, 100000, NULL, 0, 40300, 0, 0, 30000896, 'Glamour Anvil', 4095, 0, 0, 0, 0, 650, 0, 0, 0, '', 1, 1, 0, 0, 0, 650,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143040, 100000, NULL, 0, 40300, 0, 0, 20302314, 'Pet Skin Crafting Scroll', 4095, 0, 0, 0, 0, 650, 0, 0, 0, '', 1, 1, 0, 0, 0, 650,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143050, 100000, NULL, 0, 40300, 0, 0, 20300011, 'Emergency Radio', 4095, 0, 0, 0, 0, 30, 0, 0, 0, '', 1, 1, 0, 0, 0, 30,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143051, 100000, NULL, 0, 0, 0, 0, 20300011, 'Emergency Radio', 4095, 0, 0, 0, 143050, 150, 0, 0, 0, '', 5, 1, 0, 0, 0,
        150, 1262304000, 4102444800, 0, 1, 0, 0),
       (143052, 100000, NULL, 0, 0, 0, 0, 20300011, 'Emergency Radio', 4095, 0, 0, 0, 143050, 300, 0, 0, 0, '', 10, 1, 0, 0,
        0, 300, 1262304000, 4102444800, 0, 1, 0, 0),
       (143053, 100000, NULL, 0, 0, 0, 0, 20300011, 'Emergency Radio', 4095, 0, 0, 0, 143050, 900, 0, 0, 0, '', 30, 1, 0, 0,
        0, 900, 1262304000, 4102444800, 0, 1, 0, 0),
       (143060, 100000, NULL, 0, 40300, 0, 0, 20000004, 'Elixir', 4095, 0, 0, 0, 0, 7, 0, 0, 0, '', 1, 1, 0, 0, 0, 7,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143061, 100000, NULL, 0, 0, 0, 0, 20000004, 'Elixir', 4095, 0, 0, 0, 143060, 70, 0, 0, 0, '', 10, 1, 0, 0, 0,
        65, 1262304000, 4102444800, 0, 1, 0, 0),
       (143062, 100000, NULL, 0, 0, 0, 0, 20000004, 'Elixir', 4095, 0, 0, 0, 143060, 350, 0, 0, 0, '', 50, 1, 0, 0,
        0, 300, 1262304000, 4102444800, 0, 1, 0, 0),
       (143063, 100000, NULL, 0, 0, 0, 0, 20000004, 'Elixir', 4095, 0, 0, 0, 143060, 700, 0, 0, 0, '', 100, 1, 0, 0,
        0, 550, 1262304000, 4102444800, 0, 1, 0, 0),
       (143070, 100000, NULL, 0, 40300, 0, 0, 20300226, 'Rotors Walkie-talkie', 4095, 0, 0, 0, 0, 5, 0, 0, 0, '', 1, 1, 0, 0, 0, 5,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143071, 100000, NULL, 0, 0, 0, 0, 20300226, 'Rotors Walkie-talkie', 4095, 0, 0, 0, 143070, 50, 0, 0, 0, '', 10, 1, 0, 0, 0,
        45, 1262304000, 4102444800, 0, 1, 0, 0),
       (143072, 100000, NULL, 0, 0, 0, 0, 20300226, 'Rotors Walkie-talkie', 4095, 0, 0, 0, 143070, 250, 0, 0, 0, '', 50, 1, 0, 0,
        0, 200, 1262304000, 4102444800, 0, 1, 0, 0),
       (143073, 100000, NULL, 0, 0, 0, 0, 20300226, 'Rotors Walkie-talkie', 4095, 0, 0, 0, 143070, 500, 0, 0, 0, '', 100, 1, 0, 0,
        0, 380, 1262304000, 4102444800, 0, 1, 0, 0),
       (143080, 100000, NULL, 0, 40300, 0, 0, 20301114, 'Skill Tab Voucher', 4095, 0, 0, 0, 0, 990, 0, 0, 0, '', 1, 1, 0, 0, 0, 990,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143090, 100000, NULL, 0, 40300, 0, 0, 20300225, '1-slot Character Card', 4095, 0, 0, 0, 0, 790, 0, 0, 0, '', 1, 1, 0, 0, 0, 790,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143100, 100000, NULL, 0, 40300, 0, 0, 20300224, 'Gender Change Voucher', 4095, 0, 0, 0, 0, 1390, 0, 0, 0, '', 1, 1, 0, 0, 0, 1390,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143110, 100000, NULL, 0, 40300, 0, 0, 20300222, 'Name Change Voucher', 4095, 0, 0, 0, 0, 990, 0, 0, 0, '', 1, 1, 0, 0, 0, 990,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143120, 100000, NULL, 0, 40300, 0, 0, 20300054, 'Guild Summon Scroll', 4095, 0, 0, 0, 0, 150, 0, 0, 0, '', 1, 1, 0, 0, 0, 150,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143130, 100000, NULL, 0, 40300, 0, 0, 20300046, 'Helium Balloon', 4095, 0, 0, 0, 0, 10, 0, 0, 0, '', 1, 1, 0, 0, 0, 10,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143140, 100000, NULL, 0, 40300, 1, 0, 20300089, 'Goldus MTM', 4095, 0, 0, 0, 0, 60, 0, 0, 0, '', 1, 1, 0, 0, 0, 60,
        1262304000, 4102444800, 0, 1, 0, 0),
       (143141, 100000, NULL, 0, 0, 7, 0, 20300089, 'Goldus MTM', 4095, 0, 0, 0, 143140, 420, 0, 0, 0, '', 1, 1, 0, 0, 0,
        270, 1262304000, 4102444800, 0, 1, 0, 0),
       (146000, 100000, NULL, 0, 40600, 0, 0, 34000088, 'Gold Star Bass Drum', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146010, 100000, NULL, 0, 40600, 0, 0, 34000089, 'Gold Star Snare Drum', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146020, 100000, NULL, 0, 40600, 0, 0, 34000090, 'Gold Star Cymbals', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146030, 100000, NULL, 0, 40600, 0, 0, 34000071, 'Arlano Classic Celesta', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146040, 100000, NULL, 0, 40600, 0, 0, 34000070, 'Arlano Classic Recorder', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146050, 100000, NULL, 0, 40600, 0, 0, 34000049, 'Arlano Classic Xylophone', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146060, 100000, NULL, 0, 40600, 0, 0, 34000048, 'Arlano Classic Harmonica', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146070, 100000, NULL, 0, 40600, 0, 0, 34000041, 'Arlano Classic Harpsichord', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146080, 100000, NULL, 0, 40600, 0, 0, 34000040, 'Arlano Classic Pizzicato', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146090, 100000, NULL, 0, 40600, 0, 0, 34000039, 'Arlano Classic Oboe', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146100, 100000, NULL, 0, 40600, 0, 0, 34000035, 'Purio Electric Piano', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146110, 100000, NULL, 0, 40600, 0, 0, 34000036, 'Purio Pick Bass', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146120, 100000, NULL, 0, 40600, 0, 0, 34000037, 'Purio Steel Drum', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146130, 100000, NULL, 0, 40600, 0, 0, 34000028, 'Arlano Acoustic Bass', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146140, 100000, NULL, 0, 40600, 0, 0, 34000027, 'Arlano Classic Ocarina', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146150, 100000, NULL, 0, 40600, 0, 0, 34000029, 'Arlano Classic Vibraphone', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146160, 100000, NULL, 0, 40600, 0, 0, 34000024, 'Arlano Classic Saxophone', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146170, 100000, NULL, 0, 40600, 0, 0, 34000025, 'Arlano Classic Trombone', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146180, 100000, NULL, 0, 40600, 0, 0, 34000026, 'Arlano Classic Trumpet', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146190, 100000, NULL, 0, 40600, 0, 0, 34000021, 'Arlano Classic Violin', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146200, 100000, NULL, 0, 40600, 0, 0, 34000022, 'Arlano Classic Cello', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146210, 100000, NULL, 0, 40600, 0, 0, 34000023, 'Arlano Classic Pan Flute', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146220, 100000, NULL, 0, 40600, 0, 0, 34000013, 'Purio Electric Guitar', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146230, 100000, NULL, 0, 40600, 0, 0, 34000014, 'Purio Bass Guitar', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146240, 100000, NULL, 0, 40600, 0, 0, 34000015, 'Purio Tom-toms', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146250, 100000, NULL, 0, 40600, 0, 0, 34000012, 'Arlano Classic Timpani', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146260, 100000, NULL, 0, 40600, 0, 0, 34000011, 'Arlano Classic Harp', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146270, 100000, NULL, 0, 40600, 0, 0, 34000010, 'Arlano Classic Clarinet', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146280, 100000, NULL, 0, 40600, 0, 0, 34000009, 'Arlano Classic Guitar', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0),
       (146290, 100000, NULL, 0, 40600, 0, 0, 34000008, 'Arlano Classic Piano', 4095, 0, 0, 0, 0, 500, 0, 0, 0, '', 1, 3, 0, 0, 0, 500,
        1262304000, 4102444800, 0, 1, 0, 0);