--
-- Table structure for table `shopitems`
--

DROP TABLE IF EXISTS `shop_items`;
CREATE TABLE `shop_items`
(
    `uid`                              int              NOT NULL AUTO_INCREMENT,
    `auto_preview_equip`               tinyint(1)       NOT NULL,
    `category`                         varchar(25) DEFAULT NULL,
    `flag`                             tinyint unsigned NOT NULL,
    `guild_trophy`                     int              NOT NULL,
    `item_id`                          int              NOT NULL,
    `item_rank`                        tinyint unsigned NOT NULL,
    `price`                            int              NOT NULL,
    `quantity`                         smallint         NOT NULL,
    `required_achievement_grade`       int              NOT NULL,
    `required_achievement_id`          int              NOT NULL,
    `required_championship_grade`      tinyint unsigned NOT NULL,
    `required_championship_join_count` smallint         NOT NULL,
    `required_fame_grade`              int              NOT NULL,
    `required_guild_merchant_level`    smallint         NOT NULL,
    `required_guild_merchant_type`     tinyint unsigned NOT NULL,
    `required_item_id`                 int              NOT NULL,
    `required_quest_alliance`          smallint         NOT NULL,
    `sale_price`                       int              NOT NULL,
    `shop_id`                          int         DEFAULT NULL,
    `stock_count`                      int              NOT NULL,
    `stock_purchased`                  int              NOT NULL,
    `template_name`                    varchar(25) DEFAULT NULL,
    `token_type`                       tinyint unsigned NOT NULL,
    PRIMARY KEY (`uid`),
    KEY `ix_shopitems_shopid` (`shop_id`),
    CONSTRAINT `fk_shopitems_shops_shopid` FOREIGN KEY (`shop_id`) REFERENCES `shops` (`id`) ON DELETE RESTRICT
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4
  COLLATE = utf8mb4_0900_ai_ci;

INSERT INTO `shop_items` (`auto_preview_equip`, `category`, `flag`, `guild_trophy`, `item_id`, `item_rank`, `price`,
                          `quantity`, `required_achievement_grade`, `required_achievement_id`,
                          `required_championship_grade`, `required_championship_join_count`, `required_fame_grade`,
                          `required_guild_merchant_level`, `required_guild_merchant_type`, `required_item_id`,
                          `required_quest_alliance`, `sale_price`, `shop_id`, `stock_count`, `stock_purchased`,
                          `template_name`, `token_type`)
VALUES (0, 'PS', 0, 0, 63000000, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (1, 'Excellecnt02', 0, 0, 11720040, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820039, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820040, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220039, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220040, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11020111, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11020112, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120111, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120112, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320111, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320112, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720111, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720112, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220111, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220112, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320219, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320220, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320323, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320324, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320401, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320402, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420401, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420402, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720401, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720402, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620401, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620402, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720039, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11520403, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620040, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320040, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220209, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220210, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320211, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320212, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320221, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320222, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320319, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320320, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320321, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320322, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820211, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820212, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220047, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220048, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320047, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320048, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620047, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620048, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720047, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720048, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820047, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820048, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220047, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220048, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11020039, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11020040, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320039, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620039, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11520404, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820217, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820218, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201010, 0, 0, 101010, 0, 0, '22201001', 1),
       (0, 'Action', 0, 0, 20201009, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201010, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201011, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201012, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201013, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201014, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101002, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802002, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410005, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410006, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610003, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620003, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401003, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501003, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601003, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711003, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310003, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210003, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211003, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201015, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201016, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201017, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201018, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201019, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201020, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201021, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101003, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201029, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211002, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210002, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310002, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410001, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410002, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610001, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620001, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401001, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501001, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601001, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711001, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310001, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210001, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211001, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201001, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201002, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (1, 'Normal', 0, 0, 11720210, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (0, 'Action', 0, 0, 20201003, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201005, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201006, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201007, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101001, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802001, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410003, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410004, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610002, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620002, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401002, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501002, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601002, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711002, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202002, 0, 0, 102002, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201004, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202001, 0, 0, 102001, 0, 0, '22202001', 1),
       (1, 'Normal', 0, 0, 11720209, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320210, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320209, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820187, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820188, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820189, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820190, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820191, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820192, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220027, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220028, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320027, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320028, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620027, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620028, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720027, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720028, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820027, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820028, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220027, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220028, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220089, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220090, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320089, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320090, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620089, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620090, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720089, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720090, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820089, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820186, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820185, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320192, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320191, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220041, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220042, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320041, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320042, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620041, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620042, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720041, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720042, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820041, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820042, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220041, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220042, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320109, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820090, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320110, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620110, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720109, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720110, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11820109, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11820110, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220109, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220110, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320185, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320186, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320187, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320188, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320189, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320190, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620109, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (0, 'ETC', 0, 0, 20802003, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202003, 0, 0, 102003, 0, 0, '22202001', 1),
       (1, 'Excellecnt02', 0, 0, 12220089, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120351, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720054, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820053, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820054, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220053, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220054, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220081, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220082, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320081, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320082, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620081, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620082, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720081, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720082, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820081, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820082, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220081, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220082, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220115, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220116, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320115, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320116, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620115, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620116, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720115, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720116, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220115, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220116, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720053, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620054, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620053, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320054, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120352, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320351, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320352, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620351, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620352, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720351, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720352, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220351, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220352, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120207, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120208, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320205, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320206, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220090, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820205, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220193, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220194, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320203, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320204, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620203, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620204, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720203, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720204, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220203, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220204, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220053, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220054, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320053, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201009, 0, 0, 101009, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820206, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201008, 0, 0, 101008, 0, 0, '22201001', 1),
       (0, 'Ride', 0, 0, 40410007, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410008, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610004, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (1, 'Legendary02', 0, 0, 11720358, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11820357, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11820358, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 12220357, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 12220358, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11320419, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11320420, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11620419, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11620420, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11720419, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11720420, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11820419, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11820420, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 12220419, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 12220420, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 70910004, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20710003, 4, 28, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 34000098, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 34000092, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20303087, 4, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20303162, 4, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (0, 'Fish', 0, 0, 20000265, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 20000276, 1, 2500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 20000307, 1, 10000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 20000308, 1, 20000, 1, 1, 23100136, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 20000309, 1, 50000, 1, 1, 23100137, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 20000310, 1, 100000, 1, 1, 23100138, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (1, 'Legendary02', 0, 0, 11720357, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11620358, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11620357, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11320358, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11620362, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11720361, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11720362, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11820361, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11820362, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 12220361, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 12220362, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 70910001, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20710001, 4, 28, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20303116, 4, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 20303117, 4, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 34000056, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Other', 0, 0, 34000087, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (0, 'Fish', 0, 0, 32000001, 1, 5000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (1, 'Legendary01', 0, 0, 11220355, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11320355, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11320356, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11620355, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11620356, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11720355, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11720356, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11820355, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11820356, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 12220355, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 12220356, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11220357, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11220358, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11320357, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11220356, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204202, 0, 0, 104202, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11620361, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (0, 'Fish', 0, 0, 32000005, 2, 100000, 1, 1, 23100136, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 32000011, 4, 500000, 1, 1, 23100138, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Jewel', 0, 0, 30000148, 1, 2400, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Jewel', 0, 0, 30000147, 1, 1200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Diamond', 0, 0, 30000149, 1, 10000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 30000272, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'PD', 0, 0, 11900061, 3, 1000000, 1, 8, 22100002, 0, 0, 0, 0, 0, 0, 0, 0, 148, 0, 0, '', 0),
       (0, 'PD', 0, 0, 11900062, 3, 1000000, 1, 2, 23100009, 0, 0, 0, 0, 0, 0, 0, 0, 148, 0, 0, '', 0),
       (0, 'PD', 0, 0, 11900063, 3, 1000000, 1, 6, 23100002, 0, 0, 0, 0, 0, 0, 0, 0, 148, 0, 0, '', 0),
       (0, 'PD', 0, 0, 11900064, 3, 1000000, 1, 6, 23100008, 0, 0, 0, 0, 0, 0, 0, 0, 148, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 50600012, 3, 4000000, 1, 4, 22200004, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 50600010, 3, 4000000, 1, 3, 23400004, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 50600002, 3, 4000000, 1, 3, 23400002, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 50600046, 4, 10000000, 1, 5, 21100019, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 20000, 50600047, 4, 10000000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 50000, 50600048, 4, 10000000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 50600033, 4, 12500000, 1, 8, 23200001, 0, 0, 0, 0, 0, 0, 0, 0, 121, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000022, 1, 750, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000023, 1, 2480, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000024, 1, 4280, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000028, 1, 210, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000029, 1, 980, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000030, 1, 2360, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000031, 1, 4160, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000032, 1, 5180, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000033, 1, 5670, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000025, 1, 5820, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000026, 1, 7380, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000027, 1, 8960, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000243, 1, 4000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 20000086, 1, 500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 20000084, 1, 700, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 20000085, 1, 1100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11400383, 1, 1500000, 1, 3, 23100154, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11500311, 1, 1500000, 1, 3, 23100154, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11700411, 1, 1000000, 1, 3, 23100154, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'FishEtc', 0, 0, 40100039, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11300036, 1, 1500000, 1, 3, 22200194, 0, 0, 0, 0, 0, 0, 0, 0, 963, 0, 0, '', 0),
       (0, 'PS', 0, 0, 63000000, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'Flight', 0, 0, 40400020, 3, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'SKC', 0, 0, 40100039, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301053, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301054, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301057, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000022, 1, 750, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000023, 1, 2480, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'Fish', 0, 0, 32000008, 3, 300000, 1, 1, 23100137, 0, 0, 0, 0, 0, 0, 0, 0, 161, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000024, 1, 4280, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000029, 1, 980, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000030, 1, 2360, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000031, 1, 4160, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000032, 1, 5180, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000033, 1, 5670, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000234, 1, 2800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000235, 1, 3500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000236, 1, 1500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000237, 1, 1500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000238, 1, 3600, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 30000239, 1, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 20000041, 1, 850, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'Food', 0, 0, 20000042, 1, 600, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 123, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000028, 1, 210, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0, 0, '', 0),
       (1, 'Excellecnt01', 0, 0, 12220032, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Legendary03', 0, 0, 11320361, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11220362, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (0, 'Action', 0, 0, 20201033, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201034, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201035, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101001, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802005, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410013, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410014, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610007, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620007, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401006, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501006, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601007, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711007, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310007, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210007, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211007, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201043, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201044, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201045, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201046, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201047, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201048, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201049, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101003, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802007, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202006, 0, 0, 102006, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410011, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410012, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201032, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201031, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201030, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201008, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620004, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401004, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501004, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601004, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711004, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310004, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210004, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211004, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201022, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201023, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201024, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201025, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201026, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610006, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201027, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101004, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802004, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410009, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410010, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610005, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620005, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401005, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501005, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601005, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711005, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310005, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210005, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211005, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202005, 0, 0, 102005, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201028, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202004, 0, 0, 102004, 0, 0, '22202001', 1),
       (1, 'Legendary03', 0, 0, 11320361, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (0, 'Ride', 0, 0, 50620006, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501007, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101004, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802008, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (1, 'Legendary01', 0, 0, 11220353, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11220354, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11320353, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11320354, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11620353, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11620354, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11720353, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11720354, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11820353, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 11820354, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 12220353, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary01', 0, 0, 12220354, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11220387, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11220388, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11320387, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11320388, 5, 36, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11620387, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11620388, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11720387, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11720388, 5, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11820387, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 11820388, 5, 38, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 12220387, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary02', 0, 0, 12220388, 5, 56, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (1, 'Legendary03', 0, 0, 11220361, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '22204001', 1),
       (0, 'Action', 0, 0, 20201055, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201054, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201053, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201052, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601006, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711006, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310006, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210006, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211006, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201036, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201037, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201038, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201039, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201040, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201041, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201042, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 21101002, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401007, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'ETC', 0, 0, 20802006, 2, 2, 1, 0, 0, 0, 0, 0, 0, 0, 22202007, 0, 0, 102007, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410016, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50610008, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 50620008, 4, 40, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70401008, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70501008, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70601008, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70711008, 3, 10, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70310008, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Badge', 0, 0, 70210008, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20211008, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201050, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201013, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Action', 0, 0, 20201051, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (0, 'Ride', 0, 0, 40410015, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 22202008, 0, 0, 102008, 0, 0, '22202001', 1),
       (1, 'Excellecnt01', 0, 0, 12220031, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820032, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820031, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (0, 'Score', 0, 0, 35100026, 1, 40000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35100011, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35100027, 1, 100000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35100028, 2, 125000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35100029, 2, 250000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000001, 1, 6700, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000029, 1, 8200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000003, 1, 9900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000004, 1, 9900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000005, 1, 7700, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000006, 1, 5500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000007, 1, 4900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000008, 1, 9200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000009, 1, 8300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000010, 1, 8300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000011, 1, 4800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000012, 1, 5300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000013, 1, 8600, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000014, 1, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000015, 1, 6100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000016, 1, 6100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000017, 1, 9900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000018, 1, 8900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000019, 1, 6800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000020, 1, 6600, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000021, 1, 18300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000022, 1, 18300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35100001, 1, 20000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000007, 1, 250000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000006, 1, 250000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000005, 1, 250000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11400905, 1, 90, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11500809, 1, 90, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11600982, 1, 60, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11701053, 1, 60, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11301053, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11400901, 1, 90, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11500805, 1, 90, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11600976, 1, 60, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11701047, 1, 60, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'ETC', 0, 0, 70300041, 1, 30, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Pet', 0, 0, 60000015, 1, 200, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Pet', 0, 0, 60000047, 1, 200, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Ride', 0, 0, 50600183, 1, 300, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Score', 0, 0, 35000023, 1, 18300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 196, 0, 0, '', 0),
       (0, 'Ride', 0, 0, 50600220, 1, 300, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'CouponNScroll', 0, 0, 20000590, 1, 12, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'CouponNScroll', 0, 0, 20301105, 1, 10, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'PS', 0, 0, 20301106, 1, 7, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 3, 0, '', 1),
       (0, 'CouponNScroll', 0, 0, 20302776, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'CouponNScroll', 0, 0, 20302777, 1, 20, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'ETC', 0, 0, 20300078, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Skin', 0, 0, 11300428, 1, 4000000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Skin', 0, 0, 11850034, 1, 4000000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000078, 1, 70000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000002, 1, 70000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000082, 1, 100000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000083, 1, 100000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Instrument', 0, 0, 34000084, 1, 100000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20000310, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 1, 0, '', 1),
       (0, 'Skin', 0, 0, 11301058, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 20301082, 0, 0, 196, 0, 0, '', 1),
       (0, 'Score', 0, 0, 35000024, 1, 18300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000026, 1, 3700, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (1, 'Elite', 0, 0, 11620095, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620096, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720095, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720096, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220095, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220096, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120153, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120154, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11220147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11220152, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320145, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320152, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320150, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220152, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11520147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720152, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820147, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820152, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220143, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220144, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220003, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220004, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320003, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320004, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320096, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320095, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220002, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220001, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (0, 'Score', 0, 0, 35000027, 1, 3700, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000028, 1, 13300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000030, 1, 1900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000031, 1, 1900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'Score', 0, 0, 35000032, 1, 1900, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (0, 'PS', 0, 0, 11220353, 5, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22204201, 0, 0, 104201, 0, 0, '', 1),
       (1, 'Excellecnt01', 0, 0, 11220311, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220312, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320311, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320312, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620311, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620312, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720311, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (0, 'Score', 0, 0, 35000025, 1, 18300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 0, 0, '', 0),
       (1, 'Excellecnt01', 0, 0, 11720312, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820312, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220311, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220312, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220001, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220002, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320001, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320002, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620001, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620002, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720001, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720002, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820001, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820002, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820311, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201001, 0, 0, 101001, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620003, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (0, 'PVPAcc', 0, 0, 12100072, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 0, 0, '', 2),
       (0, 'PVPRide', 0, 0, 50600159, 4, 2000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 0, 0, '', 2),
       (0, 'HabiEquip', 0, 0, 11600804, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600805, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiSkin', 0, 0, 11300423, 1, 7000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiMount', 0, 0, 50600115, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiSkin', 0, 0, 11304766, 1, 12000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'CoinMount', 0, 0, 50600117, 4, 3600, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinMount', 0, 0, 50600221, 4, 3600, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20300227, 4, 15, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000547, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000548, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000549, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000550, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000552, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000516, 1, 10, 10, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000518, 1, 40, 10, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000519, 1, 75, 10, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000520, 1, 75, 10, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200865, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200866, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200867, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200868, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200869, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400251, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400252, 1, 17, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400253, 1, 17, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400254, 1, 2, 1, 0, 0, 0, 0, 0, 0, 0, 30000448, 0, 0, 154, 0, 0, '', 1),
       (0, 'CoinMount', 0, 0, 50600116, 4, 3200, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'HabiEquip', 0, 0, 11600803, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600802, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600801, 4, 6000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600810, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'Flight', 0, 0, 40400020, 3, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'SKC', 0, 0, 40100039, 1, 1000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301053, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301054, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 20301057, 1, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000022, 1, 750, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000023, 1, 2480, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000024, 1, 4280, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000028, 1, 210, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000029, 1, 980, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000030, 1, 2360, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000031, 1, 4160, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'PS', 0, 0, 20000032, 1, 5180, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'CoinMount', 0, 0, 50600222, 4, 3200, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'PS', 0, 0, 20000033, 1, 5670, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 103, 0, 0, '', 0),
       (0, 'HabiMount', 0, 0, 50600188, 4, 8000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 31000145, 4, 200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 31000146, 4, 300, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000521, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000522, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000523, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000524, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000525, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 20000597, 1, 5000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600806, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600807, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600808, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEquip', 0, 0, 11600809, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'HabiEtc', 0, 0, 40100023, 1, 3000, 4000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 152, 0, 0, '', 6),
       (0, 'PVPAcc', 0, 0, 11800085, 4, 800, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168, 0, 0, '', 2),
       (0, 'CoinEtc', 0, 0, 20300227, 4, 25, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000562, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'SKIN', 0, 0, 11500524, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'SKIN', 0, 0, 11600636, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'SKIN', 0, 0, 11700669, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'ETC', 0, 0, 20300652, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'Ride', 0, 0, 50600153, 4, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'FUN', 0, 0, 40100024, 4, 600, 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 34000063, 2, 35000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 34000064, 2, 35000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 34000065, 2, 35000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 34000066, 2, 35000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40300001, 1, 10, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40300002, 1, 10, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40300005, 1, 10, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40300006, 1, 10, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40220141, 4, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40220151, 4, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40220161, 4, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 0, 0, '', 3),
       (0, 'FUN', 0, 0, 40220131, 4, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 177, 0, 0, '', 3),
       (0, 'PS', 0, 0, 20000080, 1, 30, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'PS', 0, 0, 20000081, 1, 30, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 135, 0, 0, '', 3),
       (0, 'ShadowSkin', 0, 0, 11300252, 1, 2500, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 0, 0, '', 3),
       (0, 'ShadowSkin', 0, 0, 12200096, 1, 3000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 138, 0, 0, '', 3),
       (0, 'Mide', 0, 0, 50600021, 3, 850, 1, 2, 23200014, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, '', 3),
       (0, 'Mide', 0, 0, 50600032, 4, 1700, 1, 4, 23200014, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, '', 3),
       (0, 'Mide', 0, 0, 50600016, 3, 850, 1, 5, 23200013, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, '', 3),
       (0, 'Mide', 0, 0, 50600030, 4, 1700, 1, 8, 23200013, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, '', 3),
       (0, 'Mide', 0, 0, 50600217, 4, 50000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 142, 0, 0, '', 3),
       (0, 'SKIN', 0, 0, 11400609, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'SKIN', 0, 0, 11300713, 1, 100, 1, 0, 0, 0, 0, 0, 0, 0, 30000601, 0, 0, 177, 0, 0, '', 1),
       (0, 'LuMoneyBox', 0, 0, 20300228, 4, 4, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyMount', 0, 0, 50600035, 4, 445, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'CoinEtc', 0, 0, 20000563, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000564, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000512, 1, 100, 100, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000514, 1, 100, 100, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200870, 1, 12, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200871, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200872, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200873, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200874, 1, 17, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200875, 1, 12, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200876, 1, 17, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50200877, 1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400255, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinEtc', 0, 0, 20000561, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'CoinConstruct', 0, 0, 50400256, 1, 26, 1, 0, 0, 0, 0, 0, 0, 0, 30000447, 0, 0, 153, 0, 0, '', 1),
       (0, 'LuMoneyAromor', 0, 0, 11850105, 3, 200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000598, 1, 50, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000553, 1, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000554, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000559, 1, 8, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000567, 1, 40, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuEtc', 0, 0, 20000570, 1, 40, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneySkin', 0, 0, 11300194, 1, 190, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneySkin', 0, 0, 12200079, 1, 250, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyBadge', 0, 0, 70200032, 1, 16, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyBadge', 0, 0, 70200033, 1, 25, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyBadge', 0, 0, 70200034, 1, 16, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyBadge', 0, 0, 70200035, 1, 25, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'LuMoneyAromor', 0, 0, 12100074, 3, 200, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 151, 0, 0, '', 5),
       (0, 'Mide', 0, 0, 50600015, 1, 55000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 0, 0, '', 0),
       (1, 'Excellecnt01', 0, 0, 11620004, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720004, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720017, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720018, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820017, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820018, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220017, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220018, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320103, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320104, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620103, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620104, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720103, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720104, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11820103, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11820104, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220103, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220104, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320175, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320176, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320181, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320182, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420175, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420176, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420177, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11420178, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720175, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720176, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820175, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620018, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620017, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320018, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320017, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320167, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320168, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620167, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620168, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720167, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720168, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220167, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220168, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320169, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320170, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320172, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320173, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820169, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820176, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820170, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220368, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320367, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320368, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620367, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620368, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720367, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720368, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820367, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820368, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220367, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220368, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220017, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220018, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220367, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220102, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820181, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220307, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720108, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220107, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220108, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020193, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020194, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020201, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020202, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020197, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020198, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11220199, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11220200, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320193, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320194, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620201, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11620202, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720319, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720320, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220319, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220320, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220031, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220032, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320031, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320032, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620031, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620032, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720031, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720032, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201007, 0, 0, 101007, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720107, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620108, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620107, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320108, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220308, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220023, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220024, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320023, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320024, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620023, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620024, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720023, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720024, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820023, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820024, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220023, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220024, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820182, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201005, 0, 0, 101005, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220033, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320033, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320034, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620033, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620034, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720033, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720034, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820033, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820034, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220033, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220034, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220107, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220108, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320107, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220034, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201006, 0, 0, 101006, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720003, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220101, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720101, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720287, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720288, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820157, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820158, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820313, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820314, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220159, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220160, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220313, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220314, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220007, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220008, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320007, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320008, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620007, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620008, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720007, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720008, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820007, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820008, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220007, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220008, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220009, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220010, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320009, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320010, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620009, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720158, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720157, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320314, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320313, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820003, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820004, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220003, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220004, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11020005, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11020006, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320005, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320006, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620005, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620006, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720005, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720006, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820005, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620010, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820006, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220006, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320097, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320098, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620097, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620098, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720097, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720098, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220097, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220098, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020313, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11020314, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120159, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11120160, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220005, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201002, 0, 0, 101002, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720102, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720009, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820009, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320318, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620317, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11620318, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720317, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11720318, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820317, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11820318, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220317, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 12220318, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220013, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11220014, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320013, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11320014, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620013, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11620014, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720013, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720014, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820013, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820014, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220013, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220014, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220101, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11220102, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320101, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320102, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620101, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620102, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11320317, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220318, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Excellecnt01', 0, 0, 11220317, 4, 32, 1, 0, 0, 0, 0, 0, 0, 0, 22201004, 0, 0, 101004, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220316, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11820010, 4, 34, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220009, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 12220010, 4, 35, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120099, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11120100, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320099, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11320100, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620099, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11620100, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720099, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 11720100, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220099, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Elite', 0, 0, 12220100, 3, 24, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Excellecnt02', 0, 0, 11720010, 4, 33, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320161, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320315, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320316, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720305, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11720306, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820161, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820162, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820163, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11820164, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220157, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220158, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220301, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220302, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 12220315, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (1, 'Normal', 0, 0, 11320162, 1, 4, 1, 0, 0, 0, 0, 0, 0, 0, 22201003, 0, 0, 101003, 0, 0, '22201001', 1),
       (0, 'Mide', 0, 0, 50600005, 3, 5000000, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 0, 0, '', 0),
       (0, 'Package', 0, 0, 59200366, 4, 50, 1, 0, 0, 0, 0, 0, 0, 0, 30001203, 0, 0, 249, 0, 0, '', 1),
    

       # GM SHOP
       # crafting stuff
       (0, 'ETC', 0, 0, 40100037, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100038, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100036, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100033, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100044, 3, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100035, 3, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100034, 3, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100055, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'ETC', 0, 0, 40100056, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),

       # capsules
       (0, 'Mide', 0, 0, 22001001, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001002, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001003, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001004, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001005, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001006, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001007, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001008, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001009, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001010, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001011, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001012, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001013, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001014, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001015, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001016, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001017, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001018, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001019, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001020, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001021, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001022, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001023, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22001024, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002001, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002002, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002003, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002004, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002005, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002006, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002007, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002008, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002009, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002010, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002011, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22002012, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22004201, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'Mide', 0, 0, 22004202, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),

       # scrolls
       (0, 'DS', 0, 0, 31001501, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001502, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001503, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001504, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001505, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001507, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001508, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001509, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001510, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001511, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001512, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001513, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001514, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001515, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001516, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001517, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001530, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001531, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001532, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001533, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001534, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001535, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001536, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001537, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001538, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001539, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001540, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001541, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001974, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001975, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001982, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001983, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001984, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001985, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001989, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 31001991, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30000859, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30000860, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30000889, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30050859, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30050860, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30050889, 5, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0), 
       (0, 'DS', 0, 0, 30060859, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30060860, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DS', 0, 0, 30060889, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),

       # gm gear
       (0, 'CP', 0, 0, 11300088, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'CP', 0, 0, 11400056, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'CP', 0, 0, 11500055, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'CP', 0, 0, 11700079, 6, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'CP', 0, 0, 59400074, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),

       # money
       (0, 'DE', 0, 0, 90000006, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000017, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000013, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000014, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000022, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000023, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000024, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 90000027, 1, 1, 32000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300553, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300554, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300555, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300633, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300277, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20301029, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20301028, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20301027, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300065, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300066, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300067, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300068, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300069, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300070, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0),
       (0, 'DE', 0, 0, 20300071, 4, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 999999, 0, 0, '', 0);
