﻿namespace MapleServer2.Enums;

/// <summary>
/// Contains all values for system notices.
/// Not all names are correct or complete.
/// </summary>
public enum SystemNotice
{
    EmptyString = 0x00, // s_empty_string
    CharInputName = 0x1, // s_char_input_name
    CharLevelJob = 0x2, // s_char_level_job
    CharDeleteWaiting = 0x3, // s_char_delete_waiting
    CharAskDelete = 0x4, // s_char_ask_delete
    CharAskDeleteWithWait = 0x5, // s_char_ask_delete_with_wait
    CharAskDeleteFinal = 0x6, // s_char_ask_delete_final
    CharAskDeleteConfirmCheckbox = 0x7, // s_char_ask_delete_confirm_checkbox
    CharAskRevivalChar = 0x8, // s_char_ask_revival_char
    CharErrCharCount = 0x9, // s_char_err_char_count
    CharErrCharCountByGameEvent = 0xA, // s_char_err_char_count_by_gameevent
    CharErrName = 0xB, // s_char_err_name
    CharErrSystem = 0xC, // s_char_err_system
    CharErrInput = 0xD, // s_char_err_input
    CharErrBanAll = 0xF, // s_char_err_ban_all
    CharErrBanAny = 0xE, // s_char_err_ban_any
    CharErrAlreadyTaken = 0x10, // s_char_err_already_taken
    CharErrInvalidDefItem = 0x11, // s_char_err_invalid_def_item
    CharErrJobForbidden = 0x12, // s_char_err_job_forbidden
    CharErrCreationRestriction = 0x13, // s_char_err_creation_restriction
    CharErrUnknown = 0x14, // s_char_err_unknown
    CharErrExistUgcMap = 0x15, // s_char_err_exist_ugc_map
    CharErrAlreadyDestroy = 0x16, // s_char_err_already_destroy
    CharErrDestroy = 0x17, // s_char_err_destroy
    CharErrDeleteName = 0x18, // s_char_err_delete_name
    CharErrGuildMaster = 0x19, // s_char_err_guild_master
    CharErrGuild = 0x1A, // s_char_err_guild
    CharErrUgcMarket = 0x1B, // s_char_err_ugc_market
    CharErrBlackMarketCount = 0x1C, // s_char_err_black_market_count
    CharErrUnreadMail = 0x1D, // s_char_err_unread_mail
    CharErrNoDestroyWait = 0x1E, // s_char_err_no_destroy_wait
    CharInfoBirthday = 0x1F, // s_char_info_birthday
    CharInfoLevelJob = 0x20, // s_char_info_level_job
    CharInfoGuild = 0x21, // s_char_info_guild
    CharInfoUgcMap = 0x22, // s_char_info_ugcmap
    CharInfoHomeName = 0x23, // s_char_info_home_name
    CharInfoGuildName = 0x24, // s_char_info_guild_name
    CharInfoHomeCommend = 0x25, // s_char_info_home_commend
    CharInfoErrNotFound = 0x26, // s_char_info_err_not_found
    ChangeCharacterNameDisconnect = 0x27, // s_change_charname_disconnect
    ChangeCharacterNameConfirm = 0x28, // s_change_charname_confirm
    ChangeCharacterNameErrBadWords = 0x29, // s_change_charname_err_bad_words
    ChangeCharacterNameErrAlreadyTaken = 0x2A, // s_change_charname_err_already_taken
    ChangeCharacterNameErrConsumeItem = 0x2B, // s_change_charname_err_consume_item
    ChangeCharacterNameErrSystem = 0x2C, // s_change_charname_err_system
    ErrorGender = 0x2D, // s_err_gender
    ErrorTarget = 0x2E, // s_err_target
    ErrorJob = 0x2F, // s_err_job
    ErrorStat = 0x30, // s_err_stat
    ErrorInsufficientCoupon = 0x31, // s_err_lack_coupon
    ErrorInsufficientSuperChatThemes = 0x32, // s_err_lack_super_coupon
    ErrorInsufficientMoney = 0x33, // s_err_lack_money
    ErrorInsufficientMeso = 0x34, // s_err_lack_meso
    ErrorInsufficientMeret = 0x35, // s_err_lack_merat
    ErrorInsufficientMeretBlue = 0x36, // s_err_lack_merat_blue
    ErrorInsufficientMeretRed = 0x37, // s_err_lack_merat_red
    ErrorInsufficientPaymentItem = 0x38, // s_err_lack_payment_item
    ErrorInsufficientHonorToken = 0x39, // s_err_lack_honor_token
    ErrorInsufficientKarmaToken = 0x3A, // s_err_lack_karma_token
    ErrorInsufficientLuToken = 0x3B, // s_err_lack_lu_token
    ErrorInsufficientHaviToken = 0x3C, // s_err_lack_habi_token
    ErrorInsufficientReverseCoin = 0x3D, // s_err_lack_reverse_coin
    ErrorInsufficientMentorToken = 0x3E, // s_err_lack_mentor_token
    ErrorInsufficientMenteeToken = 0x3F, // s_err_lack_mentee_token
    ErrorInsufficientStarPoint = 0x40, // s_err_lack_star_point
    ErrorInsufficientMesoMarketToken = 0x41, // s_err_lack_meso_market_token
    ErrorUnable = 0x42, // s_err_unable
    ErrInventory = 0x43, // s_err_inventory
    ErrInventoryTabFull = 0x44, // s_err_inventory_tab_full
    ErrDropItemPickFailOwnership = 0x45, // s_err_dropitem_pickfail_ownership
    ErrLackHp = 0x46, // s_err_lack_hp
    ErrLackSp = 0x47, // s_err_lack_sp
    ErrLackEp = 0x48, // s_err_lack_ep
    ErrLackShopItem = 0x49, // s_err_lack_shopitem
    ErrorItemNotFound = 0x4A, // s_err_invalid_item
    ErrInput = 0x4B, // s_err_input
    ErrorUnableToSendWhisper = 0x4C, // s_err_cannot_find_user
    ErrInputWhisperTarget = 0x4D, // s_err_input_whisper_target
    ErrCannotFindClub = 0x4E, // s_err_cannot_find_club
    ErrInputClub = 0x4F, // s_err_input_club
    ErrCannotMove = 0x50, // s_err_cannot_move
    ErrCannotFly = 0x51, // s_err_cannot_fly
    ErrCannotUseHere = 0x52, // s_err_cannot_use_here
    ErrCannotUseDead = 0x53, // s_err_cannot_use_dead
    ErrCannotUseCooltime = 0x54, // s_err_cannot_use_cooltime
    ErrCannotUseOnlyShadowWorld = 0x55, // s_err_cannot_use_only_shadowworld
    ErrRequireAdditionalEffect = 0x56, // s_err_require_additional_effect
    ErrGotOfControlUnablePotion = 0x57, // s_err_got_of_control_unable_potion
    ErrEmptyTabName = 0x84, // s_err_empty_tabname
    ErrDuplicateTabName = 0x85, // s_err_duplicate_tabname
    ErrLackItemCount = 0x86, // s_err_lack_itemcount
    ErrNullProduct = 0x87, // s_err_null_product
    ErrSkillUseDisable = 0x58, // s_err_skill_use_disable
    ErrSkillUseDisableByRequireCond = 0x59, // s_err_skill_use_disable_by_require_cond
    ErrLackGuildTrophy = 0x5A, // s_err_lack_guild_trophy
    ErrLackAchieve = 0x5B, // s_err_lack_achieve
    ErrLackChampionshipGrade = 0x5C, // s_err_lack_championship_grade
    ErrLackChampionshipJoinCount = 0x5D, // s_err_lack_championship_join_count
    ErrCannotUseByFunctionCubeClimb = 0x5E, // s_err_cannot_use_by_function_cube_climb
    ErrCannotUseByFunctionCubeJump = 0x5F, // s_err_cannot_use_by_function_cube_jump
    ErrCannotUseByFunctionCubeSkill = 0x60, // s_err_cannot_use_by_function_cube_skill
    ErrCannotUseByFunctionCubePlay = 0x61, // s_err_cannot_use_by_function_cube_play_
    ErrCannotUseInDesignHome = 0x62, // s_err_cannot_use_in_design_home
    ErrCannotBuyLimitedItemMore = 0x63, // s_err_cannot_buy_limited_item_more
    ErrCannotInstallBlueprint = 0x64, // s_err_cannot_install_blueprint
    ErrCannotInstallMaidInPractice = 0x65, // s_err_cannot_install_maid_in_practice
    ErrCannotInstallNurturingInDesignHome = 0x66, // s_err_cannot_install_nurturing_in_design_home
    ErrCannotInstallMagicPortal = 0x67, // s_err_cannot_install_magic_portal
    ErrCannotInstallTriggerEditor = 0x68, // s_err_cannot_install_trigger_editor
    ErrCannotInstallTriggerControlObject = 0x69, // s_err_cannot_install_trigger_controlobject
    ErrCannotInstallInteriorMessage = 0x6A, // s_err_cannot_install_interior_message
    ErrCannotInstallEventCube = 0x6B, // s_err_cannot_install_event_cube
    ErrCannotInstallTrophyRelativeCube = 0x6C, // s_err_cannot_install_trophy_relative_cube
    ErrCannotInstallWorkbenchCube = 0x6D, // s_err_cannot_install_workbench_cube
    ErrCannotInstallFittingDoll = 0x6E, // s_err_cannot_install_fittingdoll
    ErrCannotInstallUgcDesignMaidInOther = 0x6F, // s_err_cannot_install_ugcdesign_maidin_other
    ErrCannotDestroyPetItemSummon = 0x70, // s_err_cannot_destroy_petitem_summon
    ErrCannotDestroyPetItemHasItem = 0x71, // s_err_cannot_destroy_petitem_hasitem
    ErrCheckSurvivalWith = 0x72, // s_err_check_survival_with
    ErrCannotUseMaviewInTestsvr = 0x73, // s_err_cannot_use_maview_in_testsvr
    JobDifficulty = 0x74, // s_job_difficulty
    ErrJobNotEnoughMeso = 0x75, // s_err_job_not_enough_meso
    ErrJobNotEnoughLevel = 0x76, // s_err_job_not_enough_level
    ErrJobBadJob = 0x77, // s_err_job_bad_job
    ErrJobNoPenalty = 0x78, // s_err_job_no_penalty
    ErrJobNoHome = 0x79, // s_err_job_no_home
    ErrJobNotCompleteQuest = 0x7A, // s_err_job_not_complete_quest
    ErrJobPrivilege = 0x7B, // s_err_job_privilege
    ErrJobDayOfWeek = 0x7C, // s_err_job_dayofweek
    ErrJobDeBuff = 0x7D, // s_err_job_debuff
    ErrJobGuild = 0x7E, // s_err_job_guild
    ErrJobInventoryFull = 0x7F, // s_err_job_inventory_full
    ErrJobUnknown = 0x80, // s_err_job_unknown
    MirrorErrNotEditableCp = 0x81, // s_mirror_err_not_editable_cp
    MirrorErrNotEditableCpByTransparentBadge = 0x82, // s_mirror_err_not_editable_cp_by_transp_badge
    MirrorErrNotEquipCp = 0x83, // s_mirror_err_not_equip_cp
    ErrNearTaxiStation = 0x88, // s_err_near_taxi_station
    ErrTaxiSameField = 0x89, // s_err_taxi_same_field
    TaxiTransfer = 0x8A, // s_taxi_transfer
    CashTaxiTransfer = 0x8B, // s_cash_taxi_transfer
    EventFreeTaxiTransfer = 0x8C, // s_event_free_taxi_transfer
    ErrCashTaxiContinent = 0x8D, // s_err_cash_taxi_continent
    ErrCashTaxiCannotDeparture = 0x8E, // s_err_cash_taxi_cannot_departure
    ErrCashTaxiCannotDestination = 0x8F, // s_err_cash_taxi_cannot_destination
    ErrCashTaxiCannotNow = 0x90, // s_err_cash_taxi_cannot_now
    ErrCashTaxiCannotCraftMode = 0x91, // s_err_cash_taxi_cannot_craft_mode
    ErrCashTaxiCannotPlace = 0x92, // s_err_cash_taxi_cannot_place
    ErrCashCallMedicProhibitMap = 0x93, // s_err_cash_call_medic_prohibit_map
    ErrCashCallMedicCannotNow = 0x94, // s_err_cash_call_medic_cannot_now
    ErrCashCallMedicRevivalCount = 0x95, // s_err_cash_call_medic_revival_count
    ErrCashCallMedicCannotPlace = 0x96, // s_err_cash_call_medic_cannot_place
    CashCallMedicComplete = 0x97, // s_cash_call_medic_complete
    ErrCashCallMarketProhibitMap = 0x98, // s_err_cash_call_market_prohibit_map
    ErrCashCallMarketCannotNow = 0x99, // s_err_cash_call_market_cannot_now
    ErrCashCallMarketCannotPlace = 0x9A, // s_err_cash_call_market_cannot_place
    ErrCashCallMarketCannotAlready = 0x9B, // s_err_cash_call_market_cannot_already
    ErrCashCallBankCannotNow = 0x9C, // s_err_cash_call_bank_cannot_now
    ErrCashCallBankCannotNowAlready = 0x9D, // s_err_cash_call_bank_cannot_now_already
    ErrCashCallBankCannotNowPlace = 0x9E, // s_err_cash_call_bank_cannot_now_place
    ErrCashCallCancel = 0x9F, // s_err_cash_call_cancel
    ErrTimeEventMoveField = 0xA0, // s_err_timeevent_move_field
    ErrTimeEventBattle = 0xA1, // s_err_timeevent_battle
    ErrTimeEventSameField = 0xA2, // s_err_timeevent_samefield
    ErrTimeEventSameContinent = 0xA3, // s_err_timeevent_same_continent
    ErrItemLinkCannotOtherUser = 0xA4, // s_err_itemlink_cannot_other_user
    WorldMapTimeEventMove = 0xA7, // s_worldmap_timeevent_move
    ErrWorldMapSearchNothingField = 0xA5, // s_err_worldmap_search_nothing_field
    ErrWorldMapSearchInvisibleField = 0xA6, // s_err_worldmap_search_invisible_field
    TimeEventNoticeChat = 0xA8, // s_timeevent_notice_chat
    RevivalPenalty = 0xA9, // s_revival_panelty
    FailLogin = 0xAA, // s_fail_login
    FailConnect = 0xAB, // s_fail_connect
    FailCharCreate = 0xAC, // s_fail_char_create
    NoticeShutdown = 0xAD, // s_notice_shutdown
    NpcNormal = 0xAE, // s_npc_normal
    NpcLeader = 0xAF, // s_npc_leader
    NpcNamed = 0xB0, // s_npc_named
    NpcBoss = 0xB1, // s_npc_boss
    NpcFieldBoss = 0xB2, // s_npc_field_boss
    NpcDungeonBoss = 0xB3, // s_npc_dungeon_boss
    NpcFriendly = 0xB4, // s_npc_friendly
    ItemRequireWeapon = 0xB5, // s_item_require_weapon
    ItemEditTime = 0xB6, // s_item_edit_time
    ItemEndTime = 0xB7, // s_item_end_time
    ItemEndTimeExpired = 0xB8, // s_item_end_time_expired
    ItemEndTimeMaid = 0xB9, // s_item_end_time_maid
    ItemEndTimeMaidExpired = 0xBA, // s_item_end_time_maid_expired
    ItemEndTimePcbang = 0xBB, // s_item_end_time_pcbang
    ItemEndTimePcbangExpired = 0xBC, // s_item_end_time_pcbang_expired
    ItemEndTimeTooltip = 0xBD, // s_item_end_time_tooltip
    ItemEndTimeTooltipExpiration = 0xBE, // s_item_end_time_tooltip_expiration
    ItemEndTimeTooltipPcbang = 0xBF, // s_item_end_time_tooltip_pcbang
    ItemEndTimeTooltipMaid = 0xC0, // s_item_end_time_tooltip_maid
    ItemEndTimeWhenItemGetTooltip = 0xC1, // s_item_end_time_when_item_get_tooltip
    ItemEndTimeWhenItemGetTooltipP = 0xC2, // s_item_end_time_when_item_get_tooltip_p
    ItemEndTimeWhenItemGetTooltipM = 0xC3, // s_item_end_time_when_item_get_tooltip_m
    ItemWordD = 0xC4, // s_item_word_d
    ItemWordH = 0xC5, // s_item_word_h
    ItemWordM = 0xC6, // s_item_word_m
    ItemTypeActive = 0xC7, // s_item_type_active
    ItemTypePassive = 0xC8, // s_item_type_passive
    ItemTypeTwoHand = 0xC9, // s_item_type_twohand
    ItemTypeLeftHand = 0xCA, // s_item_type_lefthand
    ItemTypeRightHand = 0xCB, // s_item_type_righthand
    ItemErrCode = 0xCC, // s_item_err_code
    ItemErrPutOn = 0xCD, // s_item_err_puton
    ItemErrPutOff = 0xCE, // s_item_err_putoff
    ItemErrDestroyEquip = 0xCF, // s_item_err_destroy_equip
    ItemErrNoWeapon = 0xD0, // s_item_err_no_weapon
    ItemErrInvalidWeapon = 0xD1, // s_item_err_invalid_weapon
    ItemErrInvalidSlot = 0xD2, // s_item_err_Invalid_slot
    ItemErrCashSlot = 0xD3, // s_item_err_cash_slot
    ItemErrCashPutOff = 0xD4, // s_item_err_cash_putoff
    ItemErrTwoHand = 0xD5, // s_item_err_twohand
    ItemErrDrop = 0xD6, // s_item_err_drop
    ItemErrCannotDrop = 0xD7, // s_item_err_cannot_drop
    ItemErrCannotDropIfBinding = 0xD8, // s_item_err_cannot_drop_if_binding
    ItemErrBindingDestroy = 0xD9, // s_item_err_binding_destroy
    ItemErrBindingDestroyAtFittingDoll = 0xDA, // s_item_err_binding_destroy_at_fittingdo
    ItemErrBindItemInSocketStoreOut = 0xDB, // s_item_err_binditem_in_socket_store_out
    ItemErrBindingInSocketDestroy = 0xDC, // s_item_err_binding_in_socket_destroy
    ItemErrBindingInSocketDestroyAt = 0xDD, // s_item_err_binding_in_socket_destroy_at
    ItemErrCubeItemDestroy = 0xDE, // s_item_err_cubeitem_destroy
    ItemErrPutonLowLevel = 0xDF, // s_item_err_puton_low_level
    ItemErrPutonExpired = 0xE0, // s_item_err_puton_expired
    ItemErrPutonPcbang = 0xE1, // s_item_err_puton_pcbang
    ItemErrUseLowLevel = 0xE2, // s_item_err_use_low_level
    ItemInvalidFunctionItem = 0xE3, // s_item_invalid_function_item
    ItemInvalidFunctionNotUseItem = 0xE4, // s_item_invalid_function_not_use_item
    ItemInvalidDoNotHave = 0xE5, // s_item_invalid_do_not_have
    WordItemChangeNameSamename = 0xE6, // s_word_item_change_name_samename
    ItemErrPutonJob = 0xE7, // s_item_err_puton_job
    ItemErrDisableJob = 0xE8, // s_item_err_disable_job
    ItemErrPutonInvalid = 0xE9, // s_item_err_puton_invalid
    ItemErrInvalidCount = 0xEA, // s_item_err_invalid_count
    ItemErrCantSell = 0xEB, // s_item_err_cant_sell
    ItemErrTransferItemBound = 0xEC, // s_item_err_transfer_item_bound
    ItemErrRange = 0xED, // s_item_err_range
    ItemErrSkillLevel = 0xEE, // s_item_err_skill_level
    ItemErrPutonSkillSamekinds = 0xEF, // s_item_err_puton_skill_samekinds
    ItemErrInvaildStoreType = 0xF0, // s_item_err_invaild_store_type
    ItemErrStoreFull = 0xF1, // s_item_err_store_full
    ItemTooltipUgcRemoved = 0xF2, // s_item_tooltip_ugc_removed
    ItemUgcNameBlocked = 0xF3, // s_item_ugc_name_blocked
    ItemErrCantSellRidingItem = 0xF4, // s_item_err_cant_sell_riding_item
    ItemErrCantAttachToMailRidingI = 0xF5, // s_item_err_cant_attach_to_mail_riding_i
    ItemErrCantDropRidingItem = 0xF6, // s_item_err_cant_drop_riding_item
    ItemErrCantTradeRidingItem = 0xF7, // s_item_err_cant_trade_riding_item
    ItemErrDonotPreview = 0xF8, // s_item_err_donot_preview
    ItemErrDonotPreviewExpire = 0xF9, // s_item_err_donot_preview_expire
    ItemErrBinditem = 0xFA, // s_item_err_binditem
    ItemErrBinditemStoreOut = 0xFB, // s_item_err_binditem_store_out
    ItemErrPutonInvalidBinding = 0xFC, // s_item_err_puton_invalid_binding
    ItemErrUseInvalidBinding = 0xFD, // s_item_err_use_invalid_binding
    ItemErrMoveDisableitemStoreOut = 0xFE, // s_item_err_moveDisableitem_store_out
    ItemOptError = 0xFF, // s_item_opt_error
    ItemOptSaImproveAcquireExp = 0x100, // s_item_opt_sa_improve_acquire_exp
    ItemOptSaImproveAcquireExpV = 0x101, // s_item_opt_sa_improve_acquire_exp_v
    ItemOptSaImproveAcquireExpR = 0x102, // s_item_opt_sa_improve_acquire_exp_r
    ItemOptSaImproveAcquireMeso = 0x103, // s_item_opt_sa_improve_acquire_meso
    ItemOptSaImproveAcquireMesoV = 0x104, // s_item_opt_sa_improve_acquire_meso_v
    ItemOptSaImproveAcquireMesoR = 0x105, // s_item_opt_sa_improve_acquire_meso_r
    ItemOptSaImproveSpeedSwim = 0x106, // s_item_opt_sa_improve_speed_swim
    ItemOptSaImproveSpeedSwimV = 0x107, // s_item_opt_sa_improve_speed_swim_v
    ItemOptSaImproveSpeedSwimR = 0x108, // s_item_opt_sa_improve_speed_swim_r
    ItemOptSaImproveSpeedDash = 0x109, // s_item_opt_sa_improve_speed_dash
    ItemOptSaImproveSpeedDashV = 0x10A, // s_item_opt_sa_improve_speed_dash_v
    ItemOptSaImproveSpeedDashR = 0x10B, // s_item_opt_sa_improve_speed_dash_r
    ItemOptSaImproveAcquirePotion = 0x10C, // s_item_opt_sa_improve_acquire_potion
    ItemOptSaImproveAcquirePotionV = 0x10D, // s_item_opt_sa_improve_acquire_potion_v
    ItemOptSaImproveAcquirePotionR = 0x10E, // s_item_opt_sa_improve_acquire_potion_r
    ItemOptSaImproveAcquireEquipment = 0x10F, // s_item_opt_sa_improve_acquire_equipment
    ItemOptSaImproveAcquireEquipmentV = 0x110, // s_item_opt_sa_improve_acquire_equipment_v
    ItemOptSaImproveAcquireEquipmentR = 0x111, // s_item_opt_sa_improve_acquire_equipment_r
    ItemOptSaImproveDamageCritical = 0x112, // s_item_opt_sa_improve_damage_critical
    ItemOptSaImproveDamageCriticalV = 0x113, // s_item_opt_sa_improve_damage_critical_v
    ItemOptSaImproveDamageCriticalR = 0x114, // s_item_opt_sa_improve_damage_critical_r
    ItemOptSaImproveDamageNormalNpc = 0x115, // s_item_opt_sa_improve_damage_normalNpc
    ItemOptSaImproveDamageNormalNpcV = 0x116, // s_item_opt_sa_improve_damage_normalNpc_v
    ItemOptSaImproveDamageNormalNpcR = 0x117, // s_item_opt_sa_improve_damage_normalNpc_r
    ItemOptSaImproveDamageLeaderNpc = 0x118, // s_item_opt_sa_improve_damage_leaderNpc
    ItemOptSaImproveDamageLeaderNpcV = 0x119, // s_item_opt_sa_improve_damage_leaderNpc_v
    ItemOptSaImproveDamageLeaderNpcR = 0x11A, // s_item_opt_sa_improve_damage_leaderNpc_r
    ItemOptSaImproveDamageNamedNpc = 0x11B, // s_item_opt_sa_improve_damage_namedNpc
    ItemOptSaImproveDamageNamedNpcV = 0x11C, // s_item_opt_sa_improve_damage_namedNpc_v
    ItemOptSaImproveDamageNamedNpcR = 0x11D, // s_item_opt_sa_improve_damage_namedNpc_r
    ItemOptSaImproveDamageBossNpc = 0x11E, // s_item_opt_sa_improve_damage_bossNpc
    ItemOptSaImproveDamageBossNpcV = 0x11F, // s_item_opt_sa_improve_damage_bossNpc_v
    ItemOptSaImproveDamageBossNpcR = 0x120, // s_item_opt_sa_improve_damage_bossNpc_r
    ItemOptSaImproveRecoveryRegenDoheal = 0x121, // s_item_opt_sa_improve_recovery_regen_doheal
    ItemOptSaImproveRecoveryRegenDohealV = 0x122, // s_item_opt_sa_improve_recovery_regen_doheal_v
    ItemOptSaImproveRecoveryRegenDohealR = 0x123, // s_item_opt_sa_improve_recovery_regen_doheal_r
    ItemOptSaImproveRecoveryRegenReceiveheal = 0x124, // s_item_opt_sa_improve_recovery_regen_receiveheal
    ItemOptSaImproveRecoveryRegenReceivehealV = 0x125, // s_item_opt_sa_improve_recovery_regen_receiveheal_v
    ItemOptSaImproveRecoveryRegenReceivehealR = 0x126, // s_item_opt_sa_improve_recovery_regen_receiveheal_r
    ItemOptSaReduceTimeStun = 0x127, // s_item_opt_sa_reduce_time_stun
    ItemOptSaReduceTimeStunV = 0x128, // s_item_opt_sa_reduce_time_stun_v
    ItemOptSaReduceTimeStunR = 0x129, // s_item_opt_sa_reduce_time_stun_r
    ItemOptSaImproveRecoveryHpDokill = 0x12A, // s_item_opt_sa_improve_recovery_hp_dokill
    ItemOptSaImproveRecoveryHpDokillV = 0x12B, // s_item_opt_sa_improve_recovery_hp_dokill_v
    ItemOptSaImproveRecoveryHpDokillR = 0x12C, // s_item_opt_sa_improve_recovery_hp_dokill_r
    ItemOptSaImproveRecoverySpDokill = 0x12D, // s_item_opt_sa_improve_recovery_sp_dokill
    ItemOptSaImproveRecoverySpDokillV = 0x12E, // s_item_opt_sa_improve_recovery_sp_dokill_v
    ItemOptSaImproveRecoverySpDokillR = 0x12F, // s_item_opt_sa_improve_recovery_sp_dokill_r
    ItemOptSaImproveRecoveryEpDokill = 0x130, // s_item_opt_sa_improve_recovery_ep_dokill
    ItemOptSaImproveRecoveryEpDokillV = 0x131, // s_item_opt_sa_improve_recovery_ep_dokill_v
    ItemOptSaImproveRecoveryEpDokillR = 0x132, // s_item_opt_sa_improve_recovery_ep_dokill_r
    ItemOptSaReduceTimeCooldown = 0x133, // s_item_opt_sa_reduce_time_cooldown
    ItemOptSaReduceTimeCooldownV = 0x134, // s_item_opt_sa_reduce_time_cooldown_v
    ItemOptSaReduceTimeCooldownR = 0x135, // s_item_opt_sa_reduce_time_cooldown_r
    ItemOptSaStatAttackpoint = 0x136, // s_item_opt_sa_stat_attackpoint
    ItemOptSaStatAttackpointV = 0x137, // s_item_opt_sa_stat_attackpoint_v
    ItemOptSaStatAttackpointR = 0x138, // s_item_opt_sa_stat_attackpoint_r
    ItemOptSaImproveElementsIce = 0x139, // s_item_opt_sa_improve_elements_ice
    ItemOptSaImproveElementsIceV = 0x13A, // s_item_opt_sa_improve_elements_ice_v
    ItemOptSaImproveElementsIceR = 0x13B, // s_item_opt_sa_improve_elements_ice_r
    ItemOptSaImproveElementsFire = 0x13C, // s_item_opt_sa_improve_elements_fire
    ItemOptSaImproveElementsFireV = 0x13D, // s_item_opt_sa_improve_elements_fire_v
    ItemOptSaImproveElementsFireR = 0x13E, // s_item_opt_sa_improve_elements_fire_r
    ItemOptSaImproveElementsDark = 0x13F, // s_item_opt_sa_improve_elements_dark
    ItemOptSaImproveElementsDarkV = 0x140, // s_item_opt_sa_improve_elements_dark_v
    ItemOptSaImproveElementsDarkR = 0x141, // s_item_opt_sa_improve_elements_dark_r
    ItemOptSaImproveElementsLight = 0x142, // s_item_opt_sa_improve_elements_light
    ItemOptSaImproveElementsLightV = 0x143, // s_item_opt_sa_improve_elements_light_v
    ItemOptSaImproveElementsLightR = 0x144, // s_item_opt_sa_improve_elements_light_r
    ItemOptSaImproveElementsPoison = 0x145, // s_item_opt_sa_improve_elements_poison
    ItemOptSaImproveElementsPoisonV = 0x146, // s_item_opt_sa_improve_elements_poison_v
    ItemOptSaImproveElementsPoisonR = 0x147, // s_item_opt_sa_improve_elements_poison_r
    ItemOptSaImproveElementsThunder = 0x148, // s_item_opt_sa_improve_elements_thunder
    ItemOptSaImproveElementsThunderV = 0x149, // s_item_opt_sa_improve_elements_thunder_v
    ItemOptSaImproveElementsThunderR = 0x14A, // s_item_opt_sa_improve_elements_thunder_r
    ItemOptSaImproveDamageNearrange = 0x14B, // s_item_opt_sa_improve_damage_nearrange
    ItemOptSaImproveDamageNearrangeV = 0x14C, // s_item_opt_sa_improve_damage_nearrange_v
    ItemOptSaImproveDamageNearrangeR = 0x14D, // s_item_opt_sa_improve_damage_nearrange_r
    ItemOptSaImproveDamageLongrange = 0x14E, // s_item_opt_sa_improve_damage_longrange
    ItemOptSaImproveDamageLongrangeV = 0x14F, // s_item_opt_sa_improve_damage_longrange_v
    ItemOptSaImproveDamageLongrangeR = 0x150, // s_item_opt_sa_improve_damage_longrange_r
    ItemOptSaImprovePiercingPar = 0x151, // s_item_opt_sa_improve_piercing_par
    ItemOptSaImprovePiercingParR = 0x152, // s_item_opt_sa_improve_piercing_par_r
    ItemOptSaImprovePiercingParV = 0x153, // s_item_opt_sa_improve_piercing_par_v
    ItemOptSaImprovePiercingMar = 0x154, // s_item_opt_sa_improve_piercing_mar
    ItemOptSaImprovePiercingMarR = 0x155, // s_item_opt_sa_improve_piercing_mar_r
    ItemOptSaImprovePiercingMarV = 0x156, // s_item_opt_sa_improve_piercing_mar_v
    ItemOptSaReduceElementsIce = 0x157, // s_item_opt_sa_reduce_elements_ice
    ItemOptSaReduceElementsIceV = 0x158, // s_item_opt_sa_reduce_elements_ice_v
    ItemOptSaReduceElementsIceR = 0x159, // s_item_opt_sa_reduce_elements_ice_r
    ItemOptSaReduceElementsFire = 0x15A, // s_item_opt_sa_reduce_elements_fire
    ItemOptSaReduceElementsFireV = 0x15B, // s_item_opt_sa_reduce_elements_fire_v
    ItemOptSaReduceElementsFireR = 0x15C, // s_item_opt_sa_reduce_elements_fire_r
    ItemOptSaReduceElementsDark = 0x15D, // s_item_opt_sa_reduce_elements_dark
    ItemOptSaReduceElementsDarkV = 0x15E, // s_item_opt_sa_reduce_elements_dark_v
    ItemOptSaReduceElementsDarkR = 0x15F, // s_item_opt_sa_reduce_elements_dark_r
    ItemOptSaReduceElementsLight = 0x160, // s_item_opt_sa_reduce_elements_light
    ItemOptSaReduceElementsLightV = 0x161, // s_item_opt_sa_reduce_elements_light_v
    ItemOptSaReduceElementsLightR = 0x162, // s_item_opt_sa_reduce_elements_light_r
    ItemOptSaReduceElementsPoison = 0x163, // s_item_opt_sa_reduce_elements_poison
    ItemOptSaReduceElementsPoisonV = 0x164, // s_item_opt_sa_reduce_elements_poison_v
    ItemOptSaReduceElementsPoisonR = 0x165, // s_item_opt_sa_reduce_elements_poison_r
    ItemOptSaReduceElementsThunder = 0x166, // s_item_opt_sa_reduce_elements_thunder
    ItemOptSaReduceElementsThunderV = 0x167, // s_item_opt_sa_reduce_elements_thunder_v
    ItemOptSaReduceElementsThunderR = 0x168, // s_item_opt_sa_reduce_elements_thunder_r
    ItemOptSaReduceTimeCondition = 0x169, // s_item_opt_sa_reduce_time_condition
    ItemOptSaReduceTimeConditionV = 0x16A, // s_item_opt_sa_reduce_time_condition_v
    ItemOptSaReduceTimeConditionR = 0x16B, // s_item_opt_sa_reduce_time_condition_r
    ItemOptSaReduceDistanceKnockBack = 0x16C, // s_item_opt_sa_reduce_distance_knockBack
    ItemOptSaReduceDistanceKnockBackV = 0x16D, // s_item_opt_sa_reduce_distance_knockBack_v
    ItemOptSaReduceDistanceKnockBackR = 0x16E, // s_item_opt_sa_reduce_distance_knockBack_r
    ItemOptSaReduceDamageNearrange = 0x16F, // s_item_opt_sa_reduce_damage_nearrange
    ItemOptSaReduceDamageNearrangeV = 0x171, // s_item_opt_sa_reduce_damage_nearrange_v
    ItemOptSaReduceDamageNearrangeR = 0x170, // s_item_opt_sa_reduce_damage_nearrange_r
    ItemOptSaReduceDamageLongrange = 0x172, // s_item_opt_sa_reduce_damage_longrange
    ItemOptSaReduceDamageLongrangeV = 0x174, // s_item_opt_sa_reduce_damage_longrange_v
    ItemOptSaReduceDamageLongrangeR = 0x173, // s_item_opt_sa_reduce_damage_longrange_r
    ItemOptSaImproveDamageFinal = 0x175, // s_item_opt_sa_improve_damage_final
    ItemOptSaImproveDamageFinalV = 0x177, // s_item_opt_sa_improve_damage_final_v
    ItemOptSaImproveDamageFinalR = 0x176, // s_item_opt_sa_improve_damage_final_r
    ItemOptSaProbabilityStunNearrange = 0x178, // s_item_opt_sa_probability_stun_nearrange
    ItemOptSaProbabilityStunNearrangeV = 0x17A, // s_item_opt_sa_probability_stun_nearrange_v
    ItemOptSaProbabilityStunNearrangeR = 0x179, // s_item_opt_sa_probability_stun_nearrange_r
    ItemOptSaProbabilityStunLongrange = 0x17B, // s_item_opt_sa_probability_stun_longrange
    ItemOptSaProbabilityStunLongrangeV = 0x17D, // s_item_opt_sa_probability_stun_longrange_v
    ItemOptSaProbabilityStunLongrangeR = 0x17C, // s_item_opt_sa_probability_stun_longrange_r
    ItemOptSaProbabilityKnockbackNearrange = 0x17E, // s_item_opt_sa_probability_knockback_nearrange
    ItemOptSaProbabilityKnockbackNearrangeV = 0x180, // s_item_opt_sa_probability_knockback_nearrange_v
    ItemOptSaProbabilityKnockbackNearrangeR = 0x17F, // s_item_opt_sa_probability_knockback_nearrange_r
    ItemOptSaProbabilityKnockbackLongrange = 0x181, // s_item_opt_sa_probability_knockback_longrange
    ItemOptSaProbabilityKnockbackLongrangeV = 0x183, // s_item_opt_sa_probability_knockback_longrange_v
    ItemOptSaProbabilityKnockbackLongrangeR = 0x182, // s_item_opt_sa_probability_knockback_longrange_r
    ItemOptSaProbabilityCannotmoveNearrange = 0x184, // s_item_opt_sa_probability_cannotmove_nearrange
    ItemOptSaProbabilityCannotmoveNearrangeV = 0x186, // s_item_opt_sa_probability_cannotmove_nearrange_v
    ItemOptSaProbabilityCannotmoveNearrangeR = 0x185, // s_item_opt_sa_probability_cannotmove_nearrange_r
    ItemOptSaProbabilityCannotmoveLongrange = 0x187, // s_item_opt_sa_probability_cannotmove_longrange
    ItemOptSaProbabilityCannotmoveLongrangeV = 0x189, // s_item_opt_sa_probability_cannotmove_longrange_v
    ItemOptSaProbabilityCannotmoveLongrangeR = 0x188, // s_item_opt_sa_probability_cannotmove_longrange_r
    ItemOptSaProbabilitySplashdamageNearrange = 0x18A, // s_item_opt_sa_probability_splashdamage_nearrange
    ItemOptSaProbabilitySplashdamageNearrangeV = 0x18C, // s_item_opt_sa_probability_splashdamage_nearrange_v
    ItemOptSaProbabilitySplashdamageNearrangeR = 0x18B, // s_item_opt_sa_probability_splashdamage_nearrange_r
    ItemOptSaProbabilitySplashdamageLongrange = 0x18D, // s_item_opt_sa_probability_splashdamage_longrange
    ItemOptSaProbabilitySplashdamageLongrangeV = 0x18F, // s_item_opt_sa_probability_splashdamage_longrange_v
    ItemOptSaProbabilitySplashdamageLongrangeR = 0x18E, // s_item_opt_sa_probability_splashdamage_longrange_r
    ItemOptSaImproveNpckillDropitemIncrate = 0x190, // s_item_opt_sa_improve_npckill_dropitem_incrate
    ItemOptSaImproveNpckillDropitemIncrateV = 0x191, // s_item_opt_sa_improve_npckill_dropitem_incrate_v
    ItemOptSaImproveNpckillDropitemIncrateR = 0x192, // s_item_opt_sa_improve_npckill_dropitem_incrate_r
    ItemOptSaImproveAcquireQuestrewardExp = 0x193, // s_item_opt_sa_improve_acquire_questreward_exp
    ItemOptSaImproveAcquireQuestrewardExpV = 0x194, // s_item_opt_sa_improve_acquire_questreward_exp_v
    ItemOptSaImproveAcquireQuestrewardExpR = 0x195, // s_item_opt_sa_improve_acquire_questreward_exp_r
    ItemOptSaImproveAcquireQuestrewardMeso = 0x196, // s_item_opt_sa_improve_acquire_questreward_meso
    ItemOptSaImproveAcquireQuestrewardMesoV = 0x197, // s_item_opt_sa_improve_acquire_questreward_meso_v
    ItemOptSaImproveAcquireQuestrewardMesoR = 0x198, // s_item_opt_sa_improve_acquire_questreward_meso_r
    ItemOptSaImproveAcquireFishingExp = 0x199, // s_item_opt_sa_improve_acquire_fishing_exp
    ItemOptSaImproveAcquireFishingExpV = 0x19A, // s_item_opt_sa_improve_acquire_fishing_exp_v
    ItemOptSaImproveAcquireFishingExpR = 0x19B, // s_item_opt_sa_improve_acquire_fishing_exp_r
    ItemOptSaImproveAcquireArcadeExp = 0x19C, // s_item_opt_sa_improve_acquire_arcade_exp
    ItemOptSaImproveAcquireArcadeExpV = 0x19D, // s_item_opt_sa_improve_acquire_arcade_exp_v
    ItemOptSaImproveAcquireArcadeExpR = 0x19E, // s_item_opt_sa_improve_acquire_arcade_exp_r
    ItemOptSaImproveAcquirePlayinstrumentExp = 0x19F, // s_item_opt_sa_improve_acquire_playinstrument_exp
    ItemOptSaImproveAcquirePlayinstrumentExpV = 0x1A0, // s_item_opt_sa_improve_acquire_playinstrument_exp_v
    ItemOptSaImproveAcquirePlayinstrumentExpR = 0x1A1, // s_item_opt_sa_improve_acquire_playinstrument_exp_r
    ItemOptSaInvokeEffect = 0x1A2, // s_item_opt_sa_invoke_effect
    ItemOptSaInvokeSkillDecreaseCooldowntimeV = 0x1A3, // s_item_opt_sa_invoke_skill_decrease_cooldowntime_v
    ItemOptSaInvokeSkillIncreaseCooldowntimeV = 0x1A4, // s_item_opt_sa_invoke_skill_increase_cooldowntime_v
    ItemOptSaInvokeSkillDamageV = 0x1A5, // s_item_opt_sa_invoke_skill_damage_v
    ItemOptSaInvokeEffectDurationV = 0x1A6, // s_item_opt_sa_invoke_effect_duration_v
    ItemOptSaInvokeEffectConditioneffectProbabilityV = 0x1A7, // s_item_opt_sa_invoke_effect_conditioneffect_probability_v
    ItemOptSaInvokeEffectDotdamageV = 0x1A8, // s_item_opt_sa_invoke_effect_dotdamage_v
    ItemOptSaInvokeEffectHprecoveryV = 0x1A9, // s_item_opt_sa_invoke_effect_hprecovery_v
    ItemOptSaInvokeEffectHpV = 0x1AA, // s_item_opt_sa_invoke_effect_hp_v
    ItemOptSaInvokeEffectHpRgpV = 0x1AB, // s_item_opt_sa_invoke_effect_hp_rgp_v
    ItemOptSaInvokeEffectHpInvV = 0x1AC, // s_item_opt_sa_invoke_effect_hp_inv_v
    ItemOptSaInvokeEffectSpV = 0x1AD, // s_item_opt_sa_invoke_effect_sp_v
    ItemOptSaInvokeEffectSpRgpV = 0x1AE, // s_item_opt_sa_invoke_effect_sp_rgp_v
    ItemOptSaInvokeEffectSpInvV = 0x1AF, // s_item_opt_sa_invoke_effect_sp_inv_v
    ItemOptSaInvokeEffectEpV = 0x1B0, // s_item_opt_sa_invoke_effect_ep_v
    ItemOptSaInvokeEffectEpRgpV = 0x1B1, // s_item_opt_sa_invoke_effect_ep_rgp_v
    ItemOptSaInvokeEffectEpInvV = 0x1B2, // s_item_opt_sa_invoke_effect_ep_inv_v
    ItemOptSaInvokeEffectStrV = 0x1B3, // s_item_opt_sa_invoke_effect_str_v
    ItemOptSaInvokeEffectAtpV = 0x1B4, // s_item_opt_sa_invoke_effect_atp_v
    ItemOptSaInvokeEffectPapV = 0x1B5, // s_item_opt_sa_invoke_effect_pap_v
    ItemOptSaInvokeEffectDexV = 0x1B6, // s_item_opt_sa_invoke_effect_dex_v
    ItemOptSaInvokeEffectEvpV = 0x1B7, // s_item_opt_sa_invoke_effect_evp_v
    ItemOptSaInvokeEffectMapV = 0x1B8, // s_item_opt_sa_invoke_effect_map_v
    ItemOptSaInvokeEffectIntV = 0x1B9, // s_item_opt_sa_invoke_effect_int_v
    ItemOptSaInvokeEffectCapV = 0x1BA, // s_item_opt_sa_invoke_effect_cap_v
    ItemOptSaInvokeEffectParV = 0x1BB, // s_item_opt_sa_invoke_effect_par_v
    ItemOptSaInvokeEffectLukV = 0x1BC, // s_item_opt_sa_invoke_effect_luk_v
    ItemOptSaInvokeEffectCadV = 0x1BD, // s_item_opt_sa_invoke_effect_cad_v
    ItemOptSaInvokeEffectMarV = 0x1BE, // s_item_opt_sa_invoke_effect_mar_v
    ItemOptSaInvokeEffectCarV = 0x1BF, // s_item_opt_sa_invoke_effect_car_v
    ItemOptSaInvokeEffectPenV = 0x1C0, // s_item_opt_sa_invoke_effect_pen_v
    ItemOptSaInvokeEffectAspV = 0x1C1, // s_item_opt_sa_invoke_effect_asp_v
    ItemOptSaInvokeEffectNddV = 0x1C2, // s_item_opt_sa_invoke_effect_ndd_v
    ItemOptSaInvokeEffectMspV = 0x1C3, // s_item_opt_sa_invoke_effect_msp_v
    ItemOptSaInvokeEffectAbpV = 0x1C4, // s_item_opt_sa_invoke_effect_abp_v
    ItemOptSaInvokeEffectRmspV = 0x1C5, // s_item_opt_sa_invoke_effect_rmsp_v
    ItemOptSaInvokeEffectJmpV = 0x1C6, // s_item_opt_sa_invoke_effect_jmp_v
    ItemOptSaInvokeEffectWapMinV = 0x1C7, // s_item_opt_sa_invoke_effect_wap_min_v
    ItemOptSaInvokeEffectWapMaxV = 0x1C8, // s_item_opt_sa_invoke_effect_wap_max_v
    ItemOptSaInvokeEffectOffensivePhysicalDamageV = 0x1C9, // s_item_opt_sa_invoke_effect_offensive_physical_damage_v
    ItemOptSaInvokeEffectDefensivePhysicalDamageV = 0x1CA, // s_item_opt_sa_invoke_effect_defensive_physical_damage_v
    ItemOptSaInvokeEffectOffensiveMagicalDamageV = 0x1CB, // s_item_opt_sa_invoke_effect_offensive_m
    ItemOptSaInvokeEffectDefensiveMagicalDamageV = 0x1CC, // s_item_opt_sa_invoke_effect_defensive_m
    ItemOptSaInvokeEffectDefensiveNeardistanceDamageV = 0x1CD, // s_item_opt_sa_invoke_effect_defensive_neardistance_damage_v
    ItemOptSaInvokeEffectDefensiveLongdistanceDamageV = 0x1CE, // s_item_opt_sa_invoke_effect_defensive_longdistance_damage_v
    ItemOptSaInvokeEffectImproveElementsDarkV = 0x1CF, // s_item_opt_sa_invoke_effect_improve_elements_dark_v
    ItemOptSaInvokeEffectImproveElementsHolyV = 0x1D0, // s_item_opt_sa_invoke_effect_improve_elements_holy_v
    ItemOptSaInvokeEffectImproveElementsPoisonV = 0x1D1, // s_item_opt_sa_invoke_effect_improve_elements_poison_v
    ItemOptSaInvokeEffectImproveElementsThunderV = 0x1D2, // s_item_opt_sa_invoke_effect_improve_elements_thunder_v
    ItemOptSaInvokeEffectImproveElementsIceV = 0x1D3, // s_item_opt_sa_invoke_effect_improve_elements_ice_v
    ItemOptSaInvokeEffectImproveElementsFireV = 0x1D4, // s_item_opt_sa_invoke_effect_improve_elements_fire_v
    ItemOptSaInvokeEffectReduceElementsDarkV = 0x1D5, // s_item_opt_sa_invoke_effect_reduce_elements_dark_v
    ItemOptSaInvokeEffectReduceElementsHolyV = 0x1D6, // s_item_opt_sa_invoke_effect_reduce_elements_holy_v
    ItemOptSaInvokeEffectReduceElementsPoisonV = 0x1D7, // s_item_opt_sa_invoke_effect_reduce_elements_poison_v
    ItemOptSaInvokeEffectReduceElementsThunderV = 0x1D8, // s_item_opt_sa_invoke_effect_reduce_elements_thunder_v
    ItemOptSaInvokeEffectReduceElementsIceV = 0x1D9, // s_item_opt_sa_invoke_effect_reduce_elements_ice_v
    ItemOptSaInvokeEffectReduceElementsFireV = 0x1DA, // s_item_opt_sa_invoke_effect_reduce_elements_fire_v
    ItemOptSaInvokeSkillDecreaseCooldowntimeR = 0x1DB, // s_item_opt_sa_invoke_skill_decrease_cooldowntime_r
    ItemOptSaInvokeSkillIncreaseCooldowntimeR = 0x1DC, // s_item_opt_sa_invoke_skill_increase_cooldowntime_r
    ItemOptSaInvokeSkillDamageR = 0x1DD, // s_item_opt_sa_invoke_skill_damage_r
    ItemOptSaInvokeEffectDurationR = 0x1DE, // s_item_opt_sa_invoke_effect_duration_r
    ItemOptSaInvokeEffectConditioneffectProbabilityR = 0x1DF, // s_item_opt_sa_invoke_effect_conditioneffect_probability_r
    ItemOptSaInvokeEffectDotdamageR = 0x1E0, // s_item_opt_sa_invoke_effect_dotdamage_r
    ItemOptSaInvokeEffectHprecoveryR = 0x1E1, // s_item_opt_sa_invoke_effect_hprecovery_r
    ItemOptSaInvokeEffectHpR = 0x1E2, // s_item_opt_sa_invoke_effect_hp_r
    ItemOptSaInvokeEffectHpRgpR = 0x1E3, // s_item_opt_sa_invoke_effect_hp_rgp_r
    ItemOptSaInvokeEffectHpInvR = 0x1E4, // s_item_opt_sa_invoke_effect_hp_inv_r
    ItemOptSaInvokeEffectSpR = 0x1E5, // s_item_opt_sa_invoke_effect_sp_r
    ItemOptSaInvokeEffectSpRgpR = 0x1E6, // s_item_opt_sa_invoke_effect_sp_rgp_r
    ItemOptSaInvokeEffectSpInvR = 0x1E7, // s_item_opt_sa_invoke_effect_sp_inv_r
    ItemOptSaInvokeEffectEpR = 0x1E8, // s_item_opt_sa_invoke_effect_ep_r
    ItemOptSaInvokeEffectEpRgpR = 0x1E9, // s_item_opt_sa_invoke_effect_ep_rgp_r
    ItemOptSaInvokeEffectEpInvR = 0x1EA, // s_item_opt_sa_invoke_effect_ep_inv_r
    ItemOptSaInvokeEffectStrR = 0x1EB, // s_item_opt_sa_invoke_effect_str_r
    ItemOptSaInvokeEffectAtpR = 0x1EC, // s_item_opt_sa_invoke_effect_atp_r
    ItemOptSaInvokeEffectPapR = 0x1ED, // s_item_opt_sa_invoke_effect_pap_r
    ItemOptSaInvokeEffectDexR = 0x1EE, // s_item_opt_sa_invoke_effect_dex_r
    ItemOptSaInvokeEffectEvpR = 0x1EF, // s_item_opt_sa_invoke_effect_evp_r
    ItemOptSaInvokeEffectMapR = 0x1F0, // s_item_opt_sa_invoke_effect_map_r
    ItemOptSaInvokeEffectIntR = 0x1F1, // s_item_opt_sa_invoke_effect_int_r
    ItemOptSaInvokeEffectCapR = 0x1F2, // s_item_opt_sa_invoke_effect_cap_r
    ItemOptSaInvokeEffectParR = 0x1F3, // s_item_opt_sa_invoke_effect_par_r
    ItemOptSaInvokeEffectLukR = 0x1F4, // s_item_opt_sa_invoke_effect_luk_r
    ItemOptSaInvokeEffectCadR = 0x1F5, // s_item_opt_sa_invoke_effect_cad_r
    ItemOptSaInvokeEffectMarR = 0x1F6, // s_item_opt_sa_invoke_effect_mar_r
    ItemOptSaInvokeEffectCarR = 0x1F7, // s_item_opt_sa_invoke_effect_car_r
    ItemOptSaInvokeEffectPenR = 0x1F8, // s_item_opt_sa_invoke_effect_pen_r
    ItemOptSaInvokeEffectAspR = 0x1F9, // s_item_opt_sa_invoke_effect_asp_r
    ItemOptSaInvokeEffectNddR = 0x1FA, // s_item_opt_sa_invoke_effect_ndd_r
    ItemOptSaInvokeEffectMspR = 0x1FB, // s_item_opt_sa_invoke_effect_msp_r
    ItemOptSaInvokeEffectAbpR = 0x1FC, // s_item_opt_sa_invoke_effect_abp_r
    ItemOptSaInvokeEffectRmspR = 0x1FD, // s_item_opt_sa_invoke_effect_rmsp_r
    ItemOptSaInvokeEffectJmpR = 0x1FE, // s_item_opt_sa_invoke_effect_jmp_r
    ItemOptSaInvokeEffectWapMinR = 0x1FF, // s_item_opt_sa_invoke_effect_wap_min_r
    ItemOptSaInvokeEffectWapMaxR = 0x200, // s_item_opt_sa_invoke_effect_wap_max_r
    ItemOptSaInvokeEffectOffensivePhysicalDamageR = 0x201, // s_item_opt_sa_invoke_effect_offensive_physical_damage_r
    ItemOptSaInvokeEffectDefensivePhysicalDamageR = 0x202, // s_item_opt_sa_invoke_effect_defensive_physical_damage_r
    ItemOptSaInvokeEffectOffensiveMagicalDamageR = 0x203, // s_item_opt_sa_invoke_effect_offensive_magical_damage_r
    ItemOptSaInvokeEffectDefensiveMagicalDamageR = 0x204, // s_item_opt_sa_invoke_effect_defensive_magical_damage_r
    ItemOptSaInvokeEffectDefensiveNeardistanceDamageR = 0x205, // s_item_opt_sa_invoke_effect_defensive_neardistance_damage_r
    ItemOptSaInvokeEffectDefensiveLongdistanceDamageR = 0x206, // s_item_opt_sa_invoke_effect_defensive_longdistance_damage_r
    ItemOptSaInvokeEffectImproveElementsDarkR = 0x207, // s_item_opt_sa_invoke_effect_improve_elements_dark_r
    ItemOptSaInvokeEffectImproveElementsHolyR = 0x208, // s_item_opt_sa_invoke_effect_improve_elements_holy_r
    ItemOptSaInvokeEffectImproveElementsPoisonR = 0x209, // s_item_opt_sa_invoke_effect_improve_elements_poison_r
    ItemOptSaInvokeEffectImproveElementsThunderR = 0x20A, // s_item_opt_sa_invoke_effect_improve_elements_thunder_r
    ItemOptSaInvokeEffectImproveElementsIceR = 0x20B, // s_item_opt_sa_invoke_effect_improve_elements_ice_r
    ItemOptSaInvokeEffectImproveElementsFireR = 0x20C, // s_item_opt_sa_invoke_effect_improve_elements_fire_r
    ItemOptSaInvokeEffectReduceElementsDarkR = 0x20D, // s_item_opt_sa_invoke_effect_reduce_elements_dark_r
    ItemOptSaInvokeEffectReduceElementsHolyR = 0x20E, // s_item_opt_sa_invoke_effect_reduce_elements_holy_r
    ItemOptSaInvokeEffectReduceElementsPoisonR = 0x20F, // s_item_opt_sa_invoke_effect_reduce_elements_poison_r
    ItemOptSaInvokeEffectReduceElementsThunderR = 0x210, // s_item_opt_sa_invoke_effect_reduce_elements_thunder_r
    ItemOptSaInvokeEffectReduceElementsIceR = 0x211, // s_item_opt_sa_invoke_effect_reduce_elements_ice_r
    ItemOptSaInvokeEffectReduceElementsFireR = 0x212, // s_item_opt_sa_invoke_effect_reduce_elements_fire_r
    ItemOptHasAdditionalEffect = 0x213, // s_item_opt_has_additional_effect
    ItemOptSaImproveDamagePvp = 0x214, // s_item_opt_sa_improve_damage_pvp
    ItemOptSaImproveDamagePvpR = 0x215, // s_item_opt_sa_improve_damage_pvp_r
    ItemOptSaImproveDamagePvpV = 0x216, // s_item_opt_sa_improve_damage_pvp_v
    ItemOptSaReduceDamagePvp = 0x217, // s_item_opt_sa_reduce_damage_pvp
    ItemOptSaReduceDamagePvpV = 0x218, // s_item_opt_sa_reduce_damage_pvp_v
    ItemOptSaReduceDamagePvpR = 0x219, // s_item_opt_sa_reduce_damage_pvp_r
    LoginErrConnect = 0x21A, // s_login_err_connect
    LoginErrDisconnected = 0x21B, // s_login_err_disconnected
    LoginErrId = 0x21C, // s_login_err_id
    LoginErrPwd = 0x21D, // s_login_err_pwd
    LoginErrAccess = 0x21E, // s_login_err_access
    LoginErrFullServer = 0x21F, // s_login_err_full_server
    LoginErrVersion = 0x220, // s_login_err_version
    LoginErrFullCh = 0x221, // s_login_err_full_ch
    LoginErrDb = 0x222, // s_login_err_db
    LoginErrUnknown = 0x223, // s_login_err_unknown
    LoginErrCheckPassport = 0x224, // s_login_err_check_passport
    LoginErrRestrictTitle = 0x225, // s_login_err_restrict_title
    LoginErrRestrict = 0x226, // s_login_err_restrict
    LoginErrAlphatester = 0x227, // s_login_err_alphatester
    LoginErrBlockNewAccount = 0x228, // s_login_err_block_new_account
    LoginErrGuestNopcbang = 0x229, // s_login_err_guest_nopcbang
    LoginErrSessionError = 0x22A, // s_login_err_session_error
    LoginErrExternalBlockNsn = 0x22B, // s_login_err_external_block_nsn
    LoginErrExternalBlockIp = 0x22C, // s_login_err_external_block_ip
    LoginErrAdminIp = 0x22D, // s_login_err_admin_ip
    LoginErrMainAtl = 0x22E, // s_login_err_main_atl
    LoginErrAutoExternalBlock = 0x22F, // s_login_err_auto_external_block
    LoginErrTencentSignature = 0x230, // s_login_err_tencent_signature
    AhErrClose = 0x231, // s_ah_err_close
    NgsErrLoginError = 0x232, // s_ngs_err_login_error
    RelocateWorldErr = 0x233, // s_relocate_world_err
    MailSend = 0x234, // s_mail_send
    MailReturn = 0x235, // s_mail_return
    MailDelete = 0x236, // s_mail_delete
    NotifyMailRecieve = 0x237, // s_notify_mail_recieve
    MailErrCannotAttachItem = 0x238, // s_mail_err_cannot_attach_item
    MailReadList = 0x239, // s_mail_read_list
    MailDeleteList = 0x23A, // s_mail_delete_list
    MailReceiveList = 0x23B, // s_mail_receive_list
    MailDeleteListReceivedMail = 0x23C, // s_mail_delete_list_received_mail
    MailDeleteListAttachedMail = 0x23D, // s_mail_delete_list_attached_mail
    MailDeleteListAttachedMailCheckb = 0x23E, // s_mail_delete_list_attached_mail_checkb
    MailSendDate = 0x23F, // s_mail_send_date
    MailAttachItem = 0x240, // s_mail_attach_item
    MailDeleteConfirm = 0x241, // s_mail_delete_confirm
    MailDeleteExistAd = 0x242, // s_mail_delete_exist_ad
    MailDeleteExistAttach = 0x243, // s_mail_delete_exist_attach
    MailSendReally = 0x244, // s_mail_send_really
    MailReadFail = 0x245, // s_mail_read_fail
    MailError = 0x246, // s_mail_error
    MailErrorAlreadyAttachMeso = 0x247, // s_mail_error_already_attach_meso
    MailErrorRange = 0x248, // s_mail_error_range
    MailErrorNotSelect = 0x249, // s_mail_error_not_select
    MailErrorUsername = 0x24A, // s_mail_error_username
    MailErrorCannotAttachItem = 0x24B, // s_mail_error_cannot_attach_item
    MailErrorAttachcount = 0x24C, // s_mail_error_attachcount
    MailErrorAlreadyReceive = 0x24D, // s_mail_error_already_receive
    MailErrorRecipientEqualSender = 0x24E, // s_mail_error_recipient_equal_sender
    MailErrorCreatemail = 0x24F, // s_mail_error_createmail
    MailErrorSendmail = 0x250, // s_mail_error_sendmail
    MailErrorEmptyCleaningUser = 0x251, // s_mail_error_empty_cleaning_user
    MailErrorEmptyCleaningSystem = 0x252, // s_mail_error_empty_cleaning_system
    MailErrorEmptyTitle = 0x253, // s_mail_error_empty_title
    MailErrorEmptyContent = 0x254, // s_mail_error_empty_content
    MailErrorAlreadyread = 0x255, // s_mail_error_alreadyread
    MailErrorReceiveitemToInven = 0x256, // s_mail_error_receiveitem_to_inven
    MailErrorReceiveExpired = 0x257, // s_mail_error_receive_expired
    MailErrorAdExpired = 0x258, // s_mail_error_ad_expired
    MailErrorBlockFromMe = 0x259, // s_mail_error_block_from_me
    MailErrorBlockFromOther = 0x25A, // s_mail_error_block_from_other
    MailErrorAdminCharacter = 0x25B, // s_mail_error_admin_character
    MailErrorFromAdminToUser = 0x25C, // s_mail_error_from_admin_to_user
    MailErrorBancheck = 0x25D, // s_mail_error_bancheck
    MailErrorAdminBlock = 0x25E, // s_mail_error_admin_block
    MailCleaningTitle = 0x25F, // s_mail_cleaning_title
    MailCleaningUsermail = 0x260, // s_mail_cleaning_usermail
    MailCleaningSystemmail = 0x261, // s_mail_cleaning_systemmail
    MailErrorLimitInput = 0x262, // s_mail_error_limit_input
    MailPeriodItemInclude = 0x263, // s_mail_period_item_include
    MailPeriodItemIncludeChat = 0x264, // s_mail_period_item_include_chat
    InventoryTabEquip = 0x265, // s_inventory_tab_equip
    InventoryTabLife = 0x266, // s_inventory_tab_life
    InventoryTabEtc = 0x267, // s_inventory_tab_etc
    InventoryTabSummon = 0x268, // s_inventory_tab_summon
    InventoryTabPetequip = 0x269, // s_inventory_tab_petequip
    InventoryTabSkin = 0x26A, // s_inventory_tab_skin
    InventoryTabGem = 0x26B, // s_inventory_tab_gem
    InventoryTabQuest = 0x26C, // s_inventory_tab_quest
    InventoryTabMaterial = 0x26D, // s_inventory_tab_material
    InventoryTabMastery = 0x26E, // s_inventory_tab_mastery
    InventoryTabPet = 0x26F, // s_inventory_tab_pet
    InventoryTabActiveskill = 0x270, // s_inventory_tab_activeskill
    InventoryTabCoin = 0x271, // s_inventory_tab_coin
    InventoryTabBadge = 0x272, // s_inventory_tab_badge
    InventoryTabSurvival = 0x273, // s_inventory_tab_survival
    InventoryAskExpand = 0x274, // s_inventory_ask_expand
    InventoryErrExpandMax = 0x275, // s_inventory_err_expand_max
    MoveErrNoServer = 0x276, // s_move_err_no_server
    MoveErrOverUser = 0x277, // s_move_err_over_user
    MoveErrDungeonNotExist = 0x278, // s_move_err_dungeon_not_exist
    MoveErrMemberLimit = 0x27A, // s_move_err_member_limit
    MoveErrTimeOut = 0x27B, // s_move_err_time_out
    MoveErrFieldLimit = 0x27C, // s_move_err_field_limit
    MsgDieBeginner = 0x289, // s_msg_die_beginner
    MsgDieWarringDifferentMapRevive = 0x28A, // s_msg_die_warring_different_map_revive
    MsgRevivalBtn = 0x28B, // s_msg_revival_btn
    MsgRevivalMapleworldBtn = 0x28C, // s_msg_revival_mapleworld_btn
    MsgRevivalMeratBtn = 0x28D, // s_msg_revival_merat_btn
    MsgRevivalMeratCannotDebuff = 0x28E, // s_msg_revival_merat_cannot_debuff
    MsgRevivalMeratCannotHere = 0x28F, // s_msg_revival_merat_cannot_here
    MsgRevivalMeratMsgBox = 0x290, // s_msg_revival_merat_msg_box
    MsgRevivalMeratNotDead = 0x291, // s_msg_revival_merat_not_dead
    MsgRevivalMesoBtn = 0x292, // s_msg_revival_meso_btn
    MsgRevivalMesoEventBtn = 0x293, // s_msg_revival_meso_event_btn
    MsgRevivalDungeonWarning = 0x294, // s_msg_revival_dungeon_warning
    BeautyMsgBackGameNoSave = 0x27F, // s_beauty_msg_back_game_no_save
    BeautySkinName = 0x27D, // s_beauty_skin_name
    BeautyNoticeHideCapByTranspBadg = 0x27E, // s_beauty_notice_hide_cap_by_transp_badg
    BeautyMsgErrorCode = 0x280, // s_beauty_msg_error_code
    BeautyTooltipPrice = 0x281, // s_beauty_tooltip_price
    BeautyTooltipStyle = 0x282, // s_beauty_tooltip_style
    BeautyTooltipStyleSaveDate = 0x283, // s_beauty_tooltip_style_save_date
    BeautyMsgRandom = 0x284, // s_beauty_msg_random
    BeautyMsgColoringConfirm = 0x285, // s_beauty_msg_coloring_confirm
    BeautyGotoMapInvalidDead = 0x286, // s_beauty_goto_map_invalid_dead
    BeautyGotoMapInvalidBattle = 0x287, // s_beauty_goto_map_invalid_battle
    BeautyGotoMapInvalidSamefield = 0x288, // s_beauty_goto_map_invalid_samefield
    MsgGameOver = 0x295, // s_msg_game_over
    MsgDisconnectKickuser = 0x296, // s_msg_disconnect_kickuser
    MsgItemSellRequest = 0x297, // s_msg_item_sell_request
    MsgItemSellCountRequest = 0x298, // s_msg_item_sell_count_request
    MsgRevialMeso = 0x29B, // s_msg_revial_meso
    MsgNotVisit = 0x29C, // s_msg_not_visit
    MsgNotVisitable = 0x29D, // s_msg_not_visitable
    MsgAdminInputAccountsn = 0x29E, // s_msg_admin_input_accountsn
    MsgTombstone = 0x29F, // s_msg_tombstone
    MsgMesoDrop = 0x2A0, // s_msg_meso_drop
    MsgItemDrop = 0x2A1, // s_msg_item_drop
    MsgItemBuy = 0x2A2, // s_msg_item_buy
    MsgItemSell = 0x2A3, // s_msg_item_sell
    MsgItemSellConfirm = 0x299, // s_msg_item_sell_confirm
    MsgItemBuyConfirm = 0x29A, // s_msg_item_buy_confirm
    MsgItemRepurchase = 0x2A4, // s_msg_item_repurchase
    MsgItemUpgradeLevel = 0x2A5, // s_msg_item_upgrade_level
    MsgItemUpgradeFailed = 0x2A6, // s_msg_item_upgrade_failed
    MsgItemUpgradeDisabled = 0x2A7, // s_msg_item_upgrade_disabled
    MsgItemUpgradeComplete = 0x2A8, // s_msg_item_upgrade_complete
    MsgItemDefault = 0x2A9, // s_msg_item_default
    MsgItemOpenItemBox = 0x2AA, // s_msg_item_open_item_box
    MsgItemOpenItemDontAskCheck = 0x2AB, // s_msg_item_open_item_dont_ask_check
    MsgItemOpenItemDontAskCheckBuy = 0x2AC, // s_msg_item_open_item_dont_ask_check_buy
    MsgItemUseName = 0x2AD, // s_msg_item_use_name
    MsgItemUseOnlyShadowcontinent = 0x2AE, // s_msg_item_use_only_shadowcontinent
    MsgItemRemoveExpiredItemInInven = 0x2AF, // s_msg_item_remove_expired_item_in_inven
    MsgExpandInvenComplete = 0x2B0, // s_msg_expand_inven_complete
    MsgExpandInvenAlreadyMaximum = 0x2B1, // s_msg_expand_inven_already_maximum
    MsgExpandCharacterSlotComplete = 0x2B2, // s_msg_expand_character_slot_complete
    MsgExpandCharacterSlotAlreadyMax = 0x2B3, // s_msg_expand_character_slot_already_max
    MsgExpandInvenForced = 0x2B4, // s_msg_expand_inven_forced
    MsgCurrencyOverflow = 0x2B5, // s_msg_currency_overflow
    MsgPartyInvite = 0x2C5, // s_msg_party_invite
    MsgPopupTime = 0x2C6, // s_msg_popup_time
    MsgTakeItem = 0x2C7, // s_msg_take_item
    MsgTakeItemCount = 0x2C8, // s_msg_take_item_count
    MsgTakeItemUgcCube = 0x2C9, // s_msg_take_item_ugc_cube
    MsgTakeItemCountUgcCube = 0x2CA, // s_msg_take_item_count_ugc_cube
    MsgTakeExp = 0x2CB, // s_msg_take_exp
    MsgTakeAssistBonusExp = 0x2CC, // s_msg_take_assist_bonus_exp
    MsgTakeAssistBonusExpSystem = 0x2CD, // s_msg_take_assist_bonus_exp_system
    MsgTakeMapExp = 0x2CE, // s_msg_take_map_exp
    MsgTakeTaxiExp = 0x2CF, // s_msg_take_taxi_exp
    MsgTakeTelescopeExp = 0x2D0, // s_msg_take_telescope_exp
    MsgTakeMeso = 0x2D1, // s_msg_take_meso
    MsgConsumeMeso = 0x2D2, // s_msg_consume_meso
    MsgTakePcbang = 0x2D3, // s_msg_take_pcbang
    MsgTakeMerat = 0x2D4, // s_msg_take_merat
    MsgTakeMeratBlue = 0x2D5, // s_msg_take_merat_blue
    MsgTakeMeratRed = 0x2D6, // s_msg_take_merat_red
    MsgTakeHonorToken = 0x2D7, // s_msg_take_honor_token
    MsgTakeKarmaToken = 0x2D8, // s_msg_take_karma_token
    MsgTakeLuToken = 0x2D9, // s_msg_take_lu_token
    MsgTakeHabiToken = 0x2DA, // s_msg_take_habi_token
    MsgTakeStarPoint = 0x2DB, // s_msg_take_star_point
    MsgTakeMesoMarketToken = 0x2DC, // s_msg_take_meso_market_token
    MsgCantSellTradeDrop = 0x2DD, // s_msg_cant_sell_trade_drop
    MsgCantSellTrade = 0x2DE, // s_msg_cant_sell_trade
    MsgCantSellDrop = 0x2DF, // s_msg_cant_sell_drop
    MsgCantSell = 0x2E0, // s_msg_cant_sell
    MsgCantTradeDrop = 0x2E1, // s_msg_cant_trade_drop
    MsgCantTrade = 0x2E2, // s_msg_cant_trade
    MsgCantDrop = 0x2E3, // s_msg_cant_drop
    MsgChattingWelcome = 0x2E4, // s_msg_chatting_welcome
    MsgChattingChangechannel = 0x2E5, // s_msg_chatting_changechannel
    MsgChattingConsumeMerat = 0x2E6, // s_msg_chatting_consume_merat
    MsgChattingConsumeMeratBlue = 0x2E7, // s_msg_chatting_consume_merat_blue
    MsgChattingConsumeMeratRed = 0x2E8, // s_msg_chatting_consume_merat_red
    MsgChattingConsumeMeratMessage = 0x2E9, // s_msg_chatting_consume_merat_message
    NotifyCurrencyOverflow = 0x309, // s_notify_currency_overflow
    ContentShutdownNotice = 0x30A, // s_content_shutdown_notice
    BannerBillboardShutdown = 0x30B, // s_banner_billboard_shutdown
    MsgWarehouseContainerOut = 0x30C, // s_msg_warehouse_container_out
    MsgWarehouseContainerLoading = 0x30D, // s_msg_warehouse_container_loading
    MsgWarehouseContainerCount = 0x30E, // s_msg_warehouse_container_count
    MsgWarehouseContainerCountEmpty = 0x30F, // s_msg_warehouse_container_count_empty
    MsgCrystalUpgradeEmpty = 0x311, // s_msg_crystal_upgrade_empty
    MsgCrystalUpgradeDisabled = 0x312, // s_msg_crystal_upgrade_disabled
    MsgCrystalUpgradeComplete = 0x313, // s_msg_crystal_upgrade_complete
    MsgMemoToday = 0x314, // s_msg_memo_today
    MsgPreparing = 0x315, // s_msg_preparing
    MsgTransferBindWhenTransform = 0x316, // s_msg_transfer_bind_when_transform
    ShopResetTimeDdhhmmss = 0x317, // s_shop_reset_time_ddhhmmss
    ShopResetTimeHhmmss = 0x318, // s_shop_reset_time_hhmmss
    ShopResetTimeMmss = 0x319, // s_shop_reset_time_mmss
    ShopResetTimeSs = 0x31A, // s_shop_reset_time_ss
    ShopRequireAchieve = 0x31B, // s_shop_require_achieve
    ShopRequireGuildTrophy = 0x31C, // s_shop_require_guild_trophy
    ShopRequireChampionshipGrade = 0x31D, // s_shop_require_championship_grade
    ShopErrItemRestricted = 0x31E, // s_shop_err_item_restricted
    MsgSkillbookLearnMessagebox = 0x2EA, // s_msg_skillbook_learn_messagebox
    MsgSkillbookLearnNotexistslot = 0x2EB, // s_msg_skillbook_learn_notexistslot
    MsgSkillbookErrorJob = 0x2EC, // s_msg_skillbook_error_job
    MsgSkillbookErrorLevel = 0x2ED, // s_msg_skillbook_error_level
    MsgSkillbookErrorMaster = 0x2EE, // s_msg_skillbook_error_master
    MsgSkillbookErrorExpired = 0x2EF, // s_msg_skillbook_error_expired
    MsgSkillbookResetAll = 0x2F0, // s_msg_skillbook_reset_all
    MasMoveConnect = 0x2F1, // s_mas_move_connect
    MsgUgcCannotEdit = 0x2F2, // s_msg_ugc_cannot_edit
    MsgUgcCannotFind = 0x2F3, // s_msg_ugc_cannot_find
    MsgUgcNotSelect = 0x2F4, // s_msg_ugc_not_select
    MsgUgcNotFilePreview = 0x2F5, // s_msg_ugc_not_file_preview
    MsgUgcNotFileNoexist = 0x2F6, // s_msg_ugc_not_file_noexist
    MsgUgcTooManyFiles = 0x2F7, // s_msg_ugc_too_many_files
    MsgUgcNotSelectReserve = 0x2F8, // s_msg_ugc_not_select_reserve
    MsgUgcErrorItemName = 0x2F9, // s_msg_ugc_error_item_name
    MsgUgcAdminBanner = 0x2FA, // s_msg_ugc_admin_banner
    MsgUgcShutdown = 0x2FB, // s_msg_ugc_shutdown
    MsgUgcCantRegisterShortcut = 0x2FC, // s_msg_ugc_cant_register_shortcut
    MsgUgcFailFileExist = 0x2FD, // s_msg_ugc_fail_file_exist
    MsgUgcFailFileSize = 0x2FE, // s_msg_ugc_fail_file_size
    MsgUgcItemUploadConfirm = 0x2FF, // s_msg_ugc_item_upload_confirm
    MsgUgcItemEditThumbnailTooltip = 0x300, // s_msg_ugc_item_edit_thumbnail_tooltip
    MsgUgcItemEditTextTitle = 0x301, // s_msg_ugc_item_edit_text_title
    MsgUgcItemEditComplete = 0x302, // s_msg_ugc_item_edit_complete
    MsgUgcExpiredItem = 0x303, // s_msg_ugc_expired_item
    MsgCantMovechannel = 0x304, // s_msg_cant_movechannel
    ChangeGenderConfirm = 0x305, // s_change_gender_confirm
    ChangeGenderErrEquipItems = 0x306, // s_change_gender_err_equip_items
    ChangeGenderResultSuccess = 0x307, // s_change_gender_result_success
    ChangeGenderResultFailed = 0x308, // s_change_gender_result_failed
    MsgSkillUpgrade = 0x310, // s_msg_skill_upgrade
    OptionFullscreen = 0x31F, // s_option_fullscreen
    OptionWindowmode = 0x320, // s_option_windowmode
    OptionWindowmodeFull = 0x321, // s_option_windowmode_full
    OptionResolution = 0x322, // s_option_resolution
    OptionResolutionWide = 0x323, // s_option_resolution_wide
    OptionPerfVeryLow = 0x324, // s_option_perf_very_low
    OptionPerfLow = 0x325, // s_option_perf_low
    OptionPerfNormal = 0x326, // s_option_perf_normal
    OptionPerfHigh = 0x327, // s_option_perf_high
    OptionPerfVeryHigh = 0x328, // s_option_perf_very_high
    OptionCategoryAction = 0x329, // s_option_category_action
    OptionCategoryMenu = 0x32A, // s_option_category_menu
    OptionCategoryEmotion = 0x32B, // s_option_category_emotion
    OptionCategoryEtc = 0x32C, // s_option_category_etc
    OptionCategoryDebug = 0x32D, // s_option_category_debug
    PartyJoinMe = 0x32E, // s_party_join_me
    PartyJoinSomeone = 0x32F, // s_party_join_someone
    PartyLeaveMe = 0x330, // s_party_leave_me
    PartyLeaveSomeone = 0x331, // s_party_leave_someone
    PartyExpelMe = 0x332, // s_party_expel_me
    PartyExpelSomeone = 0x333, // s_party_expel_someone
    PartyBreak = 0x334, // s_party_break
    PartyMemberLogin = 0x335, // s_party_member_login
    PartyMemberLogout = 0x336, // s_party_member_logout
    PartyChiefMe = 0x337, // s_party_chief_me
    PartyChiefSomeone = 0x338, // s_party_chief_someone
    PartyMemberDeadTomb = 0x339, // s_party_member_dead_tomb
    PartyMemberDeadDarkTomb = 0x33A, // s_party_member_dead_dark_tomb
    PartyErrCode = 0x33B, // s_party_err_code
    PartyErrNotExist = 0x33C, // s_party_err_not_exist
    PartyErrAlready = 0x33D, // s_party_err_already
    PartyErrAlreadyInvite = 0x33E, // s_party_err_alreadyInvite
    PartyErrNotChief = 0x33F, // s_party_err_not_chief
    PartyErrFull = 0x340, // s_party_err_full
    PartyErrMyself = 0x341, // s_party_err_myself
    PartyErrCannotInvite = 0x342, // s_party_err_cannot_invite
    PartyErrDeny = 0x343, // s_party_err_deny
    PartyErrDenyByAuto = 0x344, // s_party_err_deny_by_auto
    PartyErrDenyBySystem = 0x345, // s_party_err_deny_by_system
    PartyErrDenyByTimeout = 0x346, // s_party_err_deny_by_timeout
    PartyErrLeaveNoParty = 0x347, // s_party_err_leave_no_party
    PartyErrNoParty = 0x348, // s_party_err_no_party
    PartyErrFailEnterableResult = 0x349, // s_party_err_fail_enterable_result
    PartyErrLackLevel = 0x34A, // s_party_err_lack_level
    PartyErrLackGearScore = 0x34B, // s_party_err_lack_gear_score
    PartyErrFullLimitPlayer = 0x34C, // s_party_err_full_limit_player
    PartyErrInvalidRecruit = 0x34D, // s_party_err_invalid_recruit
    PartyErrInvalidParty = 0x34E, // s_party_err_invalid_party
    PartyErrInvalidChief = 0x34F, // s_party_err_invalid_chief
    PartyErrWrongParty = 0x350, // s_party_err_wrong_party
    PartyErrWrongRecruit = 0x351, // s_party_err_wrong_recruit
    PartyCheckChangeChief = 0x352, // s_party_check_change_chief
    PartyCheckExpelMember = 0x353, // s_party_check_expel_member
    PartyExpelBossRoom = 0x354, // s_party_expel_boss_room
    PartySomeoneGetHighItem = 0x355, // s_party_someone_get_high_item
    PartyAutoJoinConfirm = 0x356, // s_party_auto_join_confirm
    ClubCreate = 0x357, // s_club_create
    ClubCreateAsk = 0x358, // s_club_create_ask
    ClubBreak = 0x359, // s_club_break
    ClubInviteSomeone = 0x35A, // s_club_invite_someone
    ClubInviteMe = 0x35B, // s_club_invite_me
    ClubInviteCantMe = 0x35C, // s_club_invite_cant_me
    ClubInviteInvalidCharname = 0x35D, // s_club_invite_invalid_charname
    ClubJoin = 0x35E, // s_club_join
    ClubJoinReject = 0x35F, // s_club_join_reject
    ClubJoinRejectInvite = 0x360, // s_club_join_reject_invite
    ClubJoinRejectTimeout = 0x361, // s_club_join_reject_timeout
    ClubJoinRejectLogout = 0x362, // s_club_join_reject_logout
    ClubLeave = 0x363, // s_club_leave
    ClubNotifyLeave = 0x364, // s_club_notify_leave
    ClubNotifyAcceptInvite = 0x365, // s_club_notify_accept_invite
    ClubNotifyLoginMember = 0x366, // s_club_notify_login_member
    ClubNotifyLogoutMember = 0x367, // s_club_notify_logout_member
    ClubNotifyChangeMaster = 0x368, // s_club_notify_change_master
    ClubNotifyChangeMasterMe = 0x369, // s_club_notify_change_master_me
    ClubNotifyChangeBuff = 0x36A, // s_club_notify_change_buff
    ClubNotifyChangeName = 0x36B, // s_club_notify_change_name
    ClubUiOfflineTimeDay = 0x36C, // s_club_ui_offline_time_day
    ClubUiOfflineTimeHour = 0x36D, // s_club_ui_offline_time_hour
    ClubUiOfflineTimeMin = 0x36E, // s_club_ui_offline_time_min
    ClubUiOfflineTimeSec = 0x36F, // s_club_ui_offline_time_sec
    ClubUiOfflineUnknown = 0x370, // s_club_ui_offline_unknown
    ClubUiOffline = 0x371, // s_club_ui_offline
    ClubUiMemberLocation = 0x372, // s_club_ui_member_location
    ClubUiMemberDetail = 0x373, // s_club_ui_member_detail
    ClubUiInviteMember = 0x374, // s_club_ui_invite_member
    ClubUiCreate = 0x375, // s_club_ui_create
    ClubUiLeave = 0x376, // s_club_ui_leave
    ClubUiChangeMaster = 0x377, // s_club_ui_change_master
    ClubUiCreateTime = 0x378, // s_club_ui_create_time
    ClubUiSelectTargetMember = 0x379, // s_club_ui_select_target_member
    ClubUiCurrentMember = 0x37A, // s_club_ui_current_member
    ClubErrUnknown = 0x37B, // s_club_err_unknown
    ClubErrCreate = 0x37C, // s_club_err_create
    ClubErrCreateReject = 0x37D, // s_club_err_create_reject
    ClubErrNullClub = 0x37E, // s_club_err_null_club
    ClubErrCreateNoParty = 0x37F, // s_club_err_create_no_party
    ClubErrAlreadyExist = 0x380, // s_club_err_already_exist
    ClubErrWaitInviting = 0x381, // s_club_err_wait_inviting
    ClubErrBlocked = 0x382, // s_club_err_blocked
    ClubErrHasGuild = 0x383, // s_club_err_has_guild
    ClubErrInvalidGuild = 0x384, // s_club_err_invalid_guild
    ClubErrNullUser = 0x385, // s_club_err_null_user
    ClubErrNameExist = 0x386, // s_club_err_name_exist
    ClubErrNameValue = 0x387, // s_club_err_name_value
    ClubErrNullMember = 0x388, // s_club_err_null_member
    ClubErrExistMember = 0x389, // s_club_err_exist_member
    ClubErrFullMember = 0x38A, // s_club_err_full_member
    ClubErrNotJoinMember = 0x38B, // s_club_err_not_join_member
    ClubErrCannotLeaveMaster = 0x38C, // s_club_err_cannot_leave_master
    ClubErrExpelTargetMaster = 0x38D, // s_club_err_expel_target_master
    ClubErrNoMaster = 0x38E, // s_club_err_no_master
    ClubErrFailAddmember = 0x38F, // s_club_err_fail_addmember
    ClubErrNullInviteMember = 0x390, // s_club_err_null_invite_member
    ClubErrNone = 0x391, // s_club_err_none
    ClubErrBlock = 0x392, // s_club_err_block
    ClubErrFailThisField = 0x393, // s_club_err_fail_this_field
    ClubErrFullClub = 0x394, // s_club_err_full_club
    ClubErrFullClubMember = 0x395, // s_club_err_full_club_member
    ClubErrNotpartyAlllogin = 0x396, // s_club_err_notparty_alllogin
    ClubErrRemainTime = 0x397, // s_club_err_remain_time
    ClubErrSameClubName = 0x398, // s_club_err_same_club_name
    ClubErrClubnameHasBlank = 0x399, // s_club_err_clubname_has_blank
    GuildErrNoGuild = 0x39B, // s_guild_err_no_guild
    GuildCreate = 0x39C, // s_guild_create
    GuildBreak = 0x39D, // s_guild_break
    GuildInviteSomeone = 0x39E, // s_guild_invite_someone
    GuildInviteMe = 0x39F, // s_guild_invite_me
    GuildInviteCantMe = 0x3A0, // s_guild_invite_cant_me
    GuildInviteInvalidCharname = 0x3A1, // s_guild_invite_invalid_charname
    GuildJoin = 0x3A2, // s_guild_join
    GuildJoinReject = 0x3A3, // s_guild_join_reject
    GuildJoinAccecptInvite = 0x3A4, // s_guild_join_accecpt_invite
    GuildJoinRejectInvite = 0x3A5, // s_guild_join_reject_invite
    GuildJoinRejectLogout = 0x3A6, // s_guild_join_reject_logout
    GuildJoinRejectTimeout = 0x3A7, // s_guild_join_reject_timeout
    GuildLeave = 0x3A8, // s_guild_leave
    GuildLeaveMasterCant = 0x3A9, // s_guild_leave_master_cant
    GuildChangeNotify = 0x3AA, // s_guild_change_notify
    GuildChangeGradeSucess = 0x3AB, // s_guild_change_grade_sucess
    GuildGradeDefaultMaster = 0x3AC, // s_guild_grade_default_master
    GuildGradeDefaultGroup1 = 0x3AD, // s_guild_grade_default_group1
    GuildGradeDefaultGroup2 = 0x3AE, // s_guild_grade_default_group2
    GuildGradeDefaultGroup3 = 0x3AF, // s_guild_grade_default_group3
    GuildGradeDefaultGroup4 = 0x3B0, // s_guild_grade_default_group4
    GuildGradeDefaultGroup5 = 0x3B1, // s_guild_grade_default_group5
    GuildExtendCapacitySuccess = 0x3B2, // s_guild_extend_capacity_success
    GuildExtendCapacityErrCannot = 0x3B3, // s_guild_extend_capacity_err_cannot
    GuildExtendCapacityErrCurrent = 0x3B4, // s_guild_extend_capacity_err_current
    GuildSearchSamePropensity = 0x3B5, // s_guild_search_same_propensity
    GuildSearchMaxJoinRequest = 0x3B6, // s_guild_search_max_join_request
    GuildSearchLastRequest = 0x3B7, // s_guild_search_last_request
    GuildSearchNullJoinGuildRequest = 0x3B8, // s_guild_search_null_join_guild_request
    GuildNotifyLeave = 0x3B9, // s_guild_notify_leave
    GuildNotifyChangeGrade = 0x3BA, // s_guild_notify_change_grade
    GuildNotifyAcceptInvite = 0x3BB, // s_guild_notify_accept_invite
    GuildNotifyExpelMember = 0x3BC, // s_guild_notify_expel_member
    GuildNotifyExpeled = 0x3BD, // s_guild_notify_expeled
    GuildNotifyExpeledFrom = 0x3BE, // s_guild_notify_expeled_from
    GuildNotifyLoginMember = 0x3BF, // s_guild_notify_login_member
    GuildNotifyLogoutMember = 0x3C0, // s_guild_notify_logout_member
    GuildNotifyChangeMemberGrade = 0x3C1, // s_guild_notify_change_member_grade
    GuildNotifyChangeMemberGradeMe = 0x3C2, // s_guild_notify_change_member_grade_me
    GuildNotifyChangeMaster = 0x3C3, // s_guild_notify_change_master
    GuildNotifyChangeMasterMe = 0x3C4, // s_guild_notify_change_master_me
    GuildNotifyChangeNotify = 0x3C5, // s_guild_notify_change_notify
    GuildNotifyChangeMark = 0x3C6, // s_guild_notify_change_mark
    GuildNotifyChangeName = 0x3C7, // s_guild_notify_change_name
    GuildNotifyChangeCapacity = 0x3C8, // s_guild_notify_change_capacity
    GuildNotifyAchieveProgress = 0x3C9, // s_guild_notify_achieve_progress
    GuildNotifyAchieveComplete = 0x3CA, // s_guild_notify_achieve_complete
    GuildNotifyPvpGetGrade = 0x3CB, // s_guild_notify_pvp_get_grade
    GuildNotifyPvpRegist = 0x3CC, // s_guild_notify_pvp_regist
    GuildNotifyPvpUnregist = 0x3CD, // s_guild_notify_pvp_unregist
    GuildNotifyPvpResultWin = 0x3CE, // s_guild_notify_pvp_result_win
    GuildNotifyPvpResultLose = 0x3CF, // s_guild_notify_pvp_result_lose
    GuildNotifySearchJoinAccept = 0x3D0, // s_guild_notify_search_join_accept
    GuildNotifySearchJoinReject = 0x3D1, // s_guild_notify_search_join_reject
    GuildPvpMatchingCompleteSuccess = 0x3D2, // s_guild_pvp_matching_complete_success
    GuildPvpMatchingCompleteFail = 0x3D3, // s_guild_pvp_matching_complete_fail
    GuildPvpMatchingCompletePopup = 0x3D4, // s_guild_pvp_matching_complete_popup
    GuildPvpAlreadyPvpField = 0x3D5, // s_guild_pvp_already_pvp_field
    GuildPvpCanRegistWhenLogin = 0x3D6, // s_guild_pvp_can_regist_when_login
    GuildPvpCanRegistWhenPlaying = 0x3D7, // s_guild_pvp_can_regist_when_playing
    GuildPvpJoinOnlyMatched = 0x3D8, // s_guild_pvp_join_only_matched
    GuildPvpJoinNotEqualChampionship = 0x3DA, // s_guild_pvp_join_not_equal_championship
    GuildPvpDoneChooseChampionshipGu = 0x3DB, // s_guild_pvp_done_choose_championship_gu
    GuildSearchChoosePropensity = 0x3DC, // s_guild_search_choose_propensity
    GuildSearchGuildSearchNoResult = 0x3DD, // s_guild_search_guild_search_no_result
    GuildSearchJoinRejectMailSender = 0x3DE, // s_guild_search_join_reject_mail_sender
    GuildSearchJoinRejectMailTitle = 0x3DF, // s_guild_search_join_reject_mail_title
    GuildSearchJoinRejectMailContent = 0x3E0, // s_guild_search_join_reject_mail_content
    GuildSearchRequestJoinGuild = 0x3E1, // s_guild_search_request_join_guild
    GuildSearchCancelRequestJoinGuil = 0x3E2, // s_guild_search_cancel_request_join_guil
    GuildSearchAcceptRequestedMember = 0x3E3, // s_guild_search_accept_requested_member
    GuildSearchRejectRequestedMember = 0x3E4, // s_guild_search_reject_requested_member
    GuildUiOfflineTimeDay = 0x3E5, // s_guild_ui_offline_time_day
    GuildUiOfflineTimeHour = 0x3E6, // s_guild_ui_offline_time_hour
    GuildUiOfflineTimeMin = 0x3E7, // s_guild_ui_offline_time_min
    GuildUiOfflineTimeSec = 0x3E8, // s_guild_ui_offline_time_sec
    GuildUiOfflineUnknown = 0x3E9, // s_guild_ui_offline_unknown
    GuildUiOffline = 0x3EA, // s_guild_ui_offline
    GuildUiMemberLocation = 0x3EB, // s_guild_ui_member_location
    GuildUiMemberDetail = 0x3EC, // s_guild_ui_member_detail
    GuildUiInviteMember = 0x3ED, // s_guild_ui_invite_member
    GuildUiCreate = 0x3EE, // s_guild_ui_create
    GuildUiChangeNotify = 0x3EF, // s_guild_ui_change_notify
    GuildUiExtendMember = 0x3F0, // s_guild_ui_extend_member
    GuildUiExtendMax = 0x3F1, // s_guild_ui_extend_max
    GuildUiBreak = 0x3F2, // s_guild_ui_break
    GuildUiLeave = 0x3F3, // s_guild_ui_leave
    GuildUiNotToMaster = 0x3F4, // s_guild_ui_not_to_master
    GuildUiChangeMaster = 0x3F5, // s_guild_ui_change_master
    GuildUiExpel = 0x3F6, // s_guild_ui_expel
    GuildUiGuildCreateTime = 0x3F7, // s_guild_ui_guild_create_time
    GuildUiMustInputGroupName = 0x3F8, // s_guild_ui_must_input_group_name
    GuildUiAlreadyMemberHaveGroup = 0x3F9, // s_guild_ui_already_member_have_group
    GuildUiSelectTargetMember = 0x3FA, // s_guild_ui_select_target_member
    GuildUiCurrentMember = 0x3FB, // s_guild_ui_current_member
    GuildUiChampionshipHistoryScoreN = 0x3FC, // s_guild_ui_championship_history_score_n
    GuildUiChampionshipHistoryNoFightWin = 0x3FD, // s_guild_ui_championship_history_no_fight_win
    GuildUiChampionshipHistoryNoFightLose = 0x3FE, // s_guild_ui_championship_history_no_fight_lose
    GuildUiChampionshipCondition = 0x3FF, // s_guild_ui_championship_condition
    GuildUiChampionshipRating = 0x400, // s_guild_ui_championship_rating
    GuildUiChampionshipCombat = 0x401, // s_guild_ui_championship_combat
    GuildUiChampionshipRank = 0x402, // s_guild_ui_championship_rank
    GuildUiChampionshipGradeTooltip = 0x403, // s_guild_ui_championship_grade_tooltip
    GuildUiChampionshipReallyUnregist = 0x404, // s_guild_ui_championship_really_unregist
    GuildUiChampionshipNoRegistAuth = 0x405, // s_guild_ui_championship_no_regist_auth
    GuildUiChampionshipNoPeriodDay = 0x406, // s_guild_ui_championship_no_period_day
    GuildUiChampionshipNoPeriodTime = 0x407, // s_guild_ui_championship_no_period_time
    GuildUiChampionshipMyParticipate = 0x408, // s_guild_ui_championship_my_participate
    GuildUiChampionshipMemberParticip = 0x409, // s_guild_ui_championship_member_particip
    GuildUiChampionshipMemberGradeSc = 0x40A, // s_guild_ui_championship_member_grade_sc
    GuildUiChampionshipRewardPlayer = 0x40B, // s_guild_ui_championship_reward_player
    GuildUiChampionshipRewardSupporte = 0x40C, // s_guild_ui_championship_reward_supporte
    GuildUiChampionshipChooseChampion = 0x40D, // s_guild_ui_championship_choose_champion
    GuildUiChampionshipInfoChampionsh = 0x40E, // s_guild_ui_championship_info_championsh
    GuildUiPvpDraw = 0x40F, // s_guild_ui_pvp_draw
    GuildUiPvpWin = 0x410, // s_guild_ui_pvp_win
    GuildUiPvpLose = 0x411, // s_guild_ui_pvp_lose
    GuildUiPvpResultWinnerRating = 0x412, // s_guild_ui_pvp_result_winner_rating
    GuildUiPvpResultLoserRatingAdd = 0x413, // s_guild_ui_pvp_result_loser_rating_add
    GuildUiPvpResultReward = 0x414, // s_guild_ui_pvp_result_reward
    GuildSearchJoinRequesterInfo = 0x415, // s_guild_search_join_requester_info
    GuildErrUnknown = 0x416, // s_guild_err_unknown
    GuildErrNullGuild = 0x417, // s_guild_err_null_guild
    GuildErrAlreadyExist = 0x418, // s_guild_err_already_exist
    GuildErrWaitInviting = 0x419, // s_guild_err_wait_inviting
    GuildErrBlocked = 0x41A, // s_guild_err_blocked
    GuildErrHasGuild = 0x41B, // s_guild_err_has_guild
    GuildErrInvalidGuild = 0x41C, // s_guild_err_invalid_guild
    GuildErrNullUser = 0x41D, // s_guild_err_null_user
    GuildErrNameExist = 0x41E, // s_guild_err_name_exist
    GuildErrNameValue = 0x41F, // s_guild_err_name_value
    GuildErrNullMember = 0x420, // s_guild_err_null_member
    GuildErrExistMember = 0x421, // s_guild_err_exist_member
    GuildErrFullMember = 0x422, // s_guild_err_full_member
    GuildErrNotJoinMember = 0x423, // s_guild_err_not_join_member
    GuildErrCannotLeaveMaster = 0x424, // s_guild_err_cannot_leave_master
    GuildErrExpelTargetMaster = 0x425, // s_guild_err_expel_target_master
    GuildErrNotEnoughLevel = 0x426, // s_guild_err_not_enough_level
    GuildErrNoMoney = 0x427, // s_guild_err_no_money
    GuildErrNoAuthority = 0x428, // s_guild_err_no_authority
    GuildErrNoMaster = 0x429, // s_guild_err_no_master
    GuildErrInvalidGradeRange = 0x42A, // s_guild_err_invalid_grade_range
    GuildErrInvalidCapacityRange = 0x42B, // s_guild_err_invalid_capacity_range
    GuildErrInvalidGradeData = 0x42C, // s_guild_err_invalid_grade_data
    GuildErrInvalidGradeIndex = 0x42D, // s_guild_err_invalid_grade_index
    GuildErrExistEmptyGradeIndex = 0x42E, // s_guild_err_exist_empty_grade_index
    GuildErrSetGradeFailed = 0x42F, // s_guild_err_set_grade_failed
    GuildErrFailAddmember = 0x430, // s_guild_err_fail_addmember
    GuildErrNullInviteMember = 0x431, // s_guild_err_null_invite_member
    GuildErrCantDuringPvp = 0x432, // s_guild_err_cant_during_pvp
    GuildErrNone = 0x433, // s_guild_err_none
    GuildErrBlock = 0x434, // s_guild_err_block
    GuildErrFailChangeGradename = 0x435, // s_guild_err_fail_change_gradename
    GuildErrFailChangeGradenameRow = 0x436, // s_guild_err_fail_change_gradename_row
    GuildErrFailThisField = 0x437, // s_guild_err_fail_this_field
    IndividualWaitingUnknown = 0x438, // s_individual_waiting_unknown
    IndividualWaitingMin = 0x439, // s_individual_waiting_min
    IndividualWaitingHour = 0x43A, // s_individual_waiting_hour
    IndividualRegisterOtherArena = 0x43B, // s_individual_register_other_arena
    IndividualRegisterCallOfArena = 0x43C, // s_individual_register_call_of_arena
    IndividualRegisterLowLevel = 0x43D, // s_individual_register_low_level
    IndividualRegisterDone = 0x43E, // s_individual_register_done
    IndividualUnregisterDone = 0x43F, // s_individual_unregister_done
    IndividualMatchingDone = 0x440, // s_individual_matching_done
    IndividualJoinErrorDead = 0x441, // s_individual_join_error_dead
    IndividualJoinErrorField = 0x442, // s_individual_join_error_field
    WhisperErrMyself = 0x443, // s_whisper_err_myself
    WhisperErrTarget = 0x444, // s_whisper_err_target
    AdminBlockVelmaNotice = 0x445, // s_admin_block_velma_notice
    AdminBlockVelmaNoticeChat = 0x446, // s_admin_block_velma_notice_chat
    AdminBlockVelmaAdd = 0x447, // s_admin_block_velma_add
    AdminBlockVelmaEndtimeDec = 0x448, // s_admin_block_velma_endtime_dec
    AdminBlockVelmaMsgboxTitle = 0x449, // s_admin_block_velma_msgbox_title
    AdminBlockVelmaMsgboxContent = 0x44A, // s_admin_block_velma_msgbox_content
    AdminBlockVelmaUgcNotice = 0x44B, // s_admin_block_velma_ugc_notice
    AdminBlockVelmaUgcAdd = 0x44C, // s_admin_block_velma_ugc_add
    AdminBlockVelmaUgcEndtimeDec = 0x44D, // s_admin_block_velma_ugc_endtime_dec
    AdminBlockVelmaUgcMsgboxTitle = 0x44E, // s_admin_block_velma_ugc_msgbox_title
    AdminBlockVelmaUgcMsgboxContent = 0x44F, // s_admin_block_velma_ugc_msgbox_content
    AdminBlockTransferMsgboxTitle = 0x450, // s_admin_block_transfer_msgbox_title
    AdminBlockTransferMsgboxContent = 0x451, // s_admin_block_transfer_msgbox_content
    AdminBlockTransferMsgboxTitleKr = 0x452, // s_admin_block_transfer_msgbox_title_kr
    AdminBlockTransferMsgboxContentK = 0x453, // s_admin_block_transfer_msgbox_content_k
    AdminBlockLogin = 0x454, // s_admin_block_login
    AdminBlockChat = 0x455, // s_admin_block_chat
    AdminBlockBannerReg = 0x456, // s_admin_block_banner_reg
    AdminBlockUgcmarketReg = 0x457, // s_admin_block_ugcmarket_reg
    AdminBlockUgcEquip = 0x458, // s_admin_block_ugc_equip
    AdminBlockUgcCreate = 0x459, // s_admin_block_ugc_create
    AdminBlockGuildCreate = 0x45A, // s_admin_block_guild_create
    AdminBlockGuildMarkChange = 0x45B, // s_admin_block_guild_mark_change
    AdminBlockProfileChange = 0x45C, // s_admin_block_profile_change
    AdminBlockCharNameChange = 0x45D, // s_admin_block_char_name_change
    AdminBlockMailSend = 0x45E, // s_admin_block_mail_send
    AdminBlockUgcMapCreate = 0x45F, // s_admin_block_ugcmap_create
    AdminBlockPartySearch = 0x460, // s_admin_block_party_search
    AdminBlockPlayScore = 0x461, // s_admin_block_play_score
    AdminBlockWriteMusic = 0x462, // s_admin_block_write_music
    AdminBlockPeriod = 0x463, // s_admin_block_period
    AdminBlockTransfer = 0x464, // s_admin_block_transfer
    AdminBlockProfit = 0x465, // s_admin_block_profit
    AdminBlockDefault = 0x466, // s_admin_block_default
    AdminBlockCreateGuildMsgboxTitle = 0x467, // s_admin_block_create_guild_msgbox_title
    AdminBlockCreateGuildMsgboxConte = 0x468, // s_admin_block_create_guild_msgbox_conte
    QuestClearTime = 0x469, // s_quest_clear_time
    QuestClearMorning = 0x46A, // s_quest_clear_morning
    QuestClearAfternoon = 0x46B, // s_quest_clear_afternoon
    QuestStandardLevel = 0x46C, // s_quest_standard_level
    SkillErrMale = 0x46D, // s_skill_err_male
    SkillErrFemale = 0x46E, // s_skill_err_female
    SkillErrLowLevel = 0x46F, // s_skill_err_low_level
    SkillErrWeapon = 0x470, // s_skill_err_weapon
    StoreAskExpand = 0x2B6, // s_store_ask_expand
    StoreAskDeposit = 0x2B7, // s_store_ask_deposit
    StoreAskWithdraw = 0x2B8, // s_store_ask_withdraw
    StoreAskIn = 0x2B9, // s_store_ask_in
    StoreAskOut = 0x2BA, // s_store_ask_out
    StoreAskClose = 0x2BB, // s_store_ask_close
    StoreAskHomebankClose = 0x2BC, // s_store_ask_homebank_close
    StoreErrCode = 0x2BD, // s_store_err_code
    StoreErrExpandMax = 0x2BE, // s_store_err_expand_max
    StoreErrDepositDisableType = 0x2BF, // s_store_err_deposit_disable_type
    StoreErrDepositInvalidMoney = 0x2C0, // s_store_err_deposit_invalid_money
    StoreErrDepositMaxMoney = 0x2C1, // s_store_err_deposit_max_money
    StoreErrWithdrawInvalidMoney = 0x2C2, // s_store_err_withdraw_invalid_money
    StoreErrWithdrawNotEnoughBalance = 0x2C3, // s_store_err_withdraw_not_enough_balance
    StoreErrDepositNotEnoughBalance = 0x2C4, // s_store_err_deposit_not_enough_balance
    TitleShop = 0x471, // s_title_shop
    TitleBuyitem = 0x472, // s_title_buyitem
    TitleSellitem = 0x473, // s_title_sellitem
    UgcErrCode = 0x474, // s_ugc_err_code
    UgcErrUrl = 0x475, // s_ugc_err_url
    UgcRegistOk = 0x476, // s_ugc_regist_ok
    UgcUploadOkItem = 0x477, // s_ugc_upload_ok_item
    UgcUploadOkItemScreenshot = 0x478, // s_ugc_upload_ok_item_screenshot
    UgcUploadOkHomeScreenshot = 0x479, // s_ugc_upload_ok_home_screenshot
    UgcUploadOkProfile = 0x47A, // s_ugc_upload_ok_profile
    UgcUploadOkBannerSch = 0x47B, // s_ugc_upload_ok_banner_sch
    UgcUploadOkBanner = 0x47C, // s_ugc_upload_ok_banner
    UgcUploadMustProfile = 0x47D, // s_ugc_upload_must_profile
    UgcCameraProfileUpload = 0x47E, // s_ugc_camera_profile_upload
    UgcSignBuy = 0x47F, // s_ugc_sign_buy
    UgcSignSell = 0x480, // s_ugc_sign_sell
    UgcErrCraftMode = 0x481, // s_ugc_err_craft_mode
    UgcConfirmDestroyBank = 0x482, // s_ugc_confirm_destroy_bank
    UgcConfirmDestroyFittingdoll = 0x483, // s_ugc_confirm_destroy_fittingdoll
    UgcConfirmDestroyFittingdollV2 = 0x484, // s_ugc_confirm_destroy_fittingdoll_v2
    UgcConfirmDestroyPassword = 0x485, // s_ugc_confirm_destroy_password
    UgcConfirmDestroyTriggerEditor = 0x486, // s_ugc_confirm_destroy_trigger_editor
    UgcConfirmDestroyFieldAffected = 0x487, // s_ugc_confirm_destroy_field_affected
    WordOk = 0x488, // s_word_ok
    WordCancel = 0x489, // s_word_cancel
    WordYes = 0x48A, // s_word_yes
    WordNo = 0x48B, // s_word_no
    WordAccept = 0x48C, // s_word_accept
    WordDeny = 0x48D, // s_word_deny
    WordComplete = 0x48E, // s_word_complete
    WordNext = 0x48F, // s_word_next
    WordBuy = 0x490, // s_word_buy
    WordSell = 0x491, // s_word_sell
    WordRelease = 0x492, // s_word_release
    WordStoreUnlock = 0x493, // s_word_store_unlock
    WordSystem = 0x494, // s_word_system
    WordEntire = 0x495, // s_word_entire
    WordFriend = 0x496, // s_word_friend
    WordParty = 0x497, // s_word_party
    WordGuild = 0x498, // s_word_guild
    WordIncrease = 0x499, // s_word_increase
    WordMan = 0x49A, // s_word_man
    WordWoman = 0x49B, // s_word_woman
    WordManOrWoman = 0x49C, // s_word_man_or_woman
    WordUsercount = 0x49D, // s_word_usercount
    WordStatIncrease = 0x49E, // s_word_stat_increase
    WordStatIncreaseNearZero = 0x49F, // s_word_stat_increase_near_zero
    WordStatMax = 0x4A0, // s_word_stat_max
    WordExp = 0x4A1, // s_word_exp
    WordStatHp = 0x4A2, // s_word_stat_hp
    WordStatSp = 0x4A3, // s_word_stat_sp
    WordStatEp = 0x4A4, // s_word_stat_ep
    WordStatMsp = 0x4A5, // s_word_stat_msp
    WordStatStr = 0x4A6, // s_word_stat_str
    WordStatDex = 0x4A7, // s_word_stat_dex
    WordStatInt = 0x4A8, // s_word_stat_int
    WordStatLuk = 0x4A9, // s_word_stat_luk
    WordStatPap = 0x4AA, // s_word_stat_pap
    WordStatMap = 0x4AB, // s_word_stat_map
    WordStatPar = 0x4AC, // s_word_stat_par
    WordStatMar = 0x4AD, // s_word_stat_mar
    WordStatAsp = 0x4AE, // s_word_stat_asp
    WordStatAtp = 0x4AF, // s_word_stat_atp
    WordStatCap = 0x4B0, // s_word_stat_cap
    WordStatCad = 0x4B1, // s_word_stat_cad
    WordStatNdd = 0x4B2, // s_word_stat_ndd
    WordStatEvp = 0x4B3, // s_word_stat_evp
    WordStatCar = 0x4B4, // s_word_stat_car
    WordStatAbp = 0x4B5, // s_word_stat_abp
    WordStatJmp = 0x4B6, // s_word_stat_jmp
    WordStatHpRgp = 0x4B7, // s_word_stat_hp_rgp
    WordStatHpInv = 0x4B8, // s_word_stat_hp_inv
    WordStatSpRgp = 0x4B9, // s_word_stat_sp_rgp
    WordStatSpInv = 0x4BA, // s_word_stat_sp_inv
    WordStatEpRgp = 0x4BB, // s_word_stat_ep_rgp
    WordStatEpInv = 0x4BC, // s_word_stat_ep_inv
    WordStatWap = 0x4BD, // s_word_stat_wap
    WordStatDmg = 0x4BE, // s_word_stat_dmg
    WordStatPen = 0x4BF, // s_word_stat_pen
    WordStatRmsp = 0x4C0, // s_word_stat_rmsp
    WordStatBap = 0x4C1, // s_word_stat_bap
    WordStatBapPet = 0x4C2, // s_word_stat_bap_pet
    WordStatHpV = 0x4C3, // s_word_stat_hp_v
    WordStatSpV = 0x4C4, // s_word_stat_sp_v
    WordStatEpV = 0x4C5, // s_word_stat_ep_v
    WordStatMspV = 0x4C6, // s_word_stat_msp_v
    WordStatStrV = 0x4C7, // s_word_stat_str_v
    WordStatDexV = 0x4C8, // s_word_stat_dex_v
    WordStatIntV = 0x4C9, // s_word_stat_int_v
    WordStatLukV = 0x4CA, // s_word_stat_luk_v
    WordStatPapV = 0x4CB, // s_word_stat_pap_v
    WordStatMapV = 0x4CC, // s_word_stat_map_v
    WordStatParV = 0x4CD, // s_word_stat_par_v
    WordStatMarV = 0x4CE, // s_word_stat_mar_v
    WordStatAspV = 0x4CF, // s_word_stat_asp_v
    WordStatAtpV = 0x4D0, // s_word_stat_atp_v
    WordStatCapV = 0x4D1, // s_word_stat_cap_v
    WordStatCadV = 0x4D2, // s_word_stat_cad_v
    WordStatNddV = 0x4D3, // s_word_stat_ndd_v
    WordStatEvpV = 0x4D4, // s_word_stat_evp_v
    WordStatCarV = 0x4D5, // s_word_stat_car_v
    WordStatAbpV = 0x4D6, // s_word_stat_abp_v
    WordStatJmpV = 0x4D7, // s_word_stat_jmp_v
    WordStatHpRgpV = 0x4D8, // s_word_stat_hp_rgp_v
    WordStatHpInvV = 0x4D9, // s_word_stat_hp_inv_v
    WordStatSpRgpV = 0x4DA, // s_word_stat_sp_rgp_v
    WordStatSpInvV = 0x4DB, // s_word_stat_sp_inv_v
    WordStatEpRgpV = 0x4DC, // s_word_stat_ep_rgp_v
    WordStatEpInvV = 0x4DD, // s_word_stat_ep_inv_v
    WordStatWapDV = 0x4DE, // s_word_stat_wap_d_v
    WordStatWapUV = 0x4DF, // s_word_stat_wap_u_v
    WordStatWapCommonV = 0x4E0, // s_word_stat_wap_common_v
    WordStatDmgV = 0x4E1, // s_word_stat_dmg_v
    WordStatPenV = 0x4E2, // s_word_stat_pen_v
    WordStatRmspV = 0x4E3, // s_word_stat_rmsp_v
    WordStatBapV = 0x4E4, // s_word_stat_bap_v
    WordStatBapPetV = 0x4E5, // s_word_stat_bap_pet_v
    WordStatHpR = 0x4E6, // s_word_stat_hp_r
    WordStatSpR = 0x4E7, // s_word_stat_sp_r
    WordStatEpR = 0x4E8, // s_word_stat_ep_r
    WordStatMspR = 0x4E9, // s_word_stat_msp_r
    WordStatStrR = 0x4EA, // s_word_stat_str_r
    WordStatDexR = 0x4EB, // s_word_stat_dex_r
    WordStatIntR = 0x4EC, // s_word_stat_int_r
    WordStatLukR = 0x4ED, // s_word_stat_luk_r
    WordStatPapR = 0x4EE, // s_word_stat_pap_r
    WordStatMapR = 0x4EF, // s_word_stat_map_r
    WordStatParR = 0x4F0, // s_word_stat_par_r
    WordStatMarR = 0x4F1, // s_word_stat_mar_r
    WordStatAspR = 0x4F2, // s_word_stat_asp_r
    WordStatAtpR = 0x4F3, // s_word_stat_atp_r
    WordStatCapR = 0x4F4, // s_word_stat_cap_r
    WordStatCadR = 0x4F5, // s_word_stat_cad_r
    WordStatNddR = 0x4F6, // s_word_stat_ndd_r
    WordStatEvpR = 0x4F7, // s_word_stat_evp_r
    WordStatCarR = 0x4F8, // s_word_stat_car_r
    WordStatAbpR = 0x4F9, // s_word_stat_abp_r
    WordStatJmpR = 0x4FA, // s_word_stat_jmp_r
    WordStatHpRgpR = 0x4FB, // s_word_stat_hp_rgp_r
    WordStatHpInvR = 0x4FC, // s_word_stat_hp_inv_r
    WordStatSpRgpR = 0x4FD, // s_word_stat_sp_rgp_r
    WordStatSpInvR = 0x4FE, // s_word_stat_sp_inv_r
    WordStatEpRgpR = 0x4FF, // s_word_stat_ep_rgp_r
    WordStatEpInvR = 0x500, // s_word_stat_ep_inv_r
    WordStatWapDR = 0x501, // s_word_stat_wap_d_r
    WordStatWapUR = 0x502, // s_word_stat_wap_u_r
    WordStatWapCommonR = 0x503, // s_word_stat_wap_common_r
    WordStatDmgR = 0x504, // s_word_stat_dmg_r
    WordStatPenR = 0x505, // s_word_stat_pen_r
    WordStatRmspR = 0x506, // s_word_stat_rmsp_r
    WordStatBapR = 0x507, // s_word_stat_bap_r
    WordStatBapPetR = 0x508, // s_word_stat_bap_pet_r
    WordStatTnap = 0x509, // s_word_stat_tnap
    WordStatTwap = 0x50A, // s_word_stat_twap
    WordStatWeaponDamage = 0x50B, // s_word_stat_weapon_damage
    WordRankNo = 0x50C, // s_word_rank_no
    WordRank01 = 0x50D, // s_word_rank_01
    WordRank02 = 0x50E, // s_word_rank_02
    WordRank03 = 0x50F, // s_word_rank_03
    WordRank04 = 0x510, // s_word_rank_04
    WordRank05 = 0x511, // s_word_rank_05
    WordRank06 = 0x512, // s_word_rank_06
    WordRankBonus = 0x513, // s_word_rank_bonus
    WordItemSk = 0x514, // s_word_item_sk
    WordItemHr = 0x515, // s_word_item_hr
    WordItemFa = 0x516, // s_word_item_fa
    WordItemFd = 0x517, // s_word_item_fd
    WordItemLh = 0x518, // s_word_item_lh
    WordItemRh = 0x519, // s_word_item_rh
    WordItemCp = 0x51A, // s_word_item_cp
    WordItemMt = 0x51B, // s_word_item_mt
    WordItemCl = 0x51C, // s_word_item_cl
    WordItemPa = 0x51D, // s_word_item_pa
    WordItemGl = 0x51E, // s_word_item_gl
    WordItemSh = 0x51F, // s_word_item_sh
    WordItemFh = 0x520, // s_word_item_fh
    WordItemEy = 0x521, // s_word_item_ey
    WordItemEa = 0x522, // s_word_item_ea
    WordItemPd = 0x523, // s_word_item_pd
    WordItemRi = 0x524, // s_word_item_ri
    WordItemBe = 0x525, // s_word_item_be
    WordItemEr = 0x526, // s_word_item_er
    WordItemOh = 0x529, // s_word_item_oh
    WordItemBu = 0x527, // s_word_item_bu
    WordItemDe = 0x528, // s_word_item_de
    WordItemLook = 0x52A, // s_word_item_look
    WordItemEquip = 0x52B, // s_word_item_equip
    WordItemCategoryClothes = 0x52C, // s_word_item_category_clothes
    WordItemCategoryConstruction = 0x52D, // s_word_item_category_construction
    WordItemUnlimitedPeriod = 0x52E, // s_word_item_unlimited_period
    WordItemSoldout = 0x52F, // s_word_item_soldout
    WordItemSoldoutHtml = 0x530, // s_word_item_soldout_html
    WordItemLimitSell = 0x531, // s_word_item_limit_sell
    WordItemLimitTrade = 0x532, // s_word_item_limit_trade
    WordItemLimitSellTrade = 0x533, // s_word_item_limit_sell_trade
    WordItemLimitBlackmarket = 0x534, // s_word_item_limit_blackmarket
    WordItemLimitBlackmarketSell = 0x535, // s_word_item_limit_blackmarket_sell
    WordItemLimitTradeCount = 0x536, // s_word_item_limit_trade_count
    WordItemLimitTradeCountWithoutSellForItemlock = 0x537, // s_word_item_limit_trade_count_without_sell_for_itemlock
    WordItemLimitTradeCountWithoutSell = 0x538, // s_word_item_limit_trade_count_without_sell
    WordItemLimitBind = 0x539, // s_word_item_limit_bind
    WordItemLimitBindFormat = 0x53A, // s_word_item_limit_bind_format
    WordItemNotuse = 0x53B, // s_word_item_notuse
    WordItemNotuseHpfull = 0x53C, // s_word_item_notuse_hpfull
    WordItemNotuseSpfull = 0x53D, // s_word_item_notuse_spfull
    WordItemNotuseEpfull = 0x53E, // s_word_item_notuse_epfull
    WordIconcodeNone = 0x53F, // s_word_iconcode_none
    WordIconcodeWeapon = 0x540, // s_word_iconcode_weapon
    WordIconcodeArmor = 0x541, // s_word_iconcode_armor
    WordIconcodeAccessory = 0x542, // s_word_iconcode_accessory
    WordIconcodeActive = 0x543, // s_word_iconcode_active
    WordIconcodePassive = 0x544, // s_word_iconcode_passive
    WordIconcodePotion = 0x545, // s_word_iconcode_potion
    WordIconcodeScroll = 0x546, // s_word_iconcode_scroll
    WordIconcodeAction = 0x547, // s_word_iconcode_action
    WordIconcodeEtc = 0x548, // s_word_iconcode_etc
    WordIconcodeLand = 0x549, // s_word_iconcode_land
    WordIconcodeBuilding = 0x54A, // s_word_iconcode_building
    WordIconcodeInterior = 0x54B, // s_word_iconcode_interior
    WordIconcodeSouvenir = 0x54C, // s_word_iconcode_souvenir
    WordIconcodePet = 0x54D, // s_word_iconcode_pet
    WordIconcodeRiding = 0x54E, // s_word_iconcode_riding
    WordIconcodeMannequin = 0x54F, // s_word_iconcode_mannequin
    WordIconcodeStore = 0x550, // s_word_iconcode_store
    WordIconcodeElectronics = 0x551, // s_word_iconcode_electronics
    WordIconcodeCoupon = 0x552, // s_word_iconcode_coupon
    WordIconcodeActionSkillbook = 0x553, // s_word_iconcode_action_skillbook
    WordIconcodeGem = 0x554, // s_word_iconcode_gem
    WordIconcodeStorybook = 0x555, // s_word_iconcode_storybook
    WordIconcodeMaid = 0x556, // s_word_iconcode_maid
    WordIconcodePackage = 0x557, // s_word_iconcode_package
    WordIconcodeRandom = 0x558, // s_word_iconcode_random
    WordIconcodeCrystal = 0x559, // s_word_iconcode_crystal
    WordIconcodeAirtaxi = 0x55A, // s_word_iconcode_airtaxi
    WordIconcodeDungeonkey = 0x55B, // s_word_iconcode_dungeonkey
    WordIconcodeWorkbenchCook = 0x55C, // s_word_iconcode_workbench_cook
    WordIconcodeWorkbenchAlchemy = 0x55D, // s_word_iconcode_workbench_alchemy
    WordIconcodeWorkbenchBiz = 0x55E, // s_word_iconcode_workbench_biz
    WordIconcodeBuffportion = 0x55F, // s_word_iconcode_buffportion
    WordIconcodeTriggerController = 0x560, // s_word_iconcode_trigger_controller
    WordIconcodeInteriorPack = 0x561, // s_word_iconcode_interior_pack
    WordIconcodeFishingRod = 0x562, // s_word_iconcode_fishing_rod
    WordIconcodeMusicNote = 0x563, // s_word_iconcode_music_note
    WordIconcodeMusicInstrument = 0x564, // s_word_iconcode_music_instrument
    WordIconcodePetfood = 0x565, // s_word_iconcode_petfood
    WordIconcodeBait = 0x566, // s_word_iconcode_bait
    WordIconcodeGemstone = 0x567, // s_word_iconcode_gemstone
    WordIconcodeJeweldust = 0x568, // s_word_iconcode_jeweldust
    WordIconcodeCoin = 0x569, // s_word_iconcode_coin
    WordIconcodeQuest = 0x56A, // s_word_iconcode_quest
    WordIconcodeGlideItem = 0x56B, // s_word_iconcode_glide_item
    WordIconcodePetequip = 0x56C, // s_word_iconcode_petequip
    WordIconcodeBlueprint = 0x56D, // s_word_iconcode_blueprint
    WordIconcodeCapsule = 0x56E, // s_word_iconcode_capsule
    WordWeekSun = 0x56F, // s_word_week_sun
    WordWeekMon = 0x570, // s_word_week_mon
    WordWeekTue = 0x571, // s_word_week_tue
    WordWeekWed = 0x572, // s_word_week_wed
    WordWeekThu = 0x573, // s_word_week_thu
    WordWeekFri = 0x574, // s_word_week_fri
    WordWeekSat = 0x575, // s_word_week_sat
    WordWeekSun2 = 0x576, // s_word_week_sun2
    WordWeekMon2 = 0x577, // s_word_week_mon2
    WordWeekTue2 = 0x578, // s_word_week_tue2
    WordWeekWed2 = 0x579, // s_word_week_wed2
    WordWeekThu2 = 0x57A, // s_word_week_thu2
    WordWeekFri2 = 0x57B, // s_word_week_fri2
    WordWeekSat2 = 0x57C, // s_word_week_sat2
    WordDateWeek = 0x57D, // s_word_date_week
    WordCustomizeLength = 0x57E, // s_word_customize_length
    WordCustomizeSize = 0x57F, // s_word_customize_size
    WordCustomizeLocation = 0x580, // s_word_customize_location
    WordCustomizeAngle = 0x581, // s_word_customize_angle
    WordCustomizeChange = 0x582, // s_word_customize_change
    WordCustomizeNoEdit = 0x583, // s_word_customize_no_edit
    WordCustomizeComma = 0x584, // s_word_customize_comma
    WordGameOver = 0x585, // s_word_game_over
    WordUnknown = 0x586, // s_word_unknown
    WordWelcome = 0x587, // s_word_welcome
    WordItemTitleNone = 0x588, // s_word_item_title_none
    WordItemTitleKill = 0x589, // s_word_item_title_kill
    WordItemTitleMaster = 0x58A, // s_word_item_title_master
    WordItemTitleCreate = 0x58B, // s_word_item_title_create
    WordItemTitleStatus = 0x58C, // s_word_item_title_status
    WordItemTitleHidden = 0x58D, // s_word_item_title_hidden
    WordItemDamage = 0x58E, // s_word_item_damage
    WordItemStatZero = 0x58F, // s_word_item_stat_zero
    WordUnuse = 0x590, // s_word_unuse
    WordScreenshot = 0x591, // s_word_screenshot
    CannotMoveToNpc = 0x592, // s_cannot_move_to_npc
    WordCh = 0x593, // s_word_ch
    WordOnline = 0x594, // s_word_online
    WordOffline = 0x595, // s_word_offline
    WordDungeon = 0x596, // s_word_dungeon
    WordNewTab = 0x597, // s_word_newTab
    WordLevel = 0x598, // s_word_level
    WordLevelMax = 0x599, // s_word_level_max
    WordLearnLevel = 0x59A, // s_word_learn_level
    WordLearnSkillbook = 0x59B, // s_word_learn_skillbook
    WordAcquireLevel = 0x59C, // s_word_acquire_level
    WordCooltime = 0x59D, // s_word_cooltime
    WordNeeds = 0x59E, // s_word_needs
    WordFitness = 0x59F, // s_word_fitness
    WordDisableJob = 0x5A0, // s_word_disable_job
    WordSellprice = 0x5A1, // s_word_sellprice
    WordSellremindFormat = 0x5A2, // s_word_sellremind_format
    WordRequireLevel = 0x5A3, // s_word_require_level
    WordEquiped = 0x5A4, // s_word_equiped
    WordSkillbook = 0x5A5, // s_word_skillbook
    WordDesigned = 0x5A6, // s_word_designed
    WordIndoorArea = 0x5A7, // s_word_indoor_area
    WordIndoorOnly = 0x5A8, // s_word_indoor_only
    WordOutdoorIndoor = 0x5AA, // s_word_outdoor_indoor
    WordOutdoorOnly = 0x5A9, // s_word_outdoor_only
    WordStackable = 0x5AB, // s_word_stackable
    WordDoNotStack = 0x5AC, // s_word_do_not_stack
    WordCash = 0x5AD, // s_word_cash
    WordSkin = 0x5AE, // s_word_skin
    WordCount = 0x5AF, // s_word_count
    WordMagic = 0x5B0, // s_word_magic
    WordNearrange = 0x5B1, // s_word_nearrange
    WordLongrange = 0x5B2, // s_word_longrange
    WordTaxistation = 0x5B3, // s_word_taxistation
    WordBesttaxistation = 0x5B4, // s_word_besttaxistation
    WordTelescope = 0x5B5, // s_word_telescope
    WordMyhome = 0x5B6, // s_word_myhome
    WordMyhomeProperty = 0x5B7, // s_word_myhome_property
    WordMinimapAlpha = 0x5B8, // s_word_minimap_alpha
    WordMapbgAlpha = 0x5B9, // s_word_mapbg_alpha
    WordExitYes = 0x5BA, // s_word_exit_yes
    WordExitNo = 0x5BB, // s_word_exit_no
    WordItem = 0x5BC, // s_word_item
    WordTrade = 0x5BD, // s_word_trade
    WordCashshop = 0x5BE, // s_word_cashshop
    WordBlackmarket = 0x5BF, // s_word_blackmarket
    WordMesomarket = 0x5C0, // s_word_mesomarket
    WordMeratmarket = 0x5C1, // s_word_meratmarket
    WordUgc = 0x5C2, // s_word_ugc
    WordUgcBanner = 0x5C3, // s_word_ugc_banner
    WordHomepage = 0x5C4, // s_word_homepage
    WordSunday = 0x5C5, // s_word_sunday
    WordMonday = 0x5C6, // s_word_monday
    WordTuesday = 0x5C7, // s_word_tuesday
    WordWednesday = 0x5C8, // s_word_wednesday
    WordThursday = 0x5C9, // s_word_thursday
    WordFriday = 0x5CA, // s_word_friday
    WordSaturday = 0x5CB, // s_word_saturday
    WordChatting = 0x5CC, // s_word_chatting
    WordMail = 0x5CD, // s_word_mail
    WordSmartPush = 0x5CE, // s_word_smart_push
    WordFishing = 0x5CF, // s_word_fishing
    WordSafeRiding = 0x5D0, // s_word_safe_riding
    WordAmphibious = 0x5D1, // s_word_amphibious
    WordAutoPlayInstrument = 0x5D2, // s_word_auto_play_instrument
    WordAutoMining = 0x5D3, // s_word_auto_mining
    WordAutoGathering = 0x5D4, // s_word_auto_gathering
    WordAutoBreeding = 0x5D5, // s_word_auto_breeding
    WordAutoFarming = 0x5D6, // s_word_auto_farming
    WordRevival = 0x5D8, // s_word_revival
    WordQuest = 0x5D9, // s_word_quest
    WordSkill = 0x5DA, // s_word_skill
    WordSkillActive = 0x5DB, // s_word_skill_active
    WordSkillPassive = 0x5DC, // s_word_skill_passive
    WordSkillMove = 0x5DD, // s_word_skill_move
    WordElementPhysics = 0x5DE, // s_word_element_physics
    WordElementFire = 0x5DF, // s_word_element_fire
    WordElementIce = 0x5E0, // s_word_element_ice
    WordElementLightning = 0x5E1, // s_word_element_lightning
    WordElementHoly = 0x5E2, // s_word_element_holy
    WordElementDarkness = 0x5E3, // s_word_element_darkness
    WordElementPoison = 0x5E4, // s_word_element_poison
    WordMin = 0x5E5, // s_word_min
    WordHour = 0x5E7, // s_word_hour
    WordHour2 = 0x5E8, // s_word_hour2
    WordSec = 0x5E6, // s_word_sec
    WordDay = 0x5E9, // s_word_day
    WordRemain = 0x5EA, // s_word_remain
    WordGroup = 0x5EB, // s_word_group
    WordNewgroup = 0x5EC, // s_word_newgroup
    QuestChapter = 0x5ED, // s_quest_chapter
    QuestTalkAccept = 0x5EE, // s_quest_talk_accept
    QuestTalkComplete = 0x5EF, // s_quest_talk_complete
    QuestTalkProgress = 0x5F0, // s_quest_talk_progress
    QuestTalkEnd = 0x5F1, // s_quest_talk_end
    QuestTalkRewardTitle = 0x5F2, // s_quest_talk_reward_title
    QuestStateInit = 0x5F3, // s_quest_state_init
    QuestStateBeginAble = 0x5F4, // s_quest_state_beginAble
    QuestStateProgress = 0x5F5, // s_quest_state_progress
    QuestStateCompleteAble = 0x5F6, // s_quest_state_completeAble
    QuestStateComplete = 0x5F7, // s_quest_state_complete
    QuestMainQuest = 0x5F8, // s_quest_main_quest
    QuestSubQuest = 0x5F9, // s_quest_sub_quest
    QuestEventQuest = 0x5FA, // s_quest_event_quest
    QuestRepeatInfinite = 0x5FB, // s_quest_repeat_infinite
    QuestRepeatDaily = 0x5FC, // s_quest_repeat_daily
    QuestReplaceNpc = 0x5FD, // s_quest_replace_npc
    QuestReplaceTalk = 0x5FE, // s_quest_replace_talk
    QuestReplaceQuestObject = 0x5FF, // s_quest_replace_quest_object
    QuestReplaceField = 0x600, // s_quest_replace_field
    QuestReplaceItem = 0x601, // s_quest_replace_item
    QuestReplaceSatisfied = 0x602, // s_quest_replace_satisfied
    MissionReplaceNpcMeso = 0x603, // s_mission_replace_npc_meso
    QuestReplaceItemMove = 0x604, // s_quest_replace_item_move
    QuestNotSelectedReward = 0x605, // s_quest_not_selected_reward
    QuestBossNotify = 0x606, // s_quest_boss_notify
    QuestBossNotifyChat = 0x607, // s_quest_boss_notify_chat
    QuestBossNotifyQuest = 0x608, // s_quest_boss_notify_quest
    QuestErrorInventoryFull = 0x609, // s_quest_error_inventory_full
    QuestErrorConsumeFail = 0x60A, // s_quest_error_consume_fail
    QuestErrorAcceptFail = 0x60B, // s_quest_error_accept_fail
    QuestErrorCountLimit = 0x60C, // s_quest_error_count_limit
    QuestErrorInvalidDate = 0x60D, // s_quest_error_invalid_date
    QuestScrollProgressQuest = 0x60E, // s_quest_scroll_progress_quest
    QuestScrollInvalidBeginQuest = 0x60F, // s_quest_scroll_invalid_begin_quest
    QuestScrollInventoryFull = 0x610, // s_quest_scroll_inventory_full
    QuestScrollUseItem = 0x611, // s_quest_scroll_use_item
    TitleScrollDuplicateErr = 0x612, // s_title_scroll_duplicate_err
    BuddyConfirmDelSomebodyFromList = 0x613, // s_buddy_confirm_del_somebody_from_list
    BuddyConfirmDelSomebodyFromBanli = 0x614, // s_buddy_confirm_del_somebody_from_banli
    BuddyConfirmBanSomebody = 0x615, // s_buddy_confirm_ban_somebody
    BuddyAddSomebody = 0x616, // s_buddy_add_somebody
    BuddyBanSomebody = 0x617, // s_buddy_ban_somebody
    BuddyBanMemoComplete = 0x618, // s_buddy_ban_memo_complete
    BuddyRequestToSomebody = 0x619, // s_buddy_request_to_somebody
    BuddyDeclineRequestFromSomebody = 0x61A, // s_buddy_decline_request_from_somebody
    BuddyRefusedRequestFromSomebody = 0x61B, // s_buddy_refused_request_from_somebody
    BuddyCancelRequestFromSomebody = 0x61C, // s_buddy_cancel_request_from_somebody
    BuddyCancelRequest = 0x61D, // s_buddy_cancel_request
    BuddyDelSomebodyFromList = 0x61E, // s_buddy_del_somebody_from_list
    BuddyDelSomebodyFromBanlist = 0x61F, // s_buddy_del_somebody_from_banlist
    BuddyAlertReceiveRequest = 0x620, // s_buddy_alert_receive_request
    BuddyAlertOnlineSomebody = 0x621, // s_buddy_alert_online_somebody
    BuddyAlertOfflineSomebody = 0x622, // s_buddy_alert_offline_somebody
    BuddyRequestDefaultMsg = 0x623, // s_buddy_request_default_msg
    BuddyWaiting = 0x624, // s_buddy_waiting
    BuddyFormatChMap = 0x625, // s_buddy_format_ch_map
    BuddyFormatOffline = 0x626, // s_buddy_format_offline
    BuddyFormatMapuserCount = 0x627, // s_buddy_format_mapuser_count
    BuddyFormatRecvCount = 0x628, // s_buddy_format_recv_count
    BuddyFormatBanCount = 0x629, // s_buddy_format_ban_count
    BuddyFormatBuddyCount = 0x62A, // s_buddy_format_buddy_count
    BuddyErrUnknown = 0x62B, // s_buddy_err_unknown
    BuddyErrMissId = 0x62C, // s_buddy_err_miss_id
    BuddyErrEmptyId = 0x62D, // s_buddy_err_empty_id
    BuddyErrMyId = 0x62E, // s_buddy_err_my_id
    BuddyErrMyIdEx = 0x62F, // s_buddy_err_my_id_ex
    BuddyErrNotExistId = 0x630, // s_buddy_err_not_exist_id
    BuddyErrBanBuddyAdd = 0x631, // s_buddy_err_ban_buddy_add
    BuddyErrAlreadyReceive = 0x632, // s_buddy_err_already_receive
    BuddyErrMaxBlock = 0x633, // s_buddy_err_max_block
    BuddyErrRequestSomebody = 0x634, // s_buddy_err_request_somebody
    BuddyErrMaxBuddy = 0x635, // s_buddy_err_max_buddy
    BuddyErrTargetFull = 0x636, // s_buddy_err_target_full
    BuddyErrAlreadyRequest = 0x637, // s_buddy_err_already_request
    BuddyErrAlreadyBan = 0x638, // s_buddy_err_already_ban
    BuddyErrAlreadyBuddy = 0x639, // s_buddy_err_already_buddy
    BuddyErrAlreadyRequestSomebody = 0x63A, // s_buddy_err_already_request_somebody
    BuddyErrAlreadyReceiveFromThisC = 0x63B, // s_buddy_err_already_receive_from_this_c
    FormatMeso = 0x63C, // s_format_meso
    FormatExp = 0x63D, // s_format_exp
    FormatItem = 0x63E, // s_format_item
    FormatRewardExp = 0x63F, // s_format_reward_exp
    FormatRewardMeso = 0x640, // s_format_reward_meso
    MsgWorldmapTitle = 0x641, // s_msg_worldmap_title
    ChangeChErrField = 0x642, // s_change_ch_err_field
    ChangeChErrBattle = 0x643, // s_change_ch_err_battle
    ChangeChErrDead = 0x644, // s_change_ch_err_dead
    ActionTalkNormal = 0x645, // s_action_talk_normal
    ActionTalkNormalCinematic = 0x646, // s_action_talk_normal_cinematic
    ActionTalkShop = 0x647, // s_action_talk_shop
    ActionTalkStore = 0x648, // s_action_talk_store
    ActionTalkMail = 0x649, // s_action_talk_mail
    ActionEnterCube = 0x64A, // s_action_enter_cube
    ActionPortal = 0x64B, // s_action_portal
    ActionInteract = 0x64C, // s_action_interact
    ActionBuySite = 0x64D, // s_action_buy_site
    ActionSaleApartment = 0x64E, // s_action_sale_apartment
    ActionSellCube = 0x64F, // s_action_sell_cube
    ActionRegistUgc = 0x650, // s_action_regist_ugc
    ActionConstruct = 0x651, // s_action_construct
    ActionChangejob = 0x652, // s_action_changejob
    ActionLiftCube = 0x653, // s_action_lift_cube
    ActionRide = 0x654, // s_action_ride
    ActionPull = 0x655, // s_action_pull
    ActionPutdownLiftable = 0x656, // s_action_putdown_liftable
    ActionSwitchcube = 0x657, // s_action_switchcube
    ActionBreedingcube = 0x658, // s_action_breedingcube
    ActionFarmingcube = 0x659, // s_action_farmingcube
    ActionHarvest = 0x65A, // s_action_harvest
    ActionHarvesting = 0x65B, // s_action_harvesting
    ActionRemainTime = 0x65C, // s_action_remain_time
    ActionBreedingGrowing = 0x65D, // s_action_breeding_growing
    ActionFarmingGrowing = 0x65E, // s_action_farming_growing
    ActionFittingdoll = 0x65F, // s_action_fittingdoll
    ActionUseTelescope = 0x660, // s_action_use_telescope
    ActionViewCubeProfile = 0x661, // s_action_view_cube_profile
    ActionOwner = 0x662, // s_action_owner
    ActionTaxiCall = 0x663, // s_action_taxi_call
    ActionTaxiCallProgress = 0x664, // s_action_taxi_call_progress
    ActionCashTaxiCallProgress = 0x665, // s_action_cash_taxi_call_progress
    ActionRegistBanner = 0x666, // s_action_regist_banner
    ActionFusion = 0x667, // s_action_fusion
    ActionSummonPet = 0x668, // s_action_summon_pet
    ActionSummonRidee = 0x669, // s_action_summon_ridee
    ActionGotoHome = 0x66A, // s_action_goto_home
    ActionHold = 0x66B, // s_action_hold
    ActionHoldEnd = 0x66C, // s_action_hold_end
    ActionCantPet = 0x66D, // s_action_cant_pet
    ActionCantRide = 0x66E, // s_action_cant_ride
    ActionPrivilegePortal = 0x66F, // s_action_privilege_portal
    ActionRecallOtheruser = 0x670, // s_action_recall_otheruser
    ActionFishing = 0x671, // s_action_fishing
    ActionFishingTry = 0x672, // s_action_fishing_try
    ActionBankCallProgress = 0x673, // s_action_bank_call_progress
    ActionHomebankCallProgress = 0x679, // s_action_homebank_call_progress
    ActionWebopen = 0x674, // s_action_webopen
    ActionBanner = 0x675, // s_action_banner
    ActionBannerRps = 0x676, // s_action_banner_rps
    ActionReactor = 0x677, // s_action_reactor
    ActionPickup = 0x678, // s_action_pickup
    ErrHomebankCannotNow = 0x67A, // s_err_homebank_cannot_now
    ErrHomebankCannotNowPlace = 0x67B, // s_err_homebank_cannot_now_place
    ErrHomebankCannotNowAlready = 0x67C, // s_err_homebank_cannot_now_already
    ActionHomedoctorCallProgress = 0x67D, // s_action_homedoctor_call_progress
    ErrHomedoctorCannotNow = 0x67E, // s_err_homedoctor_cannot_now
    ErrHomedoctorCannotNowPlace = 0x67F, // s_err_homedoctor_cannot_now_place
    CutsceneTelescopeKeycap = 0x680, // s_cutscene_telescope_keycap
    CutsceneTelescopeKeydesc = 0x681, // s_cutscene_telescope_keydesc
    ChangejobAccept = 0x682, // s_changejob_accept
    TakeBoatAccept = 0x683, // s_take_boat_accept
    ResolvePaneltyAccept = 0x684, // s_resolve_panelty_accept
    SellUgcMapAccept = 0x685, // s_sell_ugc_map_accept
    RouletteAccept = 0x686, // s_roulette_accept
    RouletteTalkSkip = 0x687, // s_roulette_talk_skip
    HtmlChatSuper = 0x688, // s_html_chat_super
    HtmlChatWorld = 0x689, // s_html_chat_world
    HtmlChatChannel = 0x68A, // s_html_chat_channel
    HtmlChatNormal = 0x68B, // s_html_chat_normal
    HtmlChatGuild = 0x68D, // s_html_chat_guild
    HtmlChatParty = 0x68C, // s_html_chat_party
    HtmlChatWhisperTo = 0x68E, // s_html_chat_whisper_to
    HtmlChatWhisperFrom = 0x68F, // s_html_chat_whisper_from
    HtmlChatNotice = 0x690, // s_html_chat_notice
    HtmlChatImgNotice = 0x691, // s_html_chat_img_notice
    HtmlChatLinkableTitle = 0x692, // s_html_chat_linkable_title
    HtmlChatSystemNotice = 0x693, // s_html_chat_system_notice
    HtmlChatClub = 0x694, // s_html_chat_club
    HtmlChatUgcEvent = 0x695, // s_html_chat_ugc_event
    HtmlChatSuperCustom = 0x696, // s_html_chat_super_custom
    HtmlChatGuildMegaPhone = 0x697, // s_html_chat_guild_mega_phone
    HtmlChatSystem = 0x698, // s_html_chat_system
    HtmlChatWedding = 0x699, // s_html_chat_wedding
    HtmlChatWeddingCustom = 0x69A, // s_html_chat_wedding_custom
    SystemQuestRewardExp = 0x69B, // s_system_quest_reward_exp
    SystemQuestRewardExpWithHottimeb = 0x69C, // s_system_quest_reward_exp_with_hottimeb
    SystemQuestRewardMeso = 0x69D, // s_system_quest_reward_meso
    SystemQuestRewardMesoWithHottime = 0x69E, // s_system_quest_reward_meso_with_hottime
    SystemQuestRewardMerat = 0x69F, // s_system_quest_reward_merat
    SystemAchieveRewardTitle = 0x6A3, // s_system_achieve_reward_title
    SystemAchieveRewardFieldEnterance = 0x6A4, // s_system_achieve_reward_field_enterance
    SystemAchieveRewardShopUnlock = 0x6A5, // s_system_achieve_reward_shop_unlock
    SystemAchieveRewardHonor = 0x6A6, // s_system_achieve_reward_honor
    SystemAchieveRewardKarma = 0x6A7, // s_system_achieve_reward_karma
    SystemAchieveRewardLu = 0x6A8, // s_system_achieve_reward_lu
    SystemAchieveRewardHabi = 0x6A9, // s_system_achieve_reward_habi
    SystemQuestCondition = 0x6A0, // s_system_quest_condition
    SystemGetItem = 0x6A1, // s_system_get_item
    SystemPropertyProtectionTime = 0x6A2, // s_system_property_protection_time
    HtmlQuestReward = 0x6AA, // s_html_quest_reward
    UgcMapOk = 0x6AB, // s_ugcmap_ok
    UgcMapCreateOnNonEmptyArea = 0x6AC, // s_ugcmap_create_on_non_empty_area
    UgcMapNotExistCraftItem = 0x6AD, // s_ugcmap_not_exist_craft_item
    UgcMapNotOwnedItem = 0x6AE, // s_ugcmap_not_owned_item
    UgcMapCantBeCreated = 0x6AF, // s_ugcmap_cant_be_created
    UgcMapCantCreateOnPlace = 0x6B0, // s_ugcmap_cant_create_on_place
    UgcMapNoBaseCube = 0x6B1, // s_ugcmap_no_base_cube
    UgcMapDontHaveOwnership = 0x6B2, // s_ugcmap_dont_have_ownership
    UgcMapCantCreateGroundOnGround = 0x6B3, // s_ugcmap_cant_create_ground_on_ground
    UgcMapCantCreateOnGround = 0x6B4, // s_ugcmap_cant_create_on_ground
    UgcMapOnlyBeCreatedOnGround = 0x6B5, // s_ugcmap_only_be_created_on_ground
    UgcMapCantStackOn = 0x6B6, // s_ugcmap_cant_stack_on
    UgcMapDb = 0x6B7, // s_ugcmap_db
    UgcMapCenter = 0x6B8, // s_ugcmap_center
    UgcMapNoWallToAttach = 0x6B9, // s_ugcmap_no_wall_to_attach
    UgcMapNotWallAttachable = 0x6BA, // s_ugcmap_not_wall_attachable
    UgcMapOnlyBeCreatedOnWall = 0x6BB, // s_ugcmap_only_be_created_on_wall
    UgcMapCantAttachedToThisWall = 0x6BC, // s_ugcmap_cant_attached_to_this_wall
    UgcMapHaveAlreadyAttached = 0x6BD, // s_ugcmap_have_already_attached
    UgcMapNoCubeToRemove = 0x6BE, // s_ugcmap_no_cube_to_remove
    UgcMapCantBeRemoved = 0x6BF, // s_ugcmap_cant_be_removed
    UgcMapCantRemoveBeforeRemoveAll = 0x6C0, // s_ugcmap_cant_remove_before_remove_all_
    UgcMapCantRemoveBuildingWithIndo = 0x6C1, // s_ugcmap_cant_remove_building_with_indo
    UgcMapCanBeRemoveFromWall = 0x6C2, // s_ugcmap_can_be_remove_from_wall
    UgcMapNoAttachedObject = 0x6C3, // s_ugcmap_no_attached_object
    UgcMapNoCubeToRotate = 0x6C4, // s_ugcmap_no_cube_to_rotate
    UgcMapCantRotateDefaultCube = 0x6C5, // s_ugcmap_cant_rotate_default_cube
    UgcMapNoCubeToReplace = 0x6C6, // s_ugcmap_no_cube_to_replace
    UgcMapCantBeReplaced = 0x6C7, // s_ugcmap_cant_be_replaced
    UgcMapAttachedCubeExist = 0x6C8, // s_ugcmap_attached_cube_exist
    UgcMapCantReplaceStackableWithNo = 0x6C9, // s_ugcmap_cant_replace_stackable_with_no
    UgcMapNotABuyable = 0x6CA, // s_ugcmap_not_a_buyable
    UgcMapNotEnoughMoney = 0x6CB, // s_ugcmap_not_enough_money
    UgcMapAlreadyOwned = 0x6CC, // s_ugcmap_already_owned
    UgcMapSalable = 0x6CD, // s_ugcmap_salable
    UgcMapNoCubeToLift = 0x6CE, // s_ugcmap_no_cube_to_lift
    UgcMapCantLiftUgcCube = 0x6CF, // s_ugcmap_cant_lift_ugc_cube
    UgcMapCantLiftSalable = 0x6D0, // s_ugcmap_cant_lift_salable
    UgcMapCantRemoveDefaultCube = 0x6D1, // s_ugcmap_cant_remove_default_cube
    UgcMapCantRemoveCubeWithAttached = 0x6D2, // s_ugcmap_cant_remove_cube_with_attached
    UgcMapNullCubeItemInfo = 0x6D3, // s_ugcmap_null_cube_item_info
    UgcMapHeightLimit = 0x6D4, // s_ugcmap_height_limit
    UgcMapAreaLimit = 0x6D5, // s_ugcmap_area_limit
    UgcMapBuildingCount = 0x6D6, // s_ugcmap_building_count
    UgcMapNotForSale = 0x6D7, // s_ugcmap_not_for_sale
    UgcMapNoMoreRoom = 0x6D8, // s_ugcmap_no_more_room
    UgcMapNoHome = 0x6D9, // s_ugcmap_no_home
    UgcMapMyHouse = 0x6DA, // s_ugcmap_my_house
    UgcMapAlreadyExpired = 0x6DB, // s_ugcmap_already_expired
    UgcMapSystemError = 0x6DC, // s_ugcmap_system_error
    UgcMapHaveEquipitems = 0x6DD, // s_ugcmap_have_equipitems
    UgcMapCantReplaceSameCube = 0x6DE, // s_ugcmap_cant_replace_same_cube
    UgcMapCantBuyMoreThanTwoHouse = 0x6DF, // s_ugcmap_cant_buy_more_than_two_house
    UgcMapNeedTrophy = 0x6E0, // s_ugcmap_need_trophy
    UgcMapWallDirectionError = 0x6E2, // s_ugcmap_wall_direction_error
    UgcMapCantCreateUnderAttach = 0x6E7, // s_ugcmap_cant_create_under_attach
    UgcMapCantAttachUpperCube = 0x6E8, // s_ugcmap_cant_attach_upper_cube
    UgcMapCantReplaceUnderAttach = 0x6E9, // s_ugcmap_cant_replace_under_attach
    UgcMapCantPlaceMaid = 0x6EA, // s_ugcmap_cant_place_maid
    UgcMapOnlyPlaceOnTheFloor = 0x6EB, // s_ugcmap_only_place_on_the_floor
    UgcMapNotExtensionDate = 0x6EC, // s_ugcmap_not_extension_date
    UgcMapNeedExtansionPay = 0x6ED, // s_ugcmap_need_extansion_pay
    UgcMapExpiredSalableGroup = 0x6EE, // s_ugcmap_expired_salable_group
    UgcMapCantSellMyHomeInIndoor = 0x6EF, // s_ugcmap_cant_sell_my_home_in_indoor
    UgcMapBlockedSalableGroup = 0x6F0, // s_ugcmap_blocked_salable_group
    UgcMapRetryLater = 0x6F1, // s_ugcmap_retry_later
    UgcMapWaitingForCubeToBeCreated = 0x6F2, // s_ugcmap_waiting_for_cube_to_be_created
    UgcMapWaitingForCubeToBeReplace = 0x6F3, // s_ugcmap_waiting_for_cube_to_be_replace
    UgcMapWaitingForCubeToBeRemoved = 0x6F4, // s_ugcmap_waiting_for_cube_to_be_removed
    UgcMapTriggerCount = 0x6F5, // s_ugcmap_trigger_count
    UgcMapNoOwnerToCommend = 0x6F6, // s_ugcmap_no_owner_to_commend
    UgcMapAddCommendHomeFailFromDb = 0x6F7, // s_ugcmap_add_commend_home_fail_from_db
    UgcMapCantCommendMyself = 0x6F8, // s_ugcmap_cant_commend_myself
    UgcMapCantCommendDuplicate = 0x6F9, // s_ugcmap_cant_commend_duplicate
    UgcMapBanWordIncluded = 0x6FA, // s_ugcmap_ban_word_included
    UgcMapNotMyHouse = 0x6FB, // s_ugcmap_not_my_house
    UgcMapAutomaticRemoval = 0x6FC, // s_ugcmap_automatic_removal
    UgcMapCantTakeInteriorGiftMore = 0x6FD, // s_ugcmap_cant_take_interior_gift_more
    UgcMapTakeInteriorGiftFailFromD = 0x6FE, // s_ugcmap_take_interior_gift_fail_from_d
    UgcMapAlreadyTakenInteriorGradeG = 0x6FF, // s_ugcmap_already_taken_interior_grade_g
    UgcMapAreaLevelExtendedSuccessful = 0x700, // s_ugcmap_area_level_extended_successful
    UgcMapHeightLevelExtendedSuccessf = 0x701, // s_ugcmap_height_level_extended_successf
    UgcMapAreaLevelShrinkSuccessfully = 0x702, // s_ugcmap_area_level_shrink_successfully
    UgcMapHeightLevelShrinkSuccessful = 0x703, // s_ugcmap_height_level_shrink_successful
    UgcMapNotUseBlueprintItem = 0x704, // s_ugcmap_not_use_blueprint_item
    UgcEditHomeless = 0x705, // s_ugc_edit_homeless
    UgcEditDifferentIndoorsize = 0x706, // s_ugc_edit_different_indoorsize
    UgcMapPackageName = 0x707, // s_ugcmap_package_name
    UgcMapPackageDescription = 0x708, // s_ugcmap_package_description
    UgcMapPackageBuildCondition = 0x709, // s_ugcmap_package_build_condition
    UgcMapPackageBuildDescription = 0x70A, // s_ugcmap_package_build_description
    UgcMapLiftErrorMsg = 0x6E3, // s_ugcmap_lift_error_msg
    UgcMapTryPlaceEmpty = 0x6E4, // s_ugcmap_try_place_empty
    UgcMapCantReplaceType = 0x6E5, // s_ugcmap_cant_replace_type
    UgcMapCantRotateAttached = 0x6E6, // s_ugcmap_cant_rotate_attached
    UgcMapBuyRealestate = 0x70B, // s_ugcmap_buy_realestate
    UgcMapSellRealestate = 0x70C, // s_ugcmap_sell_realestate
    UgcMapUseSaleCouponToBuy = 0x70D, // s_ugcmap_use_sale_coupon_to_buy
    ConstructUpLimit = 0x70E, // s_construct_up_limit
    ConstructDownLimit = 0x70F, // s_construct_down_limit
    ConstructOnlyIndoor = 0x710, // s_construct_only_indoor
    ConstructOnlyOutdoor = 0x711, // s_construct_only_outdoor
    ConstructCategory = 0x712, // s_construct_category
    ConstructBuyPrice = 0x713, // s_construct_buy_price
    ConstructRequireInteriorLevel = 0x714, // s_construct_require_interior_level
    ConstructRequireTrophy = 0x715, // s_construct_require_trophy
    ConstructUsecountAndHascount = 0x716, // s_construct_usecount_and_hascount
    ConstructUsecountAndHascountArg = 0x717, // s_construct_usecount_and_hascount_arg
    HousingPointInteriorLevel = 0x718, // s_housing_point_interior_level
    UgcMapCantGuideBuild = 0x6E1, // s_ugcmap_cant_guide_build
    TipWhisper = 0x719, // s_tip_whisper
    MainplayinfoBuildCount = 0x71A, // s_mainplayinfo_build_count
    MainplayinfoMaidCount = 0x71B, // s_mainplayinfo_maid_count
    MainplayinfoTriggerCount = 0x71C, // s_mainplayinfo_trigger_count
    WarehouseTimeleftDayNormal = 0x71D, // s_warehouse_timeleft_day_normal
    WarehouseTimeleftDayRed = 0x71E, // s_warehouse_timeleft_day_red
    WarehouseTimeleftHourRed = 0x71F, // s_warehouse_timeleft_hour_red
    WarehouseTimeleftMinuteRed = 0x720, // s_warehouse_timeleft_minute_red
    WarehouseTimeleftSecondRed = 0x721, // s_warehouse_timeleft_second_red
    WarehouseTimeleftTimeoverRed = 0x722, // s_warehouse_timeleft_timeover_red
    WarehouseAccept = 0x723, // s_warehouse_accept
    WarehouseSendToMailSender = 0x724, // s_warehouse_send_to_mail_sender
    WarehouseSendToMailTitle = 0x725, // s_warehouse_send_to_mail_title
    WarehouseSendToMailContent = 0x726, // s_warehouse_send_to_mail_content
    WorldmapTooltipChannel = 0x727, // s_worldmap_tooltip_channel
    WorldmapTooltipMyname = 0x728, // s_worldmap_tooltip_myname
    WorldmapTooltipMyhome = 0x729, // s_worldmap_tooltip_myhome
    WorldmapTooltipFriend = 0x72A, // s_worldmap_tooltip_friend
    WorldmapTooltipFriendhome = 0x72B, // s_worldmap_tooltip_friendhome
    WorldmapTooltipParty = 0x72C, // s_worldmap_tooltip_party
    WorldmapTooltipLevel = 0x72D, // s_worldmap_tooltip_level
    WorldmapTooltipLevelUpper = 0x72E, // s_worldmap_tooltip_level_upper
    WorldmapTooltipMapname = 0x72F, // s_worldmap_tooltip_mapname
    WorldmapTooltipMapnameLow = 0x730, // s_worldmap_tooltip_mapname_low
    WorldmapTooltipMapnameHigh = 0x731, // s_worldmap_tooltip_mapname_high
    WorldmapTooltipFishingspotLow = 0x732, // s_worldmap_tooltip_fishingspot_low
    WorldmapTooltipFishingspotHigh = 0x733, // s_worldmap_tooltip_fishingspot_high
    WorldmapTooltipBoss = 0x734, // s_worldmap_tooltip_boss
    WorldmapTooltipChannelEnabled = 0x735, // s_worldmap_tooltip_channel_enabled
    WorldmapTooltipChannelDisabled = 0x736, // s_worldmap_tooltip_channel_disabled
    WorldmapTooltipChannelExtra = 0x737, // s_worldmap_tooltip_channel_extra
    WorldmapTooltipPortal = 0x738, // s_worldmap_tooltip_portal
    WorldmapTooltipPortalTime = 0x739, // s_worldmap_tooltip_portal_time
    WorldmapTooltipQuestCompletable = 0x73A, // s_worldmap_tooltip_quest_completable
    WorldmapTooltipQuestProgress = 0x73B, // s_worldmap_tooltip_quest_progress
    WorldmapTooltipQuestAblenow = 0x73C, // s_worldmap_tooltip_quest_ablenow
    WorldmapTooltipQuestAbleupper = 0x73D, // s_worldmap_tooltip_quest_ableupper
    WorldmapTooltipTaxiTitle = 0x73E, // s_worldmap_tooltip_taxi_title
    WorldmapTooltipTaxiPrice = 0x73F, // s_worldmap_tooltip_taxi_price
    WorldmapTooltipTaxiSeal = 0x740, // s_worldmap_tooltip_taxi_seal
    WorldmapTooltipTaxiCurrent = 0x741, // s_worldmap_tooltip_taxi_current
    WorldmapTooltipTaxiOtherContinent = 0x742, // s_worldmap_tooltip_taxi_other_continent
    WorldmapTooltipOpenNow = 0x743, // s_worldmap_tooltip_open_now
    WorldmapTooltipQuestEpic = 0x744, // s_worldmap_tooltip_quest_epic
    WorldmapTooltipQuestWorld = 0x745, // s_worldmap_tooltip_quest_world
    WorldmapTooltipShadowgate = 0x746, // s_worldmap_tooltip_shadowgate
    WorldmapDungeonRankLevelProper = 0x747, // s_worldmap_dungeon_rank_level_proper
    WorldmapDungeonRankLevelUpper = 0x748, // s_worldmap_dungeon_rank_level_upper
    WorldmapDungeonExpireDate = 0x749, // s_worldmap_dungeon_expire_date
    MinimapIconQuestCompletableEpic = 0x74A, // s_minimap_icon_quest_completable_epic
    MinimapIconQuestCompletableEvent = 0x74B, // s_minimap_icon_quest_completable_event
    MinimapIconQuestCompletableWorld = 0x74C, // s_minimap_icon_quest_completable_world
    MinimapIconQuestCompletableRepeat = 0x74D, // s_minimap_icon_quest_completable_repeat
    MinimapIconQuestAblenowEpic = 0x74E, // s_minimap_icon_quest_ablenow_epic
    MinimapIconQuestAblenowEvent = 0x74F, // s_minimap_icon_quest_ablenow_event
    MinimapIconQuestAblenowWorld = 0x750, // s_minimap_icon_quest_ablenow_world
    MinimapIconQuestAblenowRepeat = 0x751, // s_minimap_icon_quest_ablenow_repeat
    MinimapIconQuestProgress = 0x752, // s_minimap_icon_quest_progress
    MinimapIconQuestAbleupper = 0x753, // s_minimap_icon_quest_ableupper
    MinimapTooltipFunctionNpc = 0x754, // s_minimap_tooltip_function_npc
    MinimapTooltipFunctionNpc1Row = 0x755, // s_minimap_tooltip_function_npc_1row
    MinimapTooltipFunctionPortal = 0x756, // s_minimap_tooltip_function_portal
    MinimapTooltipPortal = 0x757, // s_minimap_tooltip_portal
    MinimapTooltipNormal = 0x758, // s_minimap_tooltip_normal
    MinimapTooltipNormalAlignleft = 0x759, // s_minimap_tooltip_normal_alignleft
    MinimapTooltipQuestCompletable = 0x75A, // s_minimap_tooltip_quest_completable
    MinimapTooltipQuestProgress = 0x75B, // s_minimap_tooltip_quest_progress
    MinimapTooltipQuestAblenow = 0x75C, // s_minimap_tooltip_quest_ablenow
    MinimapTooltipQuestAbleupper = 0x75D, // s_minimap_tooltip_quest_ableupper
    TriggereditorStateChange = 0x75E, // s_triggereditor_state_change
    TriggereditorDeleteStateInvalid = 0x75F, // s_triggereditor_delete_state_invalid
    TriggereditorDeleteStateConfirm = 0x760, // s_triggereditor_delete_state_confirm
    TriggereditorModifiyStateInvalid = 0x761, // s_triggereditor_modifiy_state_invalid
    TriggereditorDeleteAttribute = 0x762, // s_triggereditor_delete_attribute
    TriggereditorModelsizeTooLong = 0x763, // s_triggereditor_modelsize_too_long
    TriggereditorModifyAttributeInvali = 0x764, // s_triggereditor_modify_attribute_invali
    TriggereditorNewTrigger = 0x765, // s_triggereditor_new_trigger
    TriggereditorExitTrigger = 0x766, // s_triggereditor_exit_trigger
    TriggereditorUpload = 0x767, // s_triggereditor_upload
    TriggereditorDownload = 0x768, // s_triggereditor_download
    MsgRclickAttachTrade = 0x769, // s_msg_rclick_attach_trade
    MsgRclickDettachTrade = 0x76A, // s_msg_rclick_dettach_trade
    MsgRclickPutonEquip = 0x76B, // s_msg_rclick_puton_equip
    MsgRclickPutoffEquip = 0x76C, // s_msg_rclick_putoff_equip
    MsgRclickStoreIn = 0x76D, // s_msg_rclick_store_in
    MsgRclickStoreOut = 0x76E, // s_msg_rclick_store_out
    MsgRclickSell = 0x76F, // s_msg_rclick_sell
    MsgRclickAttachMail = 0x770, // s_msg_rclick_attach_mail
    MsgRclickDettachMail = 0x771, // s_msg_rclick_dettach_mail
    MsgRclickBuy = 0x772, // s_msg_rclick_buy
    MsgRclickPutoffQslot = 0x773, // s_msg_rclick_putoff_qslot
    MsgRclickPutonQslot = 0x774, // s_msg_rclick_puton_qslot
    MsgRclickPutonDoll = 0x775, // s_msg_rclick_puton_doll
    MsgRclickPutoffDoll = 0x776, // s_msg_rclick_putoff_doll
    MsgRclickUpgrade = 0x777, // s_msg_rclick_upgrade
    MsgRclickWarehouseOut = 0x778, // s_msg_rclick_warehouse_out
    MsgRclickItemBreak = 0x779, // s_msg_rclick_item_break
    MsgRclickBlackmarket = 0x77A, // s_msg_rclick_blackmarket
    MsgRclickPlayInstrument = 0x77B, // s_msg_rclick_play_instrument
    MsgDclickUsable = 0x77C, // s_msg_dclick_usable
    MsgDclickReadable = 0x77D, // s_msg_dclick_readable
    MsgLclickUsable = 0x77E, // s_msg_lclick_usable
    MsgTooltipCompareSwap = 0x77F, // s_msg_tooltip_compare_swap
    FusionError = 0x780, // s_fusion_error
    RecordError = 0x781, // s_record_error
    RecordAudioError = 0x782, // s_record_audio_error
    TooltipExp = 0x783, // s_tooltip_exp
    TooltipTodayword = 0x784, // s_tooltip_todayword
    TooltipPartyCh = 0x785, // s_tooltip_party_ch
    TooltipParty = 0x786, // s_tooltip_party
    AchieveAdventure = 0x787, // s_achieve_adventure
    AchieveCombat = 0x788, // s_achieve_combat
    AchieveLife = 0x789, // s_achieve_life
    AchieveRewardItem = 0x78A, // s_achieve_reward_item
    AchieveRewardMeso = 0x78B, // s_achieve_reward_meso
    AchieveRewardExp = 0x78C, // s_achieve_reward_exp
    AchieveRewardFunction = 0x78D, // s_achieve_reward_function
    AchieveRewardTitle = 0x78E, // s_achieve_reward_title
    AchieveRewardMerat = 0x78F, // s_achieve_reward_merat
    AchieveRewardFieldEnterance = 0x790, // s_achieve_reward_field_enterance
    AchieveRewardItemBuyAuth = 0x791, // s_achieve_reward_item_buy_auth
    AchieveMeter = 0x792, // s_achieve_meter
    AchieveKillometer = 0x793, // s_achieve_killometer
    AchieveKillometerF = 0x794, // s_achieve_killometer_f
    AchieveGetAchieveDaily = 0x795, // s_achieve_get_achieve_daily
    AchieveGetAchieveHeroComplete = 0x797, // s_achieve_get_achieve_hero_complete
    AchieveGetAchieveHeroProgress = 0x796, // s_achieve_get_achieve_hero_progress
    AchieveGrade = 0x798, // s_achieve_grade
    AchieveStateProgress = 0x799, // s_achieve_state_progress
    AchieveStateComplete = 0x79A, // s_achieve_state_complete
    AchieveTooltipComment = 0x79B, // s_achieve_tooltip_comment
    AchieveResetAccount = 0x79C, // s_achieve_reset_account
    AchieveResetChar = 0x79D, // s_achieve_reset_char
    AchieveCategoryRewardCount = 0x79E, // s_achieve_category_reward_count
    MaidChangeMaidName = 0x79F, // s_maid_change_maid_name
    MaidChangeOwnerName = 0x7A0, // s_maid_change_owner_name
    MaidDefaultOwnerName = 0x7A1, // s_maid_default_owner_name
    MaidLabelBirth = 0x7A2, // s_maid_label_birth
    MaidLabelConstel = 0x7A3, // s_maid_label_constel
    MaidLabelHeight = 0x7A4, // s_maid_label_height
    MaidLabelWeight = 0x7A5, // s_maid_label_weight
    MaidLabelLike = 0x7A6, // s_maid_label_like
    MaidLabelHate = 0x7A7, // s_maid_label_hate
    MaidLabelHobby = 0x7A8, // s_maid_label_hobby
    MaidLabelOwnername = 0x7A9, // s_maid_label_ownername
    MaidLabelBelongto = 0x7AA, // s_maid_label_belongto
    MaidLabelName = 0x7AB, // s_maid_label_name
    MaidLabelTitle = 0x7AC, // s_maid_label_title
    MaidLabelSalary = 0x7AD, // s_maid_label_salary
    MaidNeedSalary = 0x7AE, // s_maid_need_salary
    MaidExpireDate = 0x7AF, // s_maid_expire_date
    MaidExpireDateMorning = 0x7B0, // s_maid_expire_date_morning
    MaidExpireDateAfternoon = 0x7B1, // s_maid_expire_date_afternoon
    MaidExpireDateReservedWord = 0x7B2, // s_maid_expire_date_reserved_word
    MaidExtendDateReservedWord = 0x7B3, // s_maid_extend_date_reserved_word
    MaidAffinityGaugeLevel = 0x7B4, // s_maid_affinity_gauge_level
    MaidAffinityGaugeLevelMax = 0x7B5, // s_maid_affinity_gauge_level_max
    MaidAffinityGaugeAffinity = 0x7B6, // s_maid_affinity_gauge_affinity
    MaidAffinityGaugeAffinityMax = 0x7B7, // s_maid_affinity_gauge_affinity_max
    MaidEditConfirm = 0x7B8, // s_maid_edit_confirm
    MaidFeelNormal = 0x7B9, // s_maid_feel_normal
    MaidFeelGood = 0x7BA, // s_maid_feel_good
    MaidFeelVeryGood = 0x7BB, // s_maid_feel_very_good
    MaidTooltipMaidDesc = 0x7BC, // s_maid_tooltip_maid_desc
    MaidTooltipManufactured = 0x7BD, // s_maid_tooltip_manufactured
    MaidTooltipManufacturing = 0x7BE, // s_maid_tooltip_manufacturing
    MaidReservedWordPassedDays = 0x7BF, // s_maid_reserved_word_passed_days
    MaidReservedWordPayTypeMeso = 0x7C0, // s_maid_reserved_word_pay_type_meso
    MaidReservedWordPayTypeMerat = 0x7C1, // s_maid_reserved_word_pay_type_merat
    MaidRecipeItemOption = 0x7C2, // s_maid_recipe_item_option
    MaidRecipeItemOptionRange = 0x7C3, // s_maid_recipe_item_option_range
    ManufactureRequire = 0x7C4, // s_manufacture_require
    ManufactureRequireOverMax = 0x7C5, // s_manufacture_require_over_max
    ManufactureDetail = 0x7C6, // s_manufacture_detail
    ManufactureIngredientCountSatisfie = 0x7C7, // s_manufacture_ingredient_count_satisfie
    ManufactureIngredientCountNeed = 0x7C8, // s_manufacture_ingredient_count_need
    ManufactureTitleSpecialty = 0x7C9, // s_manufacture_title_specialty
    ManufactureTitleStatus = 0x7CA, // s_manufacture_title_status
    ManufactureTitleStatusTooltip = 0x7CB, // s_manufacture_title_status_tooltip
    ManufactureTitleStatusTooltipMax = 0x7CC, // s_manufacture_title_status_tooltip_max
    ManufactureProgressHour = 0x7CD, // s_manufacture_progress_hour
    ManufactureProgressMin = 0x7CE, // s_manufacture_progress_min
    ManufactureProgressSec = 0x7CF, // s_manufacture_progress_sec
    ManufactureProgressLeft = 0x7D0, // s_manufacture_progress_left
    ManufactureCancelConfirm = 0x7D1, // s_manufacture_cancel_confirm
    ManufactureComplete = 0x7D2, // s_manufacture_complete
    ManufactureCompleteJackpot = 0x7D3, // s_manufacture_complete_jackpot
    ManufactureCompleteByMerat = 0x7D4, // s_manufacture_complete_by_merat
    ManufactureWorkbenchTooltipCookOn = 0x7D5, // s_manufacture_workbench_tooltip_cook_on
    ManufactureWorkbenchTooltipCookOf = 0x7D6, // s_manufacture_workbench_tooltip_cook_of
    ManufactureWorkbenchTooltipAlchemyOn = 0x7D7, // s_manufacture_workbench_tooltip_alchemy_on
    ManufactureWorkbenchTooltipAlchemyOff = 0x7D8, // s_manufacture_workbench_tooltip_alchemy_off
    ManufactureWorkbenchTooltipBizOn = 0x7D9, // s_manufacture_workbench_tooltip_biz_on
    ManufactureWorkbenchTooltipBizOff = 0x7DA, // s_manufacture_workbench_tooltip_biz_off
    ManufactureCinematicTitle = 0x7DB, // s_manufacture_cinematic_title
    ManufactureCinematicAffinity = 0x7DC, // s_manufacture_cinematic_affinity
    ManufactureCinematicAffinityGrade = 0x7DD, // s_manufacture_cinematic_affinity_grade_
    ManufactureCinematicMoodPlus = 0x7DE, // s_manufacture_cinematic_mood_plus
    ManufactureCinematicMoodMinus = 0x7DF, // s_manufacture_cinematic_mood_minus
    ManufactureErrorMsg = 0x7E0, // s_manufacture_error_msg
    MaidRecipeListTitle = 0x7E1, // s_maid_recipe_list_title
    RevealTaxiStation = 0x7E2, // s_reveal_taxi_station
    InteractErrItem = 0x7E3, // s_interact_err_item
    FunctionRewardItemget = 0x7E4, // s_function_reward_itemget
    CinematicJobChange = 0x7E5, // s_cinematic_job_change
    InteractErrQuest = 0x7E6, // s_interact_err_quest
    MyhouseAddressWithRoom = 0x7E7, // s_myhouse_address_with_room
    MyhouseNameWithRoom = 0x7E8, // s_myhouse_name_with_room
    RealestateAskContract = 0x7E9, // s_realestate_ask_contract
    RealestateExpireData = 0x7EA, // s_realestate_expire_data
    RealestateExtensionDate = 0x7EB, // s_realestate_extension_date
    RealestateAskExtentionMerat = 0x7EC, // s_realestate_ask_extention_merat
    RealestateAskExtentionMeso = 0x7ED, // s_realestate_ask_extention_meso
    RealestateAskExtentionItem = 0x7EE, // s_realestate_ask_extention_item
    RealestateBuildingType0 = 0x7EF, // s_realestate_building_type_0
    RealestateBuildingType1 = 0x7F0, // s_realestate_building_type_1
    RealestateBuildingType2 = 0x7F1, // s_realestate_building_type_2
    RealestateBuildingType3 = 0x7F2, // s_realestate_building_type_3
    RealestateArea = 0x7F3, // s_realestate_area
    RealestateInstallBuildingCount = 0x7F4, // s_realestate_install_building_count
    AchieveRewardTab = 0x81D, // s_achieve_reward_tab
    AchieveRewardTabGreat = 0x81E, // s_achieve_reward_tab_great
    AchieveRendererCount = 0x81F, // s_achieve_renderer_count
    AchieveRendererCountTime = 0x820, // s_achieve_renderer_count_time
    AchieveRendererHour = 0x821, // s_achieve_renderer_hour
    AchieveRendererMin = 0x822, // s_achieve_renderer_min
    NotifyLevelup = 0x823, // s_notify_levelup
    NotifyLearnSkill = 0x824, // s_notify_learn_skill
    NotifyMailReply = 0x825, // s_notify_mail_reply
    NotifyMailReplyContent = 0x826, // s_notify_mail_reply_content
    NotifyMailRemainDay = 0x827, // s_notify_mail_remainDay
    NotifyMailRemainDayTooltip = 0x828, // s_notify_mail_remainDay_tooltip
    NotifyMailRemainDayToday = 0x829, // s_notify_mail_remainDay_today
    NotifyMailRemainDayTooltipToday = 0x82A, // s_notify_mail_remainDay_tooltip_today
    NotifyMailRemainDayExpire = 0x82B, // s_notify_mail_remainDay_expire
    NotifyAchieveRewardFunction = 0x82C, // s_notify_achieve_reward_function
    NotifyAchieveRewardDeadfail = 0x82D, // s_notify_achieve_reward_deadfail
    NotifyGroupchatInvite = 0x82E, // s_notify_groupchat_invite
    NotifyGroupchatInvited = 0x82F, // s_notify_groupchat_invited
    NotifyGroupchatLeave = 0x830, // s_notify_groupchat_leave
    NotifyGroupchatLogin = 0x831, // s_notify_groupchat_login
    NotifyGroupchatLogout = 0x832, // s_notify_groupchat_logout
    NotifyGroupchatReject = 0x833, // s_notify_groupchat_reject
    ErrGroupchatMaxjoin = 0x834, // s_err_groupchat_maxjoin
    ErrGroupchatNullTargetUser = 0x835, // s_err_groupchat_null_target_user
    ErrGroupchatJoinExist = 0x836, // s_err_groupchat_join_exist
    ErrGroupchatNameExist = 0x837, // s_err_groupchat_name_exist
    ErrGroupchatMaxgroup = 0x838, // s_err_groupchat_maxgroup
    ErrGroupchatAddMemberTarget = 0x839, // s_err_groupchat_add_member_target
    GroupchatList = 0x83A, // s_groupchat_list
    GroupchatExit = 0x83B, // s_groupchat_exit
    RealestateDetailExpireDate = 0x7F5, // s_realestate_detail_expire_date
    RealestateDetailExpireTime = 0x7F6, // s_realestate_detail_expire_time
    RealestateMorning = 0x7F7, // s_realestate_morning
    RealestateAfternoon = 0x7F8, // s_realestate_afternoon
    RealestateWaitingTime = 0x7F9, // s_realestate_waiting_time
    RealestateDateString = 0x7FA, // s_realestate_date_string
    RealestatePriceDescMoney = 0x7FB, // s_realestate_price_desc_money
    RealestatePriceDescItem = 0x7FC, // s_realestate_price_desc_item
    RealestateDescription = 0x7FD, // s_realestate_description
    RealestateSellMeso = 0x7FE, // s_realestate_sell_meso
    RealestateSellMerat = 0x7FF, // s_realestate_sell_merat
    RealestateSellName = 0x800, // s_realestate_sell_name
    RealestateSellWrong = 0x801, // s_realestate_sell_wrong
    RealestateSellCantSellMyHomeIn = 0x802, // s_realestate_sell_cant_sell_my_home_in_
    AddressPopupSale = 0x803, // s_address_popup_sale
    AddressPopupWaiting = 0x804, // s_address_popup_waiting
    AddressPopupNoroom = 0x805, // s_address_popup_noroom
    AddressPopupMyhome = 0x806, // s_address_popup_myhome
    AddressPopupPrivilege = 0x807, // s_address_popup_privilege
    AddressPopupMesoIcon = 0x808, // s_address_popup_meso_icon
    AddressPopupMeratIcon = 0x809, // s_address_popup_merat_icon
    RealestateBrokerDefaultBuy = 0x80A, // s_realestate_broker_default_buy
    RealestateBrokerDefaultNoRoom = 0x80B, // s_realestate_broker_default_no_room
    RealestateBrokerDefaultMyHouse = 0x80C, // s_realestate_broker_default_my_house
    RealestateBrokerClickBuy = 0x80D, // s_realestate_broker_click_buy
    RealestateBrokerClickNoRoom = 0x80E, // s_realestate_broker_click_no_room
    RealestateBrokerClickMyHouse = 0x80F, // s_realestate_broker_click_my_house
    RealestateBrokerSellConfirm = 0x810, // s_realestate_broker_sell_confirm
    RealestateBrokerCantBuyMoreThan = 0x811, // s_realestate_broker_cant_buy_more_than_
    RealestateBrokerNeedTrophy = 0x812, // s_realestate_broker_need_trophy
    RealestateThisIsMyApartment = 0x813, // s_realestate_this_is_my_apartment
    RealestateApartmentSoldOut = 0x814, // s_realestate_apartment_sold_out
    RealestateApartmentSoldOutDesc = 0x815, // s_realestate_apartment_sold_out_desc
    RealestateContractable = 0x816, // s_realestate_contractable
    RealestateTerms = 0x817, // s_realestate_terms
    RealestateTermsTextContent = 0x818, // s_realestate_terms_text_content
    ApartmentInputRoomNumber = 0x819, // s_apartment_input_room_number
    ApartmentMyhome = 0x81A, // s_apartment_myhome
    ApartmentMyhomeContract = 0x81B, // s_apartment_myhome_contract
    ApartmentMyhomeTooltip = 0x81C, // s_apartment_myhome_tooltip
    TooltipHomeBuff = 0x83C, // s_tooltip_home_buff
    MsgErrorRealestateName = 0x83D, // s_msg_error_realestate_name
    MsgErrorRealestateNameBanAll = 0x83E, // s_msg_error_realestate_name_ban_all
    MsgErrorRealestateNameBanText = 0x83F, // s_msg_error_realestate_name_ban_text
    WorldmapGoMyhome = 0x840, // s_worldmap_go_myhome
    WorldmapGoMyhomeNoStation = 0x841, // s_worldmap_go_myhome_no_station
    TradeRequestSuccess = 0x842, // s_trade_request_success
    TradeRecievedRequest = 0x843, // s_trade_recieved_request
    TradeDecline = 0x844, // s_trade_decline
    TradeCancel = 0x845, // s_trade_cancel
    TradeSuccess = 0x846, // s_trade_success
    TradeErrorSystem = 0x847, // s_trade_error_system
    TradeErrorDistance = 0x848, // s_trade_error_distance
    TradeErrorTimeout = 0x849, // s_trade_error_timeout
    TradeErrorAlreadyRequest = 0x84A, // s_trade_error_already_request
    TradeErrorTradingNow = 0x84B, // s_trade_error_trading_now
    TradeErrorMeso = 0x84C, // s_trade_error_meso
    TradeErrorLatched = 0x84D, // s_trade_error_latched
    TradeErrorDecline = 0x84E, // s_trade_error_decline
    TradeErrorItemcount = 0x84F, // s_trade_error_itemcount
    TradeErrorSlotcount = 0x850, // s_trade_error_slotcount
    TradeErrorItemnone = 0x851, // s_trade_error_itemnone
    TradeErrorPvp = 0x852, // s_trade_error_pvp
    TradeErrorMapLimit = 0x853, // s_trade_error_mapLimit
    TradeErrorInvalidMeso = 0x854, // s_trade_error_invalid_meso
    TradeErrorTargetPropertyProtectio = 0x855, // s_trade_error_target_property_protectio
    TradeErrorTargetFatiguePenalty = 0x856, // s_trade_error_target_fatigue_penalty
    TradeError = 0x857, // s_trade_error
    TradeErrorMesoTransferLimited = 0x858, // s_trade_error_meso_transfer_limited
    TradeErrorMesoTransferLimitedOther = 0x859, // s_trade_error_meso_transfer_limited_other
    TradeErrorMesoTransferLimited2 = 0x85A, // s_trade_error_meso_transfer_limited2
    TradeErrorMesoTransferLimitedOther2 = 0x85B, // s_trade_error_meso_transfer_limited_other2
    TradeErrorMesoTransferAdvLevelLimited = 0x85C, // s_trade_error_meso_transfer_adv_level_limited
    TradeErrorMesoTransferAdvLevelLimitedOther = 0x85D, // s_trade_error_meso_transfer_adv_level_limited_other
    TradeMeso = 0x85E, // s_trade_meso
    TradeTradelimit = 0x85F, // s_trade_tradelimit
    TradeTradelimitBlackmarket = 0x860, // s_trade_tradelimit_blackmarket
    TradeRestrict = 0x861, // s_trade_restrict
    TradeTradein = 0x862, // s_trade_tradein
    TradeAlreadyRequested = 0x863, // s_trade_already_requested
    TradeUnlatchMe = 0x864, // s_trade_unlatch_me
    TradeUnlatchOppnent = 0x865, // s_trade_unlatch_oppnent
    TradeBegin = 0x866, // s_trade_begin
    GameoptionInit = 0x867, // s_gameoption_init
    GameoptionInitAll = 0x868, // s_gameoption_init_all
    GameoptionInitCurrent = 0x869, // s_gameoption_init_current
    GameoptionQuickslotWarning = 0x86A, // s_gameoption_quickslot_warning
    GameoptionModifiedWarning = 0x86B, // s_gameoption_modified_warning
    GameoptionKeysettingWarning = 0x86C, // s_gameoption_keysetting_warning
    GameoptionKeysettingShortcutkeyWarning1 = 0x86F, // s_gameoption_keysetting_shortcutkey_warning1
    GameoptionKeysettingShortcutkeyWarning2 = 0x870, // s_gameoption_keysetting_shortcutkey_warning2
    GameoptionKeysettingShortcutkeyWarning3 = 0x871, // s_gameoption_keysetting_shortcutkey_warning3
    GameoptionQualityWarning = 0x86D, // s_gameoption_quality_warning
    GameoptionRestartWarning = 0x86E, // s_gameoption_restart_warning
    GameoptionConfirmResetLayout = 0x872, // s_gameoption_confirm_reset_layout
    GameoptionKeysettingModifiedkey = 0x873, // s_gameoption_keysetting_modifiedkey
    GameoptionKeysettingUsenotGamepad = 0x874, // s_gameoption_keysetting_usenot_gamepad
    GameoptionKeysettingUsenotKeyboard = 0x875, // s_gameoption_keysetting_usenot_keyboard
    DynamicActionAlreadyAlloc = 0x876, // s_dynamic_action_already_alloc
    DynamicActionItemInvalid = 0x877, // s_dynamic_action_item_invalid
    DynamicActionAlreadyLearn = 0x878, // s_dynamic_action_already_learn
    DynamicActionErrShortcutkey = 0x879, // s_dynamic_action_err_shortcutkey
    DynamicActionLearn = 0x87A, // s_dynamic_action_learn
    DynamicActionLearnOk = 0x87B, // s_dynamic_action_learn_ok
    FittingdollInventoryFull = 0x87D, // s_fittingdoll_InventoryFull
    FittingdollErrorInvalidOwner = 0x87C, // s_fittingdoll_error_invalid_owner
    FittingdollInvalidDoll = 0x87E, // s_fittingdoll_InvalidDoll
    FittingdollInvalidItemTypeSkin = 0x87F, // s_fittingdoll_InvalidItemType_Skin
    FittingdollInvalidItemTypeEquip = 0x880, // s_fittingdoll_InvalidItemType_Equip
    FittingdollInvalidItemTypePutonPc = 0x881, // s_fittingdoll_InvalidItemType_PutonPc
    FittingdollInvalidItemTypePutonDoll = 0x882, // s_fittingdoll_InvalidItemType_PutonDoll
    FittingdollInvalidItem = 0x883, // s_fittingdoll_InvalidItem
    FittingdollInvalidItemRule = 0x884, // s_fittingdoll_InvalidItem_rule
    FittingdollInvaliditemLimit = 0x885, // s_fittingdoll_Invaliditem_limit
    FittingdollInvaliditemMale = 0x886, // s_fittingdoll_Invaliditem_male
    FittingdollInvaliditemFemale = 0x887, // s_fittingdoll_Invaliditem_female
    FittingdollInvalidSlot = 0x888, // s_fittingdoll_Invalid_slot
    FittingdollInvalidBinding = 0x889, // s_fittingdoll_Invalid_binding
    FittingdollWasDestroyed = 0x88A, // s_fittingdoll_Invalid_doll
    FittingdollInvalidMoveDisable = 0x88B, // s_fittingdoll_Invalid_moveDisable
    FittingdollTransformDoneAll = 0x88C, // s_fittingdoll_transform_done_all
    FittingdollTransformDonePartially = 0x88D, // s_fittingdoll_transform_done_partially
    HomeReturnableInvalidState = 0x88E, // s_home_returnable_invalid_state
    HomeReturnableForbidden = 0x88F, // s_home_returnable_forbidden
    HomeReturnableForbiddenToSameplac = 0x890, // s_home_returnable_forbidden_to_sameplac
    HomeReturnableHomeless = 0x891, // s_home_returnable_homeless
    HomeReturnableSamefield = 0x892, // s_home_returnable_samefield
    HomeReturnableCooldown = 0x893, // s_home_returnable_cooldown
    HomeReturnableFieldname = 0x894, // s_home_returnable_fieldname
    HomeReturnableNewcharacter = 0x895, // s_home_returnable_newcharacter
    HomeReturnableConfirmPlace = 0x896, // s_home_returnable_confirm_place
    HomeReturnableConfirmLastPlace = 0x897, // s_home_returnable_confirm_last_place
    HomeReturnableWithoutIndoor = 0x898, // s_home_returnable_without_indoor
    HomeVisitConfirm = 0x899, // s_home_visit_confirm
    HomeVisitFailedDead = 0x89A, // s_home_visit_failed_dead
    HomeVisitFailedCommon = 0x89B, // s_home_visit_failed_common
    HomeVisitFailedHomeless = 0x89C, // s_home_visit_failed_homeless
    HomeVisitFailedDisablemap = 0x89D, // s_home_visit_failed_disablemap
    HomeVisitFailedMyhome = 0x89E, // s_home_visit_failed_myhome
    HomeInviteConfirm = 0x89F, // s_home_invite_confirm
    HomeInviteAccept = 0x8A0, // s_home_invite_accept
    HomeInviteReject = 0x8A1, // s_home_invite_reject
    HomeInviteAcceptwait = 0x8A2, // s_home_invite_acceptwait
    HomeInviteLogout = 0x8A3, // s_home_invite_logout
    HomeInviteDenybyauto = 0x8A4, // s_home_invite_denybyauto
    HomeInviteTimeout = 0x8A5, // s_home_invite_timeout
    HomeInviteSelf = 0x8A6, // s_home_invite_self
    HomeInviteCantInviteNow = 0x8A7, // s_home_invite_cant_invite_now
    TutorialShortcutkeyLimit = 0x8A8, // s_tutorial_shortcutkey_limit
    TutorialItemputonoffLimit = 0x8A9, // s_tutorial_itemputonoff_limit
    TutorialItemdropLimit = 0x8AA, // s_tutorial_itemdrop_limit
    TutorialDialogLimit = 0x8AB, // s_tutorial_dialog_limit
    TutorialSkipMovie = 0x8AC, // s_tutorial_skip_movie
    FailEnterfieldInvaliduser = 0x8AD, // s_fail_enterfield_invaliduser
    FailEnterfieldUserfull = 0x8AE, // s_fail_enterfield_userfull
    FailEnterfieldEventAlreadyStart = 0x8B0, // s_fail_enterfield_event_already_start
    InteractResultAuth = 0x8B1, // s_interact_result_auth
    InteractResultQuest = 0x8B2, // s_interact_result_quest
    InteractResultParty = 0x8B3, // s_interact_result_party
    InteractResultPrivilege = 0x8B4, // s_interact_result_privilege
    InteractResultUnknown = 0x8B5, // s_interact_result_unknown
    InteractResultMastery = 0x8B6, // s_interact_result_mastery
    InteractFindNewTelescope = 0x8B7, // s_interact_find_new_telescope
    HuntingKillBoss = 0x8B8, // s_hunting_kill_boss
    HuntingNpcKillBoss = 0x8B9, // s_hunting_npc_kill_boss
    ModePvpStatusWinner = 0x8BA, // s_mode_pvp_status_winner
    ModePvpStatusChallenger = 0x8BB, // s_mode_pvp_status_challenger
    ReturnhomeEnable = 0x8BC, // s_returnhome_enable
    ReturnhomeHomeless = 0x8BD, // s_returnhome_homeless
    ReturnhomeDisableCooldown = 0x8BE, // s_returnhome_disable_cooldown
    ReturnhomeDisable = 0x8BF, // s_returnhome_disable
    ReturnhomeEnableMerat = 0x8C0, // s_returnhome_enable_merat
    ReturnhomeHomelessMerat = 0x8C1, // s_returnhome_homeless_merat
    ReturnhomeDisableCooldownMerat = 0x8C2, // s_returnhome_disable_cooldown_merat
    ReturnhomeDisableMerat = 0x8C3, // s_returnhome_disable_merat
    ReportFailNoContext = 0x8C4, // s_report_fail_no_context
    ReportFailNoReason = 0x8C5, // s_report_fail_no_reason
    ReportFailNoBlindProfileCheck = 0x8C6, // s_report_fail_no_blind_profile_check
    ReportReallyReport = 0x8C7, // s_report_really_report
    ReportReallyReportWithBan = 0x8C8, // s_report_really_report_with_ban
    ReportReallyReportWithBlind = 0x8C9, // s_report_really_report_with_blind
    ReportReallyBlind = 0x8CA, // s_report_really_blind
    ReportSuccess = 0x8CB, // s_report_success
    ReportFail = 0x8CC, // s_report_fail
    ReportBlindSuccess = 0x8CD, // s_report_blind_success
    ReportCantReportOwnItem = 0x8CE, // s_report_cant_report_own_item
    ReportBanReason = 0x8CF, // s_report_ban_reason
    TencentReportBlockWarningUser = 0x8D0, // s_tencent_report_block_warning_user
    TencentReportBlockWarningUgcFiel = 0x8D1, // s_tencent_report_block_warning_ugc_fiel
    TencentReportBlockWarningUgcItem = 0x8D2, // s_tencent_report_block_warning_ugc_item
    BanCheckErrMinLength = 0x8D3, // s_ban_check_err_min_length
    BanCheckErrMaxLength = 0x8D4, // s_ban_check_err_max_length
    BanCheckErrInvalidChar = 0x8D5, // s_ban_check_err_invalid_char
    BanCheckErrInvalidCharSpace = 0x8D6, // s_ban_check_err_invalid_char_space
    BanCheckErrAllWord = 0x8D7, // s_ban_check_err_all_word
    BanCheckErrAllName = 0x8D8, // s_ban_check_err_all_name
    BanCheckErrAnyWord = 0x8D9, // s_ban_check_err_any_word
    BanCheckErrAny = 0x8DA, // s_ban_check_err_any
    BanCheckTabnameErrAnyWord = 0x8DB, // s_ban_check_tabname_err_any_word
    BanCheckTabnameErrAny = 0x8DC, // s_ban_check_tabname_err_any
    BanCheckTitleErrMinLength = 0x8DD, // s_ban_check_title_err_min_length
    BanCheckTitleErrMaxLength = 0x8DE, // s_ban_check_title_err_max_length
    BanCheckTitleErrInvalidChar = 0x8DF, // s_ban_check_title_err_invalid_char
    BanCheckTitleErrInvalidCharSpac = 0x8E0, // s_ban_check_title_err_invalid_char_spac
    BanCheckTitleErrAnyWord = 0x8E1, // s_ban_check_title_err_any_word
    BanCheckTitleErrAny = 0x8E2, // s_ban_check_title_err_any
    BanCheckCommentErrAnyWord = 0x8E3, // s_ban_check_comment_err_any_word
    BanCheckCommentErrAny = 0x8E4, // s_ban_check_comment_err_any
    NesAdminRoomEnterFailed = 0x8E5, // s_nes_adminRoomEnterFailed
    MaintenanceTitle = 0x8E6, // s_maintenance_title
    MaintenanceModifyEnable = 0x8E7, // s_maintenance_modify_enable
    ChatRestrictSamechat = 0x8E8, // s_chat_restrict_samechat
    ChatRestrictFastchat = 0x8E9, // s_chat_restrict_fastchat
    ChatRestrictAddtime = 0x8EA, // s_chat_restrict_addtime
    ChatRestrictAccumwarning = 0x8EB, // s_chat_restrict_accumwarning
    ChatUnknownCommand = 0x8EC, // s_chat_unknown_command
    ChatWhisperDecline = 0x8ED, // s_chat_whisper_decline
    PortalInvincibleEffectName = 0x8EE, // s_portal_invincible_effect_name
    PortalInvincibleEffectDescription = 0x8EF, // s_portal_invincible_effect_description
    RevivalEffectName = 0x8F0, // s_revival_effect_name
    RevivalEffectDescription = 0x8F1, // s_revival_effect_description
    RevivalInvincibleEffectName = 0x8F2, // s_revival_invincible_effect_name
    RevivalInvincibleEffectDescription = 0x8F3, // s_revival_invincible_effect_description
    ErrSystemTitle = 0x8F4, // s_err_system_title
    ErrSystemCheckGraphicDriver = 0x8F5, // s_err_system_check_graphic_driver
    ErrSystemGraphicError0 = 0x8F6, // s_err_system_graphic_error0
    ErrSystemGraphicError1 = 0x8F7, // s_err_system_graphic_error1
    ErrSystemGraphicError2 = 0x8F8, // s_err_system_graphic_error2
    ErrSystemGraphicError3 = 0x8F9, // s_err_system_graphic_error3
    ErrSystemGraphicError4 = 0x8FA, // s_err_system_graphic_error4
    ErrSystemGraphicError5 = 0x8FB, // s_err_system_graphic_error5
    ErrSystemGraphicError6 = 0x8FC, // s_err_system_graphic_error6
    ErrSystemGraphicError7 = 0x8FD, // s_err_system_graphic_error7
    ErrSystemGraphicError8 = 0x8FE, // s_err_system_graphic_error8
    ErrSystemGraphicError9 = 0x8FF, // s_err_system_graphic_error9
    ErrSystemGraphicError10 = 0x900, // s_err_system_graphic_error10
    ErrSystemGraphicError11 = 0x901, // s_err_system_graphic_error11
    ErrSystemGraphicError12 = 0x902, // s_err_system_graphic_error12
    ErrSystemGraphicError13 = 0x903, // s_err_system_graphic_error13
    ErrSystemGraphicError14 = 0x904, // s_err_system_graphic_error14
    ErrSystemGraphicError15 = 0x905, // s_err_system_graphic_error15
    ErrSystemGraphicError16 = 0x906, // s_err_system_graphic_error16
    ErrSystemGraphicError17 = 0x907, // s_err_system_graphic_error17
    ErrSystemGraphicError18 = 0x908, // s_err_system_graphic_error18
    MsgRestrictionSpecialChattingNeedAccCharLevel = 0x909, // s_msg_restriction_special_chatting_need_acc_char_level
    MsgRestrictionSpecialChattingNeedAccAdvLevel = 0x90A, // s_msg_restriction_special_chatting_need_acc_adv_level
    MsgRestrictionSpecialChattingOver = 0x90B, // s_msg_restriction_special_chatting_over
    MsgRestrictionMailSendNeedAccCh = 0x90C, // s_msg_restriction_mail_send_need_acc_ch
    MsgRestrictionMailSendNeedAccAd = 0x90D, // s_msg_restriction_mail_send_need_acc_ad
    MsgRestrictionMailSendOverDaily = 0x90E, // s_msg_restriction_mail_send_over_daily_
    MsgRestrictionWhisperChattingNeedAccCharLevel = 0x90F, // s_msg_restriction_whisper_chatting_need_acc_char_level
    MsgRestrictionWhisperChattingNeedAccAdvLevel = 0x910, // s_msg_restriction_whisper_chatting_need_acc_adv_level
    MsgRestrictionGroupChattingNeedAccCharLevel = 0x911, // s_msg_restriction_group_chatting_need_acc_char_level
    MsgRestrictionGroupChattingNeedAccAdvLevel = 0x912, // s_msg_restriction_group_chatting_need_acc_adv_level
    MsgRestrictionUgcBannerNeedAccC = 0x913, // s_msg_restriction_ugc_banner_need_acc_c
    MsgRestrictionUgcBannerNeedAccA = 0x914, // s_msg_restriction_ugc_banner_need_acc_a
    AdminCharacterName = 0x915, // s_admin_character_name
    ItembreakInvalidItem = 0x916, // s_itembreak_invalid_item
    ItembreakInvalidDonationItem = 0x917, // s_itembreak_invalid_donation_item
    ItembreakUnknown = 0x918, // s_itembreak_unknown
    ItembreakExcellentItem = 0x919, // s_itembreak_excellent_item
    ItembreakDonationExcellentItem = 0x91A, // s_itembreak_donation_excellent_item
    RecallUserNotifyRecall = 0x91B, // s_recall_user_notify_recall
    RecallUserNotifyConfirmRecall = 0x91C, // s_recall_user_notify_confirm_recall
    RecallUserNotifyRecalled = 0x91D, // s_recall_user_notify_recalled
    RecallUserNotifyNotFound = 0x91E, // s_recall_user_notify_not_found
    RecallUserNotifyCannotMove = 0x91F, // s_recall_user_notify_cannot_move
    RecallUserNotifyReject = 0x920, // s_recall_user_notify_reject
    RecallUserNotifyAlreadyRecalled = 0x921, // s_recall_user_notify_already_recalled
    RecallUserConfirm = 0x922, // s_recall_user_confirm
    BlackmarketMailToSender = 0x923, // s_blackmarket_mail_to_sender
    BlackmarketMailToCancelDirect = 0x924, // s_blackmarket_mail_to_cancel_direct
    BlackmarketMailToCancelExpired = 0x925, // s_blackmarket_mail_to_cancel_expired
    BlackmarketMailToCancelHide = 0x926, // s_blackmarket_mail_to_cancel_hide
    BlackmarketMailToSellerTitle = 0x927, // s_blackmarket_mail_to_seller_title
    BlackmarketMailToSellerTitle2 = 0x928, // s_blackmarket_mail_to_seller_title2
    BlackmarketMailToSellerTitlePend = 0x929, // s_blackmarket_mail_to_seller_title_pend
    BlackmarketMailToSellerContent = 0x92A, // s_blackmarket_mail_to_seller_content
    BlackmarketMailToSellerContentSo = 0x92B, // s_blackmarket_mail_to_seller_content_so
    BlackmarketMailToVipsellerContent = 0x92C, // s_blackmarket_mail_to_vipseller_content
    BlackmarketMailToVipsellerContentSoldout = 0x92D, // s_blackmarket_mail_to_vipseller_content_soldout
    BlackmarketMailToSellerContent2 = 0x92E, // s_blackmarket_mail_to_seller_content2
    BlackmarketMailToSellerContentPending = 0x92F, // s_blackmarket_mail_to_seller_content_pe
    BlackmarketMailToSellerContentPending2 = 0x930, // s_blackmarket_mail_to_seller_content_pe
    BlackmarketMailToSellerContent2I = 0x931, // s_blackmarket_mail_to_seller_content2_i
    BlackmarketMailToBuyerTitle = 0x932, // s_blackmarket_mail_to_buyer_title
    BlackmarketMailToBuyerContent = 0x933, // s_blackmarket_mail_to_buyer_content
    BlackmarketMailToCancelTitle = 0x934, // s_blackmarket_mail_to_cancel_title
    BlackmarketMailToCancelTitleExpi = 0x935, // s_blackmarket_mail_to_cancel_title_expi
    BlackmarketMailToCancelTitleHide = 0x936, // s_blackmarket_mail_to_cancel_title_hide
    BlackmarketMailToCancelContent = 0x937, // s_blackmarket_mail_to_cancel_content
    BlackmarketMailToFailAddTitle = 0x938, // s_blackmarket_mail_to_fail_add_title
    BlackmarketMailToFailAddContent = 0x939, // s_blackmarket_mail_to_fail_add_content
    BlackmarketNoticeTryLater = 0x93A, // s_blackmarket_notice_try_later
    BlackmarketUpperRank = 0x93C, // s_blackmarket_upper_rank
    BlackmarketPrice1Unit = 0x93B, // s_blackmarket_price_1_unit
    BlackmarketPeriod = 0x93D, // s_blackmarket_period
    BlackmarketOpenday1Day = 0x93E, // s_blackmarket_openday_1day
    BlackmarketOpenday2Day = 0x93F, // s_blackmarket_openday_2day
    BlackmarketOpendayOver2Day = 0x940, // s_blackmarket_openday_over_2day
    BlackmarketOpendayWithHour = 0x941, // s_blackmarket_openday_with_hour
    BlackmarketOpendayAm = 0x942, // s_blackmarket_openday_am
    BlackmarketOpendayPm = 0x943, // s_blackmarket_openday_pm
    BlackmarketNoticeClose = 0x944, // s_blackmarket_notice_close
    BlackmarketNoticeSellComplete = 0x945, // s_blackmarket_notice_sell_complete
    BlackmarketRemainTimeHhmmss = 0x946, // s_blackmarket_remain_time_hhmmss
    BlackmarketRemainTimeMmss = 0x947, // s_blackmarket_remain_time_mmss
    BlackmarketRemainTimeSs = 0x948, // s_blackmarket_remain_time_ss
    BlackmarketShutdown = 0x949, // s_blackmarket_shutdown
    BlackmarketNoticeFee = 0x94A, // s_blackmarket_notice_fee
    BlackmarketErrorCode = 0x94B, // s_blackmarket_error_code
    BlackmarketErrorDisableRegistitem = 0x94C, // s_blackmarket_error_disable_registitem
    BlackmarketErrorClose = 0x94D, // s_blackmarket_error_close
    BlackmarketErrorAlreadyRemove = 0x94E, // s_blackmarket_error_already_remove
    BlackmarketErrorInvalidSalePrice = 0x94F, // s_blackmarket_error_invalid_sale_price
    BlackmarketErrorInvalidSalePriceRange = 0x950, // s_blackmarket_error_invalid_sale_price_range
    BlackmarketErrorInvalidSaleCount = 0x951, // s_blackmarket_error_invalid_sale_count
    BlackmarketErrorLackSaleCount = 0x952, // s_blackmarket_error_lack_sale_count
    BlackmarketErrorMaxRegisterItem = 0x953, // s_blackmarket_error_max_register_item
    BlackmarketErrorFailRegister = 0x954, // s_blackmarket_error_fail_register
    BlackmarketErrorRegisterNotExist = 0x955, // s_blackmarket_error_register_not_exist_
    BlackmarketErrorAlreadyAdd = 0x956, // s_blackmarket_error_already_add
    BlackmarketErrorSearchInvalidName = 0x957, // s_blackmarket_error_search_invalid_name
    BlackmarketErrorSearchInvalidCoun = 0x958, // s_blackmarket_error_search_invalid_coun
    BlackmarketErrorSellRestrictedByUserLevel = 0x959, // s_blackmarket_error_sell_restricted_by_user_level
    BlackmarketErrorBuyRestrictedByUserLevel = 0x95A, // s_blackmarket_error_buy_restricted_by_user_level
    BlackmarketErrorSellRestrictedByCharCdate = 0x95B, // s_blackmarket_error_sell_restricted_by_char_cdate
    BlackmarketErrorBuyRestrictedByCharCdate = 0x95C, // s_blackmarket_error_buy_restricted_by_char_cdate
    BlackmarketErrorSellRestrictedByUserLevelEx = 0x95D, // s_blackmarket_error_sell_restricted_by_user_level_ex
    BlackmarketErrorBuyRestrictedByUserLevelEx = 0x95E, // s_blackmarket_error_buy_restricted_by_user_level_ex
    TradeErrorSendRestrictedByUserL = 0x95F, // s_trade_error_send_restricted_by_user_l
    TradeErrorRecvRestrictedByUserL = 0x960, // s_trade_error_recv_restricted_by_user_l
    ItemdropErrorRestrictedByUserLev = 0x961, // s_itemdrop_error_restricted_by_user_lev
    ItempickupErrorRestrictedByUserL = 0x962, // s_itempickup_error_restricted_by_user_l
    MsgBlackmarketCompleteRegister = 0x963, // s_msg_blackmarket_complete_register
    MsgBlackmarketCompleteRemove = 0x964, // s_msg_blackmarket_complete_remove
    MsgBlackmarketCompleteBuy = 0x965, // s_msg_blackmarket_complete_buy
    MsgBlackmarketCompleteStopsale = 0x966, // s_msg_blackmarket_complete_stopsale
    MsgBlackmarketAskBuy = 0x967, // s_msg_blackmarket_ask_buy
    MsgBlackmarketAskStopsale = 0x968, // s_msg_blackmarket_ask_stopsale
    MsgBlackmarketNoticeDiscountFee = 0x969, // s_msg_blackmarket_notice_discount_fee
    TooltipBlackmarketSellprice = 0x96A, // s_tooltip_blackmarket_sellprice
    TalkRewardTitle = 0x96B, // s_talk_reward_title
    ItemenchantUnknownErr = 0x96C, // s_itemenchant_unknown_err
    ItemenchantInvalidItem = 0x96D, // s_itemenchant_invalid_item
    ItemenchantExceptItem = 0x96E, // s_itemenchant_except_item
    ItemenchantDamagedItem = 0x96F, // s_itemenchant_damaged_item
    ItemenchantLackIngredient = 0x970, // s_itemenchant_lack_ingredient
    ItemenchantFailDuration = 0x975, // s_itemenchant_fail_duration
    ItemenchantFailSec = 0x971, // s_itemenchant_fail_sec
    ItemenchantFailMin = 0x972, // s_itemenchant_fail_min
    ItemenchantFailHour = 0x973, // s_itemenchant_fail_hour
    ItemenchantFailDay = 0x974, // s_itemenchant_fail_day
    ItemenchantReturnItem = 0x976, // s_itemenchant_return_item
    ItemenchantMessagebox = 0x977, // s_itemenchant_messagebox
    ItemenchantCinematicBtn = 0x978, // s_itemenchant_cinematic_btn
    ItemenchantValidItem = 0x979, // s_itemenchant_valid_item
    ItemenchantDamagedItemTooltip = 0x97A, // s_itemenchant_damaged_item_tooltip
    ItemenchantOptionProp = 0x97B, // s_itemenchant_option_prop
    ItemenchantOptionDamage = 0x97C, // s_itemenchant_option_damage
    ItemenchantOptionLowProp = 0x97D, // s_itemenchant_option_low_prop
    ItemenchantOptionRepair = 0x97E, // s_itemenchant_option_repair
    ItemenchantDamageWarning = 0x97F, // s_itemenchant_damage_warning
    ItemenchantSuccessNotice = 0x980, // s_itemenchant_success_notice
    ItemenchantUseProtector = 0x981, // s_itemenchant_use_protector
    ItemremakeChatMaxoption = 0x982, // s_itemremake_chat_maxoption
    ItemRepackingLimitCount = 0x983, // s_item_repacking_limit_count
    ItemRepackingItemConsumeCount = 0x984, // s_item_repacking_item_consume_count
    ItemRepackingItemLimitDesc = 0x985, // s_item_repacking_item_limit_desc
    ItemRepackingItemConsumeDesc = 0x986, // s_item_repacking_item_consume_desc
    ItemRepackingScrollSuccessDialog = 0x987, // s_item_repacking_scroll_success_dialog
    ShadowworldRemovebuff = 0x988, // s_shadowworld_removebuff
    ShadowworldRemovebuffBefore = 0x989, // s_shadowworld_removebuff_before
    ShadowworldPlayerKill = 0x98A, // s_shadowworld_player_kill
    ShadowworldPlayerKillSlayer = 0x98B, // s_shadowworld_player_kill_slayer
    ShadowworldPlayerKillRuler = 0x98C, // s_shadowworld_player_kill_ruler
    ShadowworldPkzoneMsg = 0x98D, // s_shadowworld_pkzone_msg
    ShadowworldPkzoneChatMsg = 0x98E, // s_shadowworld_pkzone_chat_msg
    ShadowworldSafezoneMsg = 0x98F, // s_shadowworld_safezone_msg
    ShadowworldSafezoneChatMsg = 0x990, // s_shadowworld_safezone_chat_msg
    ShadowworldPkzoneAllert = 0x991, // s_shadowworld_pkzone_allert
    ShadowworldKillLogDie = 0x992, // s_shadowworld_kill_log_die
    ShadowworldKillLogKill = 0x993, // s_shadowworld_kill_log_kill
    PvpStart = 0x994, // s_pvp_start
    PvpFfaDoubleKill = 0x995, // s_pvp_ffa_double_kill
    PvpFfaTripleKill = 0x996, // s_pvp_ffa_triple_kill
    PvpFfaSlayerKill = 0x997, // s_pvp_ffa_slayer_kill
    PvpFfaRulerKill = 0x998, // s_pvp_ffa_ruler_kill
    CommonErrorUnknown = 0x999, // s_common_error_unknown
    CommonDay = 0x99A, // s_common_day
    CommonSec = 0x99B, // s_common_sec
    CommonMin = 0x99C, // s_common_min
    CommonHour = 0x99D, // s_common_hour
    CommonMinSec = 0x99E, // s_common_min_sec
    CommonHourMin = 0x99F, // s_common_hour_min
    CommonHourMinSec = 0x9A0, // s_common_hour_min_sec
    CommonDateWeek = 0x9A1, // s_common_date_week
    CommonMaxSize = 0x9A2, // s_common_max_size
    CommonMinSize = 0x9A3, // s_common_min_size
    CommonTextCount = 0x9A4, // s_common_text_count
    CommonSet = 0x9A5, // s_common_set
    CommonMeso = 0x9A6, // s_common_meso
    CommonMerat = 0x9A7, // s_common_merat
    CommonCash = 0x9A8, // s_common_cash
    CommonPayitem = 0x9A9, // s_common_payitem
    CommonMeratnameCash = 0x9AA, // s_common_meratname_cash
    CommonMeratnameFree = 0x9AB, // s_common_meratname_free
    CommonMeratnameMarket = 0x9AC, // s_common_meratname_market
    CommonMeratnameEvent = 0x9AD, // s_common_meratname_event
    CommonPercent = 0x9AE, // s_common_percent
    BillFormatSumprice = 0x9AF, // s_bill_format_sumprice
    BillFormatSumpriceBeauty = 0x9B0, // s_bill_format_sumprice_beauty
    BillCouponHair = 0x9B1, // s_bill_coupon_hair
    BillCouponFace = 0x9B2, // s_bill_coupon_face
    BillCouponMakeup = 0x9B3, // s_bill_coupon_makeup
    BillCouponSkin = 0x9B4, // s_bill_coupon_skin
    BillCouponEquip = 0x9B5, // s_bill_coupon_equip
    BeautyUseCoupon = 0x9B6, // s_beauty_use_coupon
    BillWarningColoring = 0x9B7, // s_bill_warning_coloring
    BillMeratnameTotal = 0x9B8, // s_bill_meratname_total
    BillMeratpriceTotal = 0x9B9, // s_bill_meratprice_total
    FieldLimitUnknown = 0x9BA, // s_field_limit_unknown
    FieldLimitLevelMin = 0x9BB, // s_field_limit_level_min
    FieldLimitAchieve = 0x9BC, // s_field_limit_achieve
    FieldLimitAdmin = 0x9BD, // s_field_limit_admin
    FieldLimitContentChat = 0x9BE, // s_field_limit_content_chat
    RoomIncreaseTime = 0x9BF, // s_room_increase_time
    RoomIncreaseTimeType2 = 0x9C0, // s_room_increase_time_type2
    RoomDecreaseTime = 0x9C1, // s_room_decrease_time
    RoomPartyErrCooldown = 0x9C2, // s_room_party_err_cooldown
    RoomDungeonTimeUp = 0x9C3, // s_room_dungeon_time_up
    RoomDungeonCooldown = 0x9C4, // s_room_dungeon_cooldown
    ShutdownNotify = 0x9C5, // s_shutdown_notify
    MsgShortcutkeySlotFull = 0x9C6, // s_msg_shortcutkey_slot_full
    MsgShortcutkeyError = 0x9C7, // s_msg_shortcutkey_error
    BootypopupBuffDuration = 0x9C8, // s_bootypopup_buff_duration
    FieldEnteracneDungeonBossTooltip = 0x9C9, // s_field_enteracne_dungeon_boss_tooltip
    FieldEnteracnePartyStatusUnknown = 0x9CA, // s_field_enteracne_party_status_unknown
    FieldEnteracnePartyStatusLevel = 0x9CB, // s_field_enteracne_party_status_level
    FieldEnteracnePartyStatusEtc = 0x9CC, // s_field_enteracne_party_status_etc
    FieldEnteracnePartyNotifyEnterCh = 0x9CD, // s_field_enteracne_party_notify_enter_ch
    FieldEnteracnePartyNotifyResetDu = 0x9CE, // s_field_enteracne_party_notify_reset_du
    FieldEnteranceSoloStatus = 0x9CF, // s_field_enterance_solo_status
    FieldEnterancePartyStatus = 0x9D0, // s_field_enterance_party_status
    DungeonRoomCooldownNextDay = 0x9D1, // s_dungeonRoom_cooldown_nextDay
    DungeonRoomCooldownDayOfWeeks = 0x9D2, // s_dungeonRoom_cooldown_dayOfWeeks
    EmergencyMaintenanceRemainMinute = 0x9D3, // s_emergency_maintenance_remain_minute
    EmergencyMaintenanceRemainSeconds = 0x9D4, // s_emergency_maintenance_remain_seconds
    EmergencyMaintenanceFunctionLimit = 0x9D5, // s_emergency_maintenance_function_limit
    UgcUnloadBannerTooltip = 0x9D6, // s_ugc_unload_banner_tooltip
    MsgTooltipCustomizeColor = 0x9D7, // s_msg_tooltip_customize_color
    MsgTooltipCustomizeBuyRandomColo = 0x9D8, // s_msg_tooltip_customize_buy_random_colo
    MsgTooltipLimitRegisterMeratmarke = 0x9D9, // s_msg_tooltip_limit_register_meratmarke
    MsgTooltipEnablePlayMusic = 0x9DA, // s_msg_tooltip_enable_play_music
    MsgTooltipMusicscoreEnablePlaycount = 0x9DB, // s_msg_tooltip_musicscore_enable_playcount
    MsgTooltipMusicscoreDisablePlaycount = 0x9DC, // s_msg_tooltip_musicscore_disable_playcount
    MsgTooltipMusicscoreEnablePlaycountCustomEmpty = 0x9DD, // s_msg_tooltip_musicscore_enable_playcount_custom_empty
    MsgTooltipMusicscoreCustomUsedItemDesc = 0x9DE, // s_msg_tooltip_musicscore_custom_used_item_desc
    MsgTooltipMusicscoreCustomUsedItemDescGuide = 0x9DF, // s_msg_tooltip_musicscore_custom_used_item_desc_guide
    MsgTooltipMusicscoreCustomEmptyStatDesc = 0x9E0, // s_msg_tooltip_musicscore_custom_empty_stat_desc
    MsgTooltipMusicscoreStatDesc = 0x9E1, // s_msg_tooltip_musicscore_stat_desc
    MsgTooltipMusicscoreWriter = 0x9E2, // s_msg_tooltip_musicscore_writer
    MsgTooltipGemstoneEnableUpgrade = 0x9E3, // s_msg_tooltip_gemstone_enable_upgrade
    UpperHudTokenPocket = 0x9E4, // s_upper_hud_token_pocket
    UpperHudTokenPocketHonor = 0x9E5, // s_upper_hud_token_pocket_honor
    UpperHudTokenPocketKarma = 0x9E6, // s_upper_hud_token_pocket_karma
    UpperHudTokenPocketLu = 0x9E7, // s_upper_hud_token_pocket_lu
    UpperHudTokenPocketHabi = 0x9E8, // s_upper_hud_token_pocket_habi
    UpperHudMerat = 0x9E9, // s_upper_hud_merat
    UpperHudMeratRaw = 0x9EA, // s_upper_hud_merat_raw
    EnterUgcMapResultNoRoom = 0x9EB, // s_enter_ugcmap_result_no_room
    EnterUgcMapResultNotExistRoom = 0x9EC, // s_enter_ugcmap_result_not_exist_room
    EnterUgcMapResultExpired = 0x9ED, // s_enter_ugcmap_result_expired
    EnterUgcMapResultNotExistBuildin = 0x9EE, // s_enter_ugcmap_result_not_exist_buildin
    UgcEditTermsTextContent = 0x9EF, // s_ugc_edit_terms_text_content
    UgcEditTermsAgree = 0x9F0, // s_ugc_edit_terms_agree
    UgcEditDemolishAgree = 0x9F1, // s_ugc_edit_demolish_agree
    UgcEditTermsCouponConsume = 0x9F2, // s_ugc_edit_terms_coupon_consume
    UgcItemEditTerms = 0x9F3, // s_ugc_item_edit_terms
    UgcBannerTerms = 0x9F4, // s_ugc_banner_terms
    UgcProfileTerms = 0x9F5, // s_ugc_profile_terms
    UgcGuildmarkTerms = 0x9F6, // s_ugc_guildmark_terms
    UgcGuildposterTerms = 0x9F7, // s_ugc_guildposter_terms
    BlackmarketTerms = 0x9F8, // s_blackmarket_terms
    BlackmarketTermsTextContent = 0x9F9, // s_blackmarket_terms_text_content
    MeratmarketDesignersTerms = 0x9FA, // s_meratmarket_designers_terms
    MeratmarketDesignersTermsTextCont = 0x9FB, // s_meratmarket_designers_terms_text_cont
    MeratmarketTooltipSellCount = 0x9FC, // s_meratmarket_tooltip_sell_count
    MeratmarketTooltipSellDate = 0x9FD, // s_meratmarket_tooltip_sell_date
    MeratmarketTooltipBookmark = 0x9FE, // s_meratmarket_tooltip_bookmark
    MeratmarketTooltipMyshopCalculate = 0x9FF, // s_meratmarket_tooltip_myshop_calculate
    MeratmarketCompleteBuyItem = 0xA00, // s_meratmarket_complete_buy_item
    MeratmarketCompleteBuyItemAll = 0xA01, // s_meratmarket_complete_buy_item_all
    MeratmarketCompleteBuyItemError = 0xA02, // s_meratmarket_complete_buy_item_error
    MeratmarketCompleteBuyItemAllErr = 0xA03, // s_meratmarket_complete_buy_item_all_err
    MeratmarketCompleteBuyItemAllWit = 0xA04, // s_meratmarket_complete_buy_item_all_wit
    MeratmarketCompleteCheckBalanceSu = 0xA05, // s_meratmarket_complete_check_balance_su
    MeratmarketEmptytextAd = 0xA06, // s_meratmarket_emptytext_ad
    MeratmarketEmptytextNotExist = 0xA07, // s_meratmarket_emptytext_not_exist
    MeratmarketErrorResultBuyLackMer = 0xA08, // s_meratmarket_error_result_buy_lack_mer
    MeratmarketErrorResultBuyLackEmp = 0xA09, // s_meratmarket_error_result_buy_lack_emp
    MeratmarketErrorResultBuyOwnProd = 0xA0A, // s_meratmarket_error_result_buy_own_prod
    MeratmarketErrorResultBuyPriceIn = 0xA0B, // s_meratmarket_error_result_buy_price_in
    MeratmarketErrorResultBuySoldOut = 0xA0C, // s_meratmarket_error_result_buy_sold_out
    MeratmarketErrorResultBuySoldOutPremiumBuylimit = 0xA0D, // s_meratmarket_error_result_buy_sold_out_premium_buylimit
    MeratmarketErrorResultBuyChangeP = 0xA0E, // s_meratmarket_error_result_buy_change_p
    MeratmarketErrorResultBuyCount = 0xA0F, // s_meratmarket_error_result_buy_count
    MeratmarketErrorResultBuyNotSale = 0xA10, // s_meratmarket_error_result_buy_not_sale
    MeratmarketErrorResultAlreadyAdd = 0xA11, // s_meratmarket_error_result_already_add
    MeratmarketErrorResultBuyError = 0xA12, // s_meratmarket_error_result_buy_error
    MeratmarketErrorResultCheckBalanc = 0xA13, // s_meratmarket_error_result_check_balanc
    MeratmarketBuyFormat = 0xA14, // s_meratmarket_buy_format
    MeratmarketBuyTitle = 0xA15, // s_meratmarket_buy_title
    MeratmarketBuySuccessRow = 0xA16, // s_meratmarket_buy_success_row
    MeratmarketBuyFailRow = 0xA17, // s_meratmarket_buy_fail_row
    MeratmarketBuySuccessAll = 0xA18, // s_meratmarket_buy_success_all
    MeratmarketBuySuccessWithFail = 0xA19, // s_meratmarket_buy_success_with_fail
    MeratmarketBuyFailAll = 0xA1A, // s_meratmarket_buy_fail_all
    MeratmarketGiftTitle = 0xA1B, // s_meratmarket_gift_title
    MeratmarketGiftSuccessRow = 0xA1C, // s_meratmarket_gift_success_row
    MeratmarketGiftFailRow = 0xA1D, // s_meratmarket_gift_fail_row
    MeratmarketGiftSuccessAll = 0xA1E, // s_meratmarket_gift_success_all
    MeratmarketGiftSuccessWithFail = 0xA1F, // s_meratmarket_gift_success_with_fail
    MeratmarketGiftFailAll = 0xA20, // s_meratmarket_gift_fail_all
    MeratmarketErrorLackInvenslot = 0xA21, // s_meratmarket_error_lack_invenslot
    MeratmarketErrorAlreadyAddBookmar = 0xA22, // s_meratmarket_error_already_add_bookmar
    MeratmarketErrorRemoveStateSale = 0xA23, // s_meratmarket_error_remove_state_sale
    MeratmarketErrorCalculating = 0xA24, // s_meratmarket_error_calculating
    MeratmarketErrorRegisterPrice = 0xA25, // s_meratmarket_error_register_price
    MeratmarketErrorRegisterInvalidCa = 0xA26, // s_meratmarket_error_register_invalid_ca
    MeratmarketErrorRegisterDisableUg = 0xA27, // s_meratmarket_error_register_disable_ug
    MeratmarketErrorRegisterBlockedUg = 0xA28, // s_meratmarket_error_register_blocked_ug
    MeratmarketErrorBancheckDesc = 0xA29, // s_meratmarket_error_bancheck_desc
    MeratmarketErrorBancheckTags = 0xA2A, // s_meratmarket_error_bancheck_tags
    MeratmarketErrorCommon = 0xA2B, // s_meratmarket_error_common
    MeratmarketErrorAlreadySale = 0xA2C, // s_meratmarket_error_already_sale
    MeratmarketErrorNotSale = 0xA2D, // s_meratmarket_error_not_sale
    MeratmarketErrorNotSaleExpired = 0xA2E, // s_meratmarket_error_not_sale_expired
    MeratmarketErrorSearchResultEmpty = 0xA2F, // s_meratmarket_error_search_result_empty
    MeratmarketErrorSearchResultEmptyByItemlink = 0xA30, // s_meratmarket_error_search_result_empty_by_itemlink
    MeratmarketErrorSearchResultEmptyByBanner = 0xA31, // s_meratmarket_error_search_result_empty_by_banner
    MeratmarketErrorSearchResultWith = 0xA32, // s_meratmarket_error_search_result_with_
    MeratmarketErrorBuyOwnerProduct = 0xA33, // s_meratmarket_error_buy_owner_product
    MeratmarketErrorBuySoldout = 0xA34, // s_meratmarket_error_buy_soldout
    MeratmarketErrorAddBasketByBuyli = 0xA35, // s_meratmarket_error_add_basket_by_buyli
    MeratmarketErrorBuySoldoutPremium = 0xA36, // s_meratmarket_error_buy_soldout_premium
    MeratmarketBookmarkAddComplete = 0xA37, // s_meratmarket_bookmark_add_complete
    MeratmarketBookmarkLimitMaxcount = 0xA38, // s_meratmarket_bookmark_limit_maxcount
    MeratmarketBookmarkInputSearch = 0xA39, // s_meratmarket_bookmark_input_search
    MeratmarketBookmarkEmptyProducts = 0xA3A, // s_meratmarket_bookmark_empty_products
    MeratmarketBasketLimitMaxcount = 0xA3B, // s_meratmarket_basket_limit_maxcount
    MeratmarketBasketEmptyBuyall = 0xA3C, // s_meratmarket_basket_empty_buyall
    MeratmarketBasketCompleteAdd = 0xA3D, // s_meratmarket_basket_complete_add
    MeratmarketMyshopNoticeSellRestrict = 0xA3E, // s_meratmarket_myshop_notice_sell_restri
    MeratmarketMyshopNoticeSellRestrictTitle = 0xA3F, // s_meratmarket_myshop_notice_sell_restrict_title
    MeratmarketMyshopNoticeRestrictBy = 0xA40, // s_meratmarket_myshop_notice_restrict_by
    MeratmarketMyshopSellCount = 0xA41, // s_meratmarket_myshop_sell_count
    MeratmarketMyshopHistoryBuyDate = 0xA42, // s_meratmarket_myshop_history_buy_date
    MeratmarketMyshopLimitRegisterCou = 0xA43, // s_meratmarket_myshop_limit_register_cou
    MeratmarketMyshopNoticeCalculate = 0xA44, // s_meratmarket_myshop_notice_calculate
    MeratmarketMyshopAskStopsale = 0xA45, // s_meratmarket_myshop_ask_stopsale
    MeratmarketMyshopAskRemove = 0xA46, // s_meratmarket_myshop_ask_remove
    MeratmarketMyshopEmptyCalculate = 0xA47, // s_meratmarket_myshop_empty_calculate
    MeratmarketMyshopHistoryRow = 0xA48, // s_meratmarket_myshop_history_row
    MeratmarketMyshopHistoryEnableCol = 0xA49, // s_meratmarket_myshop_history_enable_col
    MeratmarketMyshopHistoryScheduleC = 0xA4A, // s_meratmarket_myshop_history_schedule_c
    MeratmarketMyshopHistoryTitle = 0xA4B, // s_meratmarket_myshop_history_title
    MeratmarketMyshopCompleteStopsale = 0xA4C, // s_meratmarket_myshop_complete_stopsale
    MeratmarketMyshopCompleteRegister = 0xA4D, // s_meratmarket_myshop_complete_register
    MeratmarketMyshopCompleteRemove = 0xA4E, // s_meratmarket_myshop_complete_remove
    MeratmarketMyshopCompleteResale = 0xA4F, // s_meratmarket_myshop_complete_resale
    MeratmarketMyshopCompleteCalculate = 0xA50, // s_meratmarket_myshop_complete_calculate
    MeratmarketFreeResaleConfirm = 0xA51, // s_meratmarket_free_resale_confirm
    MeratmarketRegisterLimitDesc = 0xA52, // s_meratmarket_register_limit_desc
    MeratmarketRegisterSaleDay = 0xA53, // s_meratmarket_register_sale_day
    MeratmarketRegisterAdHourAndPric = 0xA54, // s_meratmarket_register_ad_hour_and_pric
    MeratmarketRegisterRoyalty = 0xA55, // s_meratmarket_register_royalty
    MeratmarketRegisterNoticePrice = 0xA56, // s_meratmarket_register_notice_price
    MeratmarketRegisterFee = 0xA57, // s_meratmarket_register_fee
    MeratmarketRegisterErrorAddNotFi = 0xA58, // s_meratmarket_register_error_add_not_fi
    MeratmarketRegisterErrorAddAlread = 0xA59, // s_meratmarket_register_error_add_alread
    MeratmarketBillTotalFee = 0xA5A, // s_meratmarket_bill_total_fee
    MeratmarketPriceday = 0xA5B, // s_meratmarket_priceday
    MeratmarketPricedayLimitless = 0xA5C, // s_meratmarket_priceday_limitless
    MeratmarketGiftMailSender = 0xA5D, // s_meratmarket_gift_mail_sender
    MeratmarketGiftMailTitle = 0xA5E, // s_meratmarket_gift_mail_title
    MeratmarketGiftMailContent = 0xA5F, // s_meratmarket_gift_mail_content
    MeratmarketNoticeDefault = 0xA60, // s_meratmarket_notice_default
    MeratmarketErrorResultGiftNotExi = 0xA61, // s_meratmarket_error_result_gift_not_exi
    MeratmarketErrorResultGiftTarget = 0xA62, // s_meratmarket_error_result_gift_target_
    MeratmarketErrorResultGiftAdmin = 0xA63, // s_meratmarket_error_result_gift_admin
    MeratmarketAlreadyInModelhouse = 0xA64, // s_meratmarket_already_in_modelhouse
    MeratmarketMovetoModelhouseForbidd = 0xA65, // s_meratmarket_moveto_modelhouse_forbidd
    MesoMarketMailToSender = 0xA66, // s_mesoMarket_mail_to_sender
    MesoMarketMailToCancelTitle = 0xA67, // s_mesoMarket_mail_to_cancel_title
    MesoMarketMailToCancelContent = 0xA68, // s_mesoMarket_mail_to_cancel_content
    MesoMarketMailToSellerTitle = 0xA69, // s_mesoMarket_mail_to_seller_title
    MesoMarketMailToSellerContent = 0xA6A, // s_mesoMarket_mail_to_seller_content
    MesoMarketMailToBuyerTitle = 0xA6B, // s_mesoMarket_mail_to_buyer_title
    MesoMarketMailToBuyerContent = 0xA6C, // s_mesoMarket_mail_to_buyer_content
    MentoringNewMentorMailSender = 0xA6D, // s_mentoring_new_mentor_mail_sender
    MentoringNewMentorMailTitle = 0xA6E, // s_mentoring_new_mentor_mail_title
    MentoringNewMentorMailContent = 0xA6F, // s_mentoring_new_mentor_mail_content
    CashshopInvenpickup = 0xA70, // s_cashshop_invenpickup
    CashshopInvenpickupRefund = 0xA71, // s_cashshop_invenpickup_refund
    CashshopRefund = 0xA72, // s_cashshop_refund
    CashshopErrorOnetimeBuy = 0xA73, // s_cashshop_error_onetime_buy
    CashshopExpandInvenWarning = 0xA74, // s_cashshop_expand_inven_warning
    CashshopExpandInvenTabWarning = 0xA75, // s_cashshop_expand_inven_tab_warning
    CashshopExpandCharacterSlotWarnin = 0xA76, // s_cashshop_expand_character_slot_warnin
    CashshopDbclickInfo = 0xA77, // s_cashshop_dbclick_info
    CashshopLackBalance = 0xA78, // s_cashshop_lack_balance
    CashshopBasket = 0xA79, // s_cashshop_basket
    CashshopBuySuccess = 0xA7A, // s_cashshop_buy_success
    CashshopGetCouponSuccess = 0xA7B, // s_cashshop_get_coupon_success
    CashshopBuySuccessSendMail = 0xA7C, // s_cashshop_buy_success_send_mail
    CashshopGiftSuccess = 0xA7D, // s_cashshop_gift_success
    CashshopRefundSuccess = 0xA7E, // s_cashshop_refund_success
    CashshopPickupSuccess = 0xA7F, // s_cashshop_pickup_success
    CashshopGiftMessage = 0xA80, // s_cashshop_gift_message
    CashshopGiftComfirm = 0xA81, // s_cashshop_gift_comfirm
    CashshopErrUnknown = 0xA82, // s_cashshop_err_unknown
    CashshopErrClosed = 0xA83, // s_cashshop_err_closed
    CashshopErrClosedPubtest = 0xA84, // s_cashshop_err_closed_pubtest
    CashshopErrDisconnect = 0xA85, // s_cashshop_err_disconnect
    CashshopErrNotReadyProduct = 0xA86, // s_cashshop_err_not_ready_product
    CashshopErrInvalidGiftName = 0xA87, // s_cashshop_err_invalid_gift_name
    CashshopErrSameAccount = 0xA88, // s_cashshop_err_same_account
    CashshopErrNoEmptySlot = 0xA89, // s_cashshop_err_no_empty_slot
    CashshopErrNoEmptySlotPickupJp = 0xA8A, // s_cashshop_err_no_empty_slot_pickup_jp
    CashshopErrNotPurchaseDate = 0xA8B, // s_cashshop_err_not_purchase_date
    CashshopErrCannotGiftProduct = 0xA8C, // s_cashshop_err_cannot_gift_product
    CashshopErrCannotRefundProduct = 0xA8D, // s_cashshop_err_cannot_refund_product
    CashshopErrNullCashProductData = 0xA8E, // s_cashshop_err_null_cash_product_data
    CashshopErrNullNismsProduct = 0xA8F, // s_cashshop_err_null_nisms_product
    CashshopErrRequesting = 0xA90, // s_cashshop_err_requesting
    CashshopErrInvalidAuthorizationTo = 0xA91, // s_cashshop_err_invalid_authorization_to
    CashshopErrBalanceUnknown = 0xA92, // s_cashshop_err_balance_unknown
    CashshopErrBalanceBlockUser = 0xA93, // s_cashshop_err_balance_block_user
    CashshopErrBalanceMaintenance = 0xA94, // s_cashshop_err_balance_maintenance
    CashshopErrBalanceNotfindUser = 0xA95, // s_cashshop_err_balance_notfind_user
    CashshopErrPurchaseUnknown = 0xA96, // s_cashshop_err_purchase_unknown
    CashshopErrPurchaseTotalSaleCoun = 0xA97, // s_cashshop_err_purchase_total_sale_coun
    CashshopErrPurchaseSaleCountOver = 0xA98, // s_cashshop_err_purchase_sale_count_over
    CashshopErrPurchaseInvalidGame = 0xA99, // s_cashshop_err_purchase_invalid_game
    CashshopErrPurchaseInvalidGiftPr = 0xA9A, // s_cashshop_err_purchase_invalid_gift_pr
    CashshopErrPurchaseEventcashProtectGift = 0xA9B, // s_cashshop_err_purchase_eventcash_protect_gift
    CashshopErrPurchaseEventcashProtectBuy = 0xA9C, // s_cashshop_err_purchase_eventcash_protect_buy
    CashshopErrPurchaseMaintenance = 0xA9D, // s_cashshop_err_purchase_maintenance
    CashshopErrPurchaseLimitPurchase = 0xA9E, // s_cashshop_err_purchase_limit_purchase
    CashshopErrPurchaseLockCashuse = 0xA9F, // s_cashshop_err_purchase_lock_cashuse
    CashshopErrPurchaseBlockUser = 0xAA0, // s_cashshop_err_purchase_block_user
    CashshopErrPurchaseNotfindUser = 0xAA1, // s_cashshop_err_purchase_notfind_user
    CashshopErrPurchaseLackBalance = 0xAA2, // s_cashshop_err_purchase_lack_balance
    CashshopErrPurchaseInvalidCashDa = 0xAA3, // s_cashshop_err_purchase_invalid_cash_da
    CashshopErrPurchaseInvalidSalePr = 0xAA4, // s_cashshop_err_purchase_invalid_sale_pr
    CashshopErrPurchaseInvalidCashUs = 0xAA5, // s_cashshop_err_purchase_invalid_cash_us
    CashshopErrInventoryInquiryUnknow = 0xAA6, // s_cashshop_err_inventory_inquiry_unknow
    CashshopErrInventoryInquiryMainte = 0xAA7, // s_cashshop_err_inventory_inquiry_mainte
    CashshopErrInventoryPickupUnknown = 0xAA8, // s_cashshop_err_inventory_pickup_unknown
    CashshopErrInventoryPickupNoInve = 0xAA9, // s_cashshop_err_inventory_pickup_no_inve
    CashshopErrInventoryPickupLackcou = 0xAAA, // s_cashshop_err_inventory_pickup_lackcou
    CashshopErrInventoryPickupMainten = 0xAAB, // s_cashshop_err_inventory_pickup_mainten
    CashshopErrRefundUnknown = 0xAAC, // s_cashshop_err_refund_unknown
    CashshopErrRefundDisableRefund = 0xAAD, // s_cashshop_err_refund_disable_refund
    CashshopErrRefundOverDate = 0xAAE, // s_cashshop_err_refund_over_date
    CashshopErrRefundNoInventory = 0xAAF, // s_cashshop_err_refund_no_inventory
    CashshopErrRefundGift = 0xAB0, // s_cashshop_err_refund_gift
    CashshopErrGiftLimit = 0xAB1, // s_cashshop_err_gift_limit
    CashshopErrGiftAge = 0xAB2, // s_cashshop_err_gift_age
    CashshopErrGiftSendBlock = 0xAB3, // s_cashshop_err_gift_send_block
    CashshopErrGiftRecvBlock = 0xAB4, // s_cashshop_err_gift_recv_block
    CashshopErrGiftUnknown = 0xAB5, // s_cashshop_err_gift_unknown
    CashshopErrGiftSaleCountOver = 0xAB6, // s_cashshop_err_gift_sale_count_over
    PartydpsNoticeHistoryPrefix = 0xAB7, // s_partydps_notice_history_prefix
    PartydpsNoticeHistoryRow = 0xAB8, // s_partydps_notice_history_row
    PartydpsNoticeHistoryTotalTime = 0xAB9, // s_partydps_notice_history_total_time
    MsgboxFormatProfileCharDetail = 0xABA, // s_msgbox_format_profile_char_detail
    MessengerComfirmChatSuper = 0xABB, // s_messenger_comfirm_chat_super
    MessengerComfirmChatWorld = 0xABC, // s_messenger_comfirm_chat_world
    MessengerComfirmChatChannel = 0xABD, // s_messenger_comfirm_chat_channel
    MessengerNoShowMessagebox = 0xABE, // s_messenger_no_show_messagebox
    MessengerWhisper = 0xABF, // s_messenger_whisper
    MessengerClub = 0xAC0, // s_messenger_club
    MessengerPartyChatballoonPrefix = 0xAC1, // s_messenger_party_chatballoon_prefix
    MessengerGuildChatballoonPrefix = 0xAC2, // s_messenger_guild_chatballoon_prefix
    GemErrorInventoryFull = 0xAC3, // s_gem_error_inventory_full
    GemErrorInvalidSlot = 0xAC4, // s_gem_error_InvalidSlot
    GemErrorInvalidItem = 0xAC5, // s_gem_error_InvalidItem
    GemErrorExpired = 0xAC6, // s_gem_error_Expired
    GemErrorPcBang = 0xAC7, // s_gem_error_PCBang
    GemErrorUnknown = 0xAC8, // s_gem_error_unknown
    RoomExitUgcIndoor = 0xAC9, // s_room_exit_ugc_indoor
    RoomExitBonus = 0xACA, // s_room_exit_bonus
    RoomExitMassiveEvent = 0xACB, // s_room_exit_massive_event
    RoomExitPvpZone = 0xACC, // s_room_exit_pvp_zone
    RoomExitMsgUgcIndoor = 0xACD, // s_room_exit_msg_ugc_indoor
    RoomExitMsgBossDungeon = 0xACE, // s_room_exit_msg_boss_dungeon
    RoomExitMsgPartyDungeon = 0xACF, // s_room_exit_msg_party_dungeon
    RoomExitMsgShadowExpeditionDunge = 0xAD0, // s_room_exit_msg_shadow_expedition_dunge
    RoomExitMsgBonus = 0xAD1, // s_room_exit_msg_bonus
    RoomExitMsgMassiveEvent = 0xAD2, // s_room_exit_msg_massive_event
    RoomExitMsgPvpZone = 0xAD3, // s_room_exit_msg_pvp_zone
    RoomExitMsgPvpField = 0xAD4, // s_room_exit_msg_pvp_field
    RoomExitMsgDesign = 0xAD5, // s_room_exit_msg_design
    RoomExitMsgBlueprint = 0xAD6, // s_room_exit_msg_blueprint
    RoomExitMsgBlueprintPreview = 0xAD7, // s_room_exit_msg_blueprint_preview
    ItemLinkMeratmarket = 0xAD8, // s_itemlink_meratmarket
    ItemLinkCashshop = 0xAD9, // s_itemlink_cashshop
    WaitingTicketMessage = 0xADA, // s_waitingticket_message
    WaitingTicketCancel = 0xADB, // s_waitingticket_cancel
    DebugInvincible = 0xADC, // s_debug_invincible
    DebugGodMode = 0xADD, // s_debug_god_mode
    DebugInvisibleAll = 0xADE, // s_debug_invisible_all
    DebugInvisibleNpc = 0xADF, // s_debug_invisible_npc
    DebugInstantDeath = 0xAE0, // s_debug_instant_death
    SuperChatUseCoupon = 0xAE1, // s_superchat_use_coupon
    WorldChatUseCoupon = 0xAE2, // s_worldchat_use_coupon
    ChannelChatUseCoupon = 0xAE3, // s_channelchat_use_coupon
    WeddingChatUseCoupon = 0xAE4, // s_weddingchat_use_coupon
    RevivalUseCoupon = 0xAE5, // s_revival_use_coupon
    PetNameChangeUseCoupon = 0xAE6, // s_pet_name_change_use_coupon
    AlreadyloginuserRequestKick = 0xAE7, // s_alreadyloginuser_request_kick
    AlreadyloginuserResponseKick = 0xAE8, // s_alreadyloginuser_response_kick
    LauchingfestivalOnetimecharacter = 0xAE9, // s_lauchingfestival_onetimecharacter
    PcbangPlayTime1 = 0xAEA, // s_pcbang_play_time1
    PcbangPlayTime2 = 0xAEB, // s_pcbang_play_time2
    PcbangCantTutorialField = 0xAEC, // s_pcbang_cant_tutorial_field
    PcbangNoPcbang = 0xAED, // s_pcbang_no_pcbang
    PcbangGetGiftItem = 0xAEE, // s_pcbang_get_gift_item
    PcbangGetPlayItem = 0xAEF, // s_pcbang_get_play_item
    PlayTimeWarnning = 0xAF0, // s_play_time_warnning
    PlayTimeWarnningFatigueHalfBegin = 0xAF1, // s_play_time_warnning_fatigue_half_begin
    PlayTimeWarnningFatigueHalf = 0xAF2, // s_play_time_warnning_fatigue_half
    PlayTimeWarnningFatigueMax = 0xAF3, // s_play_time_warnning_fatigue_max
    PlayTimeWarnningChat = 0xAF4, // s_play_time_warnning_chat
    NametagSymbolNone = 0xAF5, // s_nametag_symbol_none
    NametagSymbolEnchant = 0xAF6, // s_nametag_symbol_enchant
    NametagSymbolSeller = 0xAF7, // s_nametag_symbol_seller
    NametagSymbolGuild = 0xAF8, // s_nametag_symbol_guild
    NametagSymbolArchitect = 0xAF9, // s_nametag_symbol_architect
    NametagSymbolTrophy = 0xAFA, // s_nametag_symbol_trophy
    NametagSymbolFisher = 0xAFB, // s_nametag_symbol_fisher
    NametagSymbolMusician = 0xAFC, // s_nametag_symbol_musician
    NametagSymbolBalrog = 0xAFD, // s_nametag_symbol_balrog
    NametagSymbolPioneer = 0xAFE, // s_nametag_symbol_pioneer
    NametagSymbolOneyear = 0xAFF, // s_nametag_symbol_oneyear
    NametagSymbolLevel = 0xB00, // s_nametag_symbol_level
    NametagSymbolEnchantDesc = 0xB01, // s_nametag_symbol_enchant_desc
    NametagSymbolSellerDesc = 0xB02, // s_nametag_symbol_seller_desc
    NametagSymbolGuildDesc = 0xB03, // s_nametag_symbol_guild_desc
    NametagSymbolArchitectDesc = 0xB04, // s_nametag_symbol_architect_desc
    NametagSymbolTrophyDesc = 0xB05, // s_nametag_symbol_trophy_desc
    NametagSymbolFisherDesc = 0xB06, // s_nametag_symbol_fisher_desc
    NametagSymbolMusicianDesc = 0xB07, // s_nametag_symbol_musician_desc
    NametagSymbolBalrogDesc = 0xB08, // s_nametag_symbol_balrog_desc
    NametagSymbolPioneerDesc = 0xB09, // s_nametag_symbol_pioneer_desc
    NametagSymbolOneyearDesc = 0xB0A, // s_nametag_symbol_oneyear_desc
    NametagSymbolLevelDesc = 0xB0B, // s_nametag_symbol_level_desc
    FieldbossRewardAssistbonusNotify = 0xB0C, // s_fieldboss_reward_assistbonus_notify
    MacroPenaltyRewardNotify = 0xB0D, // s_macro_penalty_reward_notify
    UserTriggerOverMaxLength = 0xB0E, // s_user_trigger_over_max_length
    UserTriggerOverMaxState = 0xB0F, // s_user_trigger_over_max_state
    UserTriggerOverMaxEnterAction = 0xB10, // s_user_trigger_over_max_enter_action
    UserTriggerOverMaxCondition = 0xB11, // s_user_trigger_over_max_condition
    UserTriggerOverMaxConditionActio = 0xB12, // s_user_trigger_over_max_condition_actio
    UserTriggerItemTooltipEnableTrig = 0xB13, // s_user_trigger_item_tooltip_enable_trig
    UserTriggerItemTooltipStateChang = 0xB14, // s_user_trigger_item_tooltip_state_chang
    UserTriggerDebuggingMsg = 0xB15, // s_user_trigger_debugging_msg
    UserTriggerErrorMsgSystemError = 0xB16, // s_user_trigger_error_msg_system_error
    UserTriggerErrorMsgCubePosition = 0xB17, // s_user_trigger_error_msg_cube_position
    UserTriggerAskMsgRollback = 0xB18, // s_user_trigger_ask_msg_rollback
    UserTriggerAskMsgClearContents = 0xB19, // s_user_trigger_ask_msg_clear_contents
    UserTriggerAskMsgSave = 0xB1A, // s_user_trigger_ask_msg_save
    UserTriggerAskMsgClose = 0xB1B, // s_user_trigger_ask_msg_close
    UserTriggerMsgShowDebug = 0xB1C, // s_user_trigger_msg_show_debug
    UserTriggerMsgRollback = 0xB1D, // s_user_trigger_msg_rollback
    HomePasswordOnMsg = 0xB1E, // s_home_password_on_msg
    HomePasswordOffMsg = 0xB1F, // s_home_password_off_msg
    HomePasswordOffConfirm = 0xB20, // s_home_password_off_confirm
    HomePasswordInput = 0xB21, // s_home_password_input
    HomePasswordStateOn = 0xB22, // s_home_password_state_on
    HomePasswordStateOff = 0xB23, // s_home_password_state_off
    HomePasswordStringError = 0xB24, // s_home_password_string_error
    HomePasswordMismatch = 0xB25, // s_home_password_mismatch
    HomePasswordBlockTime = 0xB26, // s_home_password_block_time
    HomePasswordOnChatMsg = 0xB27, // s_home_password_on_chat_msg
    HomePasswordOffChatMsg = 0xB28, // s_home_password_off_chat_msg
    HomePasswordEnterFieldChatMsg = 0xB29, // s_home_password_enter_field_chat_msg
    HomePasswordUserOutChatMsg = 0xB2A, // s_home_password_user_out_chat_msg
    HomePasswordExpireDateChatMsg = 0xB2B, // s_home_password_expire_date_chat_msg
    HomePasswordUserOutButton = 0xB2C, // s_home_password_user_out_button
    HomeCommendSuccess = 0xB2D, // s_home_commend_success
    HomeCommendSendConfirm = 0xB2E, // s_home_commend_send_confirm
    TeamPvpRedTeamName = 0xB2F, // s_team_pvp_red_team_name
    TeamPvpBlueTeamName = 0xB30, // s_team_pvp_blue_team_name
    TeamPvpNorth = 0xB31, // s_team_pvp_north
    TeamPvpCenter = 0xB32, // s_team_pvp_center
    TeamPvpSouth = 0xB33, // s_team_pvp_south
    TeamPvpConquered = 0xB34, // s_team_pvp_conquered
    TeamPvpRedPlayerPlunder = 0xB35, // s_team_pvp_red_player_plunder
    TeamPvpBluePlayerPlunder = 0xB36, // s_team_pvp_blue_player_plunder
    TeamPvpWinnerReward = 0xB37, // s_team_pvp_winner_reward
    TeamPvpLoserReward = 0xB38, // s_team_pvp_loser_reward
    RenderScreenRestorationFailed = 0xB39, // s_render_screen_restoration_failed
    RenderGraphiccardError = 0xB3A, // s_render_graphiccard_error
    WindowServiceAuthError = 0xB3B, // s_window_service_auth_error
    UtilMemDepletionUrl = 0xB3C, // s_util_mem_depletion_url
    UtilMemDepletionPhyx = 0xB3D, // s_util_mem_depletion_phyx
    UtilMemDepletionDefault = 0xB3E, // s_util_mem_depletion_default
    PartysearchSortPartyCreateHi = 0xB3F, // s_partysearch_sort_party_create_hi
    PartysearchSortPartyCreateLow = 0xB40, // s_partysearch_sort_party_create_low
    PartysearchSortPartyLevelHi = 0xB41, // s_partysearch_sort_party_level_hi
    PartysearchSortPartyLevelLow = 0xB42, // s_partysearch_sort_party_level_low
    PartysearchSortMemeberCountHi = 0xB43, // s_partysearch_sort_memeber_count_hi
    PartysearchSortMemeberCountLow = 0xB44, // s_partysearch_sort_memeber_count_low
    PartysearchSortMemeberCreateHi = 0xB45, // s_partysearch_sort_memeber_create_hi
    PartysearchSortMemeberCreateLow = 0xB46, // s_partysearch_sort_memeber_create_low
    PartysearchCompleteRegisterPartyse = 0xB47, // s_partysearch_complete_register_partyse
    PartysearchCompleteRegisterMembers = 0xB48, // s_partysearch_complete_register_members
    PartysearchCompleteRemovePartysear = 0xB49, // s_partysearch_complete_remove_partysear
    PartysearchCompleteRemoveMembersea = 0xB4A, // s_partysearch_complete_remove_membersea
    PartysearchAskPartyJoinAlreadyMe = 0xB4B, // s_partysearch_ask_party_join_already_me
    PartysearchErrSearchResultEmpty = 0xB4C, // s_partysearch_err_search_result_empty
    PartysearchErrSearchResultWithBa = 0xB4D, // s_partysearch_err_search_result_with_ba
    PartysearchErrWhisperMyself = 0xB4E, // s_partysearch_err_whisper_myself
    PartysearchErrPartyJoinMyself = 0xB4F, // s_partysearch_err_party_join_myself
    PartysearchErrPartyJoinAlready = 0xB50, // s_partysearch_err_party_join_already
    PartysearchErrPartyJoinLackGears = 0xB51, // s_partysearch_err_party_join_lack_gears
    PartysearchErrPartyInviteMyself = 0xB52, // s_partysearch_err_party_invite_myself
    PartysearchErrPartyInviteNotChie = 0xB53, // s_partysearch_err_party_invite_not_chie
    PartysearchErrMemebersearchCantRegisterNotChief = 0xB54, // s_partysearch_err_memebersearch_cant_register_not_chief
    PartysearchErrMemebersearchCantRegisterAlready = 0xB55, // s_partysearch_err_memebersearch_cant_register_already
    PartysearchErrMemebersearchCantRegisterMaxMemebercount = 0xB56, // s_partysearch_err_memebersearch_cant_register_max_memebercount
    PartysearchErrMemebersearchCantRegisterLimitCondition = 0xB57, // s_partysearch_err_memebersearch_cant_register_limit_condition
    PartysearchErrMemebersearchCantModifyNotChief = 0xB58, // s_partysearch_err_memebersearch_cant_modify_not_chief
    PartysearchErrMemebersearchCantModifyNoRegister = 0xB59, // s_partysearch_err_memebersearch_cant_modify_no_register
    PartysearchErrPartysearchCantRegisterInParty = 0xB5A, // s_partysearch_err_partysearch_cant_register_in_party
    PartysearchErrPartysearchCantRegisterLimitCondition = 0xB5B, // s_partysearch_err_partysearch_cant_register_limit_condition
    PartysearchErrPartysearchCantRegisterAlready = 0xB5C, // s_partysearch_err_partysearch_cant_register_already
    PartysearchErrPartysearchCantModifyInParty = 0xB5D, // s_partysearch_err_partysearch_cant_modify_in_party
    PartysearchErrPartysearchCantModifyNoRegister = 0xB5E, // s_partysearch_err_partysearch_cant_modify_no_register
    PartysearchErrDungeonCooldown = 0xB5F, // s_partysearch_err_dungeon_cooldown
    PartysearchErrServerLastaction = 0xB60, // s_partysearch_err_server_lastaction
    PartysearchErrServerNotChief = 0xB61, // s_partysearch_err_server_not_chief
    PartysearchErrServerMaxMember = 0xB62, // s_partysearch_err_server_max_member
    PartysearchErrServerDb = 0xB63, // s_partysearch_err_server_db
    PartysearchErrServerAlreadyRegist = 0xB64, // s_partysearch_err_server_already_regist
    PartysearchErrServerInvalidType = 0xB65, // s_partysearch_err_server_invalid_type
    PartysearchErrServerInParty = 0xB66, // s_partysearch_err_server_in_party
    PartysearchErrServerRegistring = 0xB67, // s_partysearch_err_server_registring
    PartysearchErrServerCode = 0xB6C, // s_partysearch_err_server_code
    PartysearchErrServerBanwordTitle = 0xB68, // s_partysearch_err_server_banword_title
    PartysearchErrServerBanwordFindwo = 0xB69, // s_partysearch_err_server_banword_findwo
    PartysearchErrServerPartyInvited = 0xB6A, // s_partysearch_err_server_party_invited
    PartysearchErrServerBlocked = 0xB6B, // s_partysearch_err_server_blocked
    PartysearchregisterErrTitle = 0xB6D, // s_partysearchregister_err_title
    PartysearchregisterInvalidDungeonle = 0xB6E, // s_partysearchregister_invalid_dungeonle
    PartysearchregisterInvalidDungeonda = 0xB6F, // s_partysearchregister_invalid_dungeonda
    PartysearchregisterAskRemove = 0xB70, // s_partysearchregister_ask_remove
    ErrCashRecallCannotNow = 0xB71, // s_err_cash_recall_cannot_now
    ErrCashRecallProhibitMap = 0xB72, // s_err_cash_recall_prohibit_map
    ErrCashRecallCannotPlace = 0xB73, // s_err_cash_recall_cannot_place
    ErrCashRecallNotGuild = 0xB74, // s_err_cash_recall_not_guild
    ErrCashRecallNotParty = 0xB75, // s_err_cash_recall_not_party
    ErrCashRecallNoGuildmember = 0xB76, // s_err_cash_recall_no_guildmember
    ErrCashRecallNoPartymember = 0xB77, // s_err_cash_recall_no_partymember
    ErrCashRecallNoWeddingmember = 0xB78, // s_err_cash_recall_no_weddingmember
    ErrCashRecallOverflow = 0xB79, // s_err_cash_recall_overflow
    ErrCashRecallCannotDead = 0xB7A, // s_err_cash_recall_cannot_dead
    ErrCashRecallCannotBattle = 0xB7B, // s_err_cash_recall_cannot_battle
    CashRecallConfirm = 0xB7C, // s_cash_recall_confirm
    CashRecallPartyNotice = 0xB7D, // s_cash_recall_party_notice
    CashRecallGuildNotice = 0xB7E, // s_cash_recall_guild_notice
    CashRecallExpiredNotice = 0xB7F, // s_cash_recall_expired_notice
    CashRecallEndNotice = 0xB80, // s_cash_recall_end_notice
    CashRecallOtherContinent = 0xB81, // s_cash_recall_other_continent
    EnchantscrollOpenscroll = 0xB82, // s_enchantscroll_openscroll
    EnchantscrollDescEnchant = 0xB83, // s_enchantscroll_desc_enchant
    EnchantscrollDescRestore = 0xB84, // s_enchantscroll_desc_restore
    EnchantscrollDescRepair = 0xB85, // s_enchantscroll_desc_repair
    EnchantscrollDescRandomEnchant = 0xB86, // s_enchantscroll_desc_random_enchant
    EnchantscrollLimit = 0xB87, // s_enchantscroll_limit
    EnchantscrollItemname = 0xB88, // s_enchantscroll_itemname
    EnchantscrollBreaking = 0xB89, // s_enchantscroll_breaking
    EnchantscrollSuccessprop = 0xB8A, // s_enchantscroll_successprop
    EnchantscrollOk = 0xB8B, // s_enchantscroll_ok
    EnchantscrollInvalidScroll = 0xB8C, // s_enchantscroll_invalid_scroll
    EnchantscrollInvalidItem = 0xB8D, // s_enchantscroll_invalid_item
    EnchantscrollBreakingItem = 0xB8E, // s_enchantscroll_breaking_item
    EnchantscrollInvalidLevel = 0xB8F, // s_enchantscroll_invalid_level
    EnchantscrollInvalidSlot = 0xB90, // s_enchantscroll_invalid_slot
    EnchantscrollInvalidRank = 0xB91, // s_enchantscroll_invalid_rank
    EnchantscrollInvalidGrade = 0xB92, // s_enchantscroll_invalid_grade
    EnchantscrollNotBreakingItem = 0xB93, // s_enchantscroll_not_breaking_item
    SystemmailNotifyOntimeConfirm = 0xB94, // s_systemmail_notify_ontime_confirm
    ServerNameScania = 0xB95, // s_server_name_scania
    ServerNameMardia = 0xB96, // s_server_name_mardia
    ServerNameHasello = 0xB97, // s_server_name_hasello
    ServerNameWindia = 0xB98, // s_server_name_windia
    ServerNameFlata = 0xB99, // s_server_name_flata
    RecoveryMailTitle = 0xB9A, // s_recovery_mail_title
    RecoveryMailContent = 0xB9B, // s_recovery_mail_content
    RecoveryMailSender = 0xB9C, // s_recovery_mail_sender
    TradeRecoveryMailTitle = 0xB9D, // s_trade_recovery_mail_title
    TradeRecoveryMailContent = 0xB9E, // s_trade_recovery_mail_content
    TradeRecoveryMailSender = 0xB9F, // s_trade_recovery_mail_sender
    DollRecoveryMailTitle = 0xBA0, // s_doll_recovery_mail_title
    DollRecoveryMailContent = 0xBA1, // s_doll_recovery_mail_content
    DollRecoveryMailSender = 0xBA2, // s_doll_recovery_mail_sender
    FunctionCubeErrorInvalidCube = 0xBA3, // s_function_cube_error_invalid_cube
    FunctionCubeErrorInvalidPos = 0xBA4, // s_function_cube_error_invalid_pos
    FunctionCubeErrorInvalidSummonUser = 0xBA5, // s_function_cube_error_invalid_summon_user
    ErrUgcMapPackageCantUse = 0xBA6, // s_err_ugcmap_package_cant_use
    ErrUgcMapPackageCantUseInThisMap = 0xBA7, // s_err_ugcmap_package_cant_use_in_this_map
    ErrUgcMapPackageShouldUseInIndoor = 0xBA8, // s_err_ugcmap_package_should_use_in_indoor
    ErrUgcMapPackageNotAValidPackageItem = 0xBA9, // s_err_ugcmap_package_not_a_valid_package_item
    ErrUgcMapPackageCantUseInOthersHome = 0xBAA, // s_err_ugcmap_package_cant_use_in_others_home
    ErrUgcMapPackageClearIndoorFirst = 0xBAB, // s_err_ugcmap_package_clear_indoor_first
    ErrUgcMapPackageNotAValidIndoor = 0xBAC, // s_err_ugcmap_package_not_a_valid_indoor
    ErrUgcMapPackageNotAIndoorForPackageItem = 0xBAD, // s_err_ugcmap_package_not_a_indoor_for_package_item
    ErrUgcMapPackageNotAIndoorForThisPackageItem = 0xBAE, // s_err_ugcmap_package_not_a_indoor_for_this_package_item
    ErrUgcMapPackageFailedToConsumePackageItem = 0xBAF, // s_err_ugcmap_package_failed_to_consume_package_item
    ErrUgcMapPackageAutomaticCreationIsInProgress = 0xBB0, // s_err_ugcmap_package_automatic_creation_is_in_progress
    ErrUgcMapPackageAutomaticRemovalIsInProgress = 0xBB1, // s_err_ugcmap_package_automatic_removal_is_in_progress
    UgcMapPackageAutomaticCreationCompleted = 0xBB2, // s_ugcmap_package_automatic_creation_completed
    UgcMapPackageAutomaticRemovalCompleted = 0xBB3, // s_ugcmap_package_automatic_removal_completed
    UgcMapPackageAutomaticCreationSuspended = 0xBB4, // s_ugcmap_package_automatic_creation_suspended
    UgcMapPackageAutomaticRemovalSuspended = 0xBB5, // s_ugcmap_package_automatic_removal_suspended
    UgcMapPackageAutomaticCreationSkip = 0xBB6, // s_ugcmap_package_automatic_creation_skip
    UgcMapPackageOpenPackageWhenIndoorIsDifferent = 0xBB7, // s_ugcmap_package_open_package_when_indoor_is_different
    UgcMapPackageOpenPackageWhenIndoorIsEmpty = 0xBB8, // s_ugcmap_package_open_package_when_indoor_is_empty
    ErrUgcMapDesignHomeShouldUseInDesignHome = 0xBB9, // s_err_ugcmap_design_home_should_use_in_design_home
    ErrUgcMapDesignHomeNotMyDesignHome = 0xBBA, // s_err_ugcmap_design_home_not_my_design_home
    ErrUgcMapDesignHomeIndoorIsntEmpty = 0xBBB, // s_err_ugcmap_design_home_indoor_isnt_empty
    ErrUgcMapDesignHomeShouldUseInHome = 0xBBC, // s_err_ugcmap_design_home_should_use_in_home
    ErrUgcMapDesignHomeNothingToImport = 0xBBD, // s_err_ugcmap_design_home_nothing_to_import
    ErrUgcMapDesignHomeInvalidItem = 0xBBE, // s_err_ugcmap_design_home_invalid_item
    ErrUgcMapDesignHomeNotEnoughMeso = 0xBBF, // s_err_ugcmap_design_home_not_enough_meso
    ErrUgcMapDesignHomeNotEnoughMerat = 0xBC0, // s_err_ugcmap_design_home_not_enough_merat
    ErrUgcMapDesignHomeNotEnoughItem = 0xBC1, // s_err_ugcmap_design_home_not_enough_item
    ErrUgcMapDesignHomeNotEnoughHonorToken = 0xBC2, // s_err_ugcmap_design_home_not_enough_honor_token
    ErrUgcMapDesignHomeNotEnoughKarmaToken = 0xBC3, // s_err_ugcmap_design_home_not_enough_karma_token
    ErrUgcMapDesignHomeNotEnoughLuToken = 0xBC4, // s_err_ugcmap_design_home_not_enough_lu_token
    ErrUgcMapDesignHomeNotEnoughHabiToken = 0xBC5, // s_err_ugcmap_design_home_not_enough_habi_token
    ErrUgcMapDesignHomeNotEnoughShardToken = 0xBC6, // s_err_ugcmap_design_home_not_enough_shard_token
    ErrUgcMapDesignHomeNotEnoughRedMerat = 0xBC7, // s_err_ugcmap_design_home_not_enough_red_merat
    ErrUgcMapDesignHomeNotEnoughReverseCoin = 0xBC8, // s_err_ugcmap_design_home_not_enough_reverse_coin
    ErrUgcMapDesignHomeNotEnoughStarPoint = 0xBC9, // s_err_ugcmap_design_home_not_enough_star_point
    ErrUgcMapDesignHomeInvalidDesignPoint = 0xBCA, // s_err_ugcmap_design_home_invalid_design_point
    ErrUgcMapCantSaveMaid = 0xBCB, // s_err_ugcmap_cant_save_maid
    ErrUgcMapGuideObjectCantGoFar = 0xBCC, // s_err_ugcmap_guide_object_cant_go_far
    ErrUgcMapCantFindDelegateOwner = 0xBCD, // s_err_ugcmap_cant_find_delegate_owner
    ErrUgcMapCantUseClearUgcMap = 0xBCE, // s_err_ugcmap_cant_use_clear_ugc_map
    ErrUgcMapNotMassiveEventField = 0xBCF, // s_err_ugcmap_not_massive_event_field
    ErrUgcMapOnlyOwnerCanSetBalance = 0xBD0, // s_err_ugcmap_only_owner_can_set_balance
    ErrUgcMapMesoBalanceShouldBePositiveNumber = 0xBD1, // s_err_ugcmap_meso_balance_should_be_positive_number
    ErrUgcMapMeratBalanceShouldBePositiveNumber = 0xBD2, // s_err_ugcmap_merat_balance_should_be_positive_number
    ErrUgcMapMesoMeratBalanceDescription = 0xBD3, // s_err_ugcmap_meso_merat_balance_description
    ErrUgcMapNothingToExport = 0xBD4, // s_err_ugcmap_nothing_to_export
    FishingGradeLv1 = 0xBD5, // s_fishing_grade_Lv1
    FishingGradeLv2 = 0xBD6, // s_fishing_grade_Lv2
    FishingGradeLv3 = 0xBD7, // s_fishing_grade_Lv3
    FishingGradeLv4 = 0xBD8, // s_fishing_grade_Lv4
    FishingGradeLv5 = 0xBD9, // s_fishing_grade_Lv5
    FishingGradeLv6 = 0xBDA, // s_fishing_grade_Lv6
    FishingGradeLv7 = 0xBDB, // s_fishing_grade_Lv7
    FishingGradeLv8 = 0xBDC, // s_fishing_grade_Lv8
    FishingGradeLv9 = 0xBDD, // s_fishing_grade_Lv9
    FishingGradeLv10 = 0xBDE, // s_fishing_grade_Lv10
    FishingGradeLv11 = 0xBDF, // s_fishing_grade_Lv11
    FishingGradeLv12 = 0xBE0, // s_fishing_grade_Lv12
    FishingGradeLv13 = 0xBE1, // s_fishing_grade_Lv13
    FishingGradeLv14 = 0xBE2, // s_fishing_grade_Lv14
    FishingGradeLv15 = 0xBE3, // s_fishing_grade_Lv15
    FishingGradeLv16 = 0xBE4, // s_fishing_grade_Lv16
    FishingGradeLv17 = 0xBE5, // s_fishing_grade_Lv17
    FishingGradeLv18 = 0xBE6, // s_fishing_grade_Lv18
    FishingGradeLv19 = 0xBE7, // s_fishing_grade_Lv19
    FishingGradeLv20 = 0xBE8, // s_fishing_grade_Lv20
    FishingGradeLv21 = 0xBE9, // s_fishing_grade_Lv21
    FishingHabitatWater = 0xBEA, // s_fishing_habitat_water
    FishingHabitatSeawater = 0xBEB, // s_fishing_habitat_seawater
    FishingHabitatPoison = 0xBEC, // s_fishing_habitat_poison
    FishingHabitatLava = 0xBED, // s_fishing_habitat_lava
    FishingHabitatOil = 0xBEE, // s_fishing_habitat_oil
    FishingHabitatDevilwater = 0xBEF, // s_fishing_habitat_devilwater
    FishingHabitatEmeraldwater = 0xBF0, // s_fishing_habitat_emeraldwater
    FishingHabitatAll = 0xBF1, // s_fishing_habitat_all
    FishingNotifySuccess = 0xBF2, // s_fishing_notify_success
    FishingNotifyFail = 0xBF3, // s_fishing_notify_fail
    FishingFishGrade = 0xBF4, // s_fishing_fish_grade
    FishingFishCatchCount = 0xBF5, // s_fishing_fish_catch_count
    FishingFishSize = 0xBF6, // s_fishing_fish_size
    FishingErrorInvalidCube = 0xBF7, // s_fishing_error_invalid_cube
    FishingErrorNotexistWater = 0xBF8, // s_fishing_error_notexist_water
    FishingErrorInvalidItem = 0xBF9, // s_fishing_error_invalid_item
    FishingErrorLackMastery = 0xBFA, // s_fishing_error_lack_mastery
    FishingErrorNotexistFish = 0xBFB, // s_fishing_error_notexist_fish
    FishingErrorSystemError = 0xBFC, // s_fishing_error_system_error
    FishingErrorFishingrodMastery = 0xBFD, // s_fishing_error_fishingrod_mastery
    FishingErrorRide = 0xBFE, // s_fishing_error_ride
    FishingErrorInventoryFull = 0xBFF, // s_fishing_error_inventory_full
    FishingErrorUgcMap = 0xC00, // s_fishing_error_ugcmap
    FishingOffsetMastery = 0xC01, // s_fishing_offset_mastery
    FishingOffsetMasteryFirstcatch = 0xC02, // s_fishing_offset_mastery_firstcatch
    FishingOffsetMasteryBigsizecatch = 0xC03, // s_fishing_offset_mastery_bigsizecatch
    FishingTotalMastery = 0xC04, // s_fishing_total_mastery
    FishingNeedMastery = 0xC05, // s_fishing_need_mastery
    FishingSizeSmall = 0xC06, // s_fishing_size_small
    FishingSizeMedium = 0xC07, // s_fishing_size_medium
    FishingSizeLarge = 0xC08, // s_fishing_size_large
    FishingSizeBigfish = 0xC09, // s_fishing_size_bigfish
    RemakeItemoptionError = 0xC0A, // s_remake_itemoption_error
    RemakeItemoptionErrorImpossible = 0xC0B, // s_remake_itemoption_error_impossible
    RemakeItemoptionErrorLimitlevel = 0xC0C, // s_remake_itemoption_error_limitlevel
    TooltipItemoptionKindsConstant = 0xC0D, // s_tooltip_itemoption_kinds_constant
    TooltipItemoptionKindsStatic = 0xC0E, // s_tooltip_itemoption_kinds_static
    TooltipItemoptionKindsRandom = 0xC0F, // s_tooltip_itemoption_kinds_random
    TooltipItemoptionKindsTitle = 0xC10, // s_tooltip_itemoption_kinds_title
    TooltipItemoptionKindsSpace = 0xC11, // s_tooltip_itemoption_kinds_space
    TooltipItemoptionEnchant = 0xC12, // s_tooltip_itemoption_enchant
    TooltipItemoptionEnchantBroken = 0xC13, // s_tooltip_itemoption_enchant_broken
    TooltipItemoptionStatRow = 0xC14, // s_tooltip_itemoption_stat_row
    TooltipItemremakeCount = 0xC15, // s_tooltip_itemremake_count
    TooltipItemremakeEnable = 0xC16, // s_tooltip_itemremake_enable
    WeddingVisitConfirm = 0xC17, // s_wedding_visit_confirm
    WeddingVisitFailedCommon = 0xC18, // s_wedding_visit_failed_common
    WeddingVisitFailedDead = 0xC19, // s_wedding_visit_failed_dead
    WeddingVisitFailedInvalidTime = 0xC1A, // s_wedding_visit_failed_invalid_time
    WeddingVisitFailedUserCountLimitExceeded = 0xC1B, // s_wedding_visit_failed_user_count_limit_exceeded
    WeddingVisitFailedUserSelfLink = 0xC1C, // s_wedding_visit_failed_user_self_link
    WeddingVisitFailedDisablemap = 0xC1D, // s_wedding_visit_failed_disablemap
    WeddingVisitFailedSoloInstance = 0xC1E, // s_wedding_visit_failed_solo_instance
    WeddingVisitFailedSamePlace = 0xC1F, // s_wedding_visit_failed_same_place
    ErrWeddingChatCannotUseCommon = 0xC20, // s_err_wedding_chat_cannot_use_common
    ErrWeddingChatCannotUseNoReservation = 0xC21, // s_err_wedding_chat_cannot_use_no_reservation
    ErrWeddingChatCannotUseComplete = 0xC22, // s_err_wedding_chat_cannot_use_complete
    AntiAddictionCannotReceive = 0xC23, // s_anti_addiction_cannot_receive
    AutoItemuseDefault = 0xC24, // s_auto_itemuse_default
    AutoItemuseCondition = 0xC25, // s_auto_itemuse_condition
    PetInputName = 0xC26, // s_pet_input_name
    PetSummonOn = 0xC27, // s_pet_summon_on
    PetSummonOff = 0xC28, // s_pet_summon_off
    PetBtnSummonOn = 0xC29, // s_pet_btn_summon_on
    PetBtnSummonOff = 0xC2A, // s_pet_btn_summon_off
    PetInventoryAskIn = 0xC2B, // s_pet_inventory_ask_in
    PetInventoryAskOut = 0xC2C, // s_pet_inventory_ask_out
    PetInventorySlotUseCount = 0xC2D, // s_pet_inventory_slot_use_count
    PetInventoryExpire = 0xC2E, // s_pet_inventory_expire
    PetInventoryEndTime = 0xC2F, // s_pet_inventory_end_time
    PetInventoryNotUse = 0xC30, // s_pet_inventory_not_use
    PetInventoryNotSendin = 0xC31, // s_pet_inventory_not_sendin
    PetInventoryNotSendinPetitem = 0xC32, // s_pet_inventory_not_sendin_petitem
    PetEffectEndTime = 0xC33, // s_pet_effect_end_time
    PetAdditionalDescName = 0xC34, // s_pet_additional_desc_name
    PetChangeNameFree = 0xC35, // s_pet_change_name_free
    PetChangeNameMerat = 0xC36, // s_pet_change_name_merat
    PetChangeNameSamename = 0xC37, // s_pet_change_name_samename
    PetItemuseCannotNotPosion = 0xC38, // s_pet_itemuse_cannot_not_posion
    PetItemuseCannotSameItem = 0xC39, // s_pet_itemuse_cannot_same_item
    PetItemuseCannotSameCondition = 0xC3A, // s_pet_itemuse_cannot_same_condition
    PetItemuseCannotNotexistCondition = 0xC3B, // s_pet_itemuse_cannot_notexist_condition
    PetItemuseCannotDragUserInventory = 0xC3C, // s_pet_itemuse_cannot_drag_user_inventory
    PetErrorSummonPotion = 0xC3D, // s_pet_error_summon_potion
    PetExtensionOntarget = 0xC3E, // s_pet_extension_ontarget
    PetExtensionPeriod = 0xC3F, // s_pet_extension_period
    PetExtensionPeriodLimit = 0xC40, // s_pet_extension_period_limit
    PetExtensionPeriodRemain = 0xC41, // s_pet_extension_period_remain
    PetExtensionPeriodHungry = 0xC42, // s_pet_extension_period_hungry
    PetExtensionPeriodNotExtendlife = 0xC43, // s_pet_extension_period_not_extendlife
    PetNutrientOntarget = 0xC44, // s_pet_nutrient_ontarget
    PetNutrientPeriodLimit = 0xC45, // s_pet_nutrient_period_limit
    PetNutrientConfirmReplaceEffect = 0xC46, // s_pet_nutrient_confirm_replace_effect
    PetNutrientSuccess = 0xC47, // s_pet_nutrient_success
    PetNutrientSuccessExtension = 0xC48, // s_pet_nutrient_success_extension
    PetNutrientCannotHungry = 0xC49, // s_pet_nutrient_cannot_hungry
    UsercommanddescriptionUser = 0xC4A, // s_usercommanddescription_user
    UsercommanddescriptionTester = 0xC4B, // s_usercommanddescription_tester
    UsercommanddescriptionAdmin = 0xC4C, // s_usercommanddescription_admin
    TimeeventCommon1 = 0xC4D, // s_timeevent_common_1
    TimeeventCommon4 = 0xC4E, // s_timeevent_common_4
    TimeeventCommon7 = 0xC4F, // s_timeevent_common_7
    TimestringAm = 0xC50, // s_timestring_am
    TimestringPm = 0xC51, // s_timestring_pm
    SkillCompactControlAddTab = 0xC52, // s_skill_compact_control_add_tab
    SkillCompactControlRenameTab = 0xC53, // s_skill_compact_control_rename_tab
    SkillCompactControlSameTabname = 0xC54, // s_skill_compact_control_same_tabname
    SkillCompactControlDefaultTabname = 0xC55, // s_skill_compact_control_default_tabname
    WindowTitleName = 0xC57, // s_window_title_name
    SkillLevelMax = 0xC56, // s_skill_level_max
    CrashreporterTitle = 0xC58, // s_crashreporter_title
    CrashreporterText = 0xC59, // s_crashreporter_text
    GameeventEnterfieldConfirm = 0xC5A, // s_gameevent_enterfield_confirm
    CardReverseGameConsumeFail = 0xC5B, // s_card_reverse_game_consume_fail
    CardReverseGameSelectCount = 0xC5C, // s_card_reverse_game_select_count
    CardReverseGameCloseMessage = 0xC5D, // s_card_reverse_game_close_message
    CardReverseGameRewardNotice = 0xC5E, // s_card_reverse_game_reward_notice
    RankDuelArenaFail = 0xC5F, // s_rank_duel_arena_fail
    InvalidBreakSkinitem = 0xC60, // s_invalid_break_skinitem
    ItemlockUnknownErr = 0xC61, // s_itemlock_unknown_err
    ItemlockInvalidItemLock = 0xC62, // s_itemlock_invalid_item_lock
    ItemlockInvalidItemUnlock = 0xC63, // s_itemlock_invalid_item_unlock
    PartySearchDefaultMsg1 = 0xC64, // s_party_search_default_msg_1
    PartySearchDefaultMsg2 = 0xC65, // s_party_search_default_msg_2
    PartySearchDefaultMsg3 = 0xC66, // s_party_search_default_msg_3
    PartySearchDefaultMsg4 = 0xC67, // s_party_search_default_msg_4
    PartySearchDefaultMsg5 = 0xC68, // s_party_search_default_msg_5
    CharacterAbilityCharacterCategoryName = 0xC69, // s_character_ability_character__category_name
    CharacterAbilityMonsterAndDungeonCategoryName = 0xC6A, // s_character_ability_monster_and_dungeon_category_name
    CharacterAbilityPlayAndFeatureCategoryName = 0xC6B, // s_character_ability_play_and_feature_category_name
    CharacterAbilityQuestAndGrowCategoryName = 0xC6C, // s_character_ability_quest_and_grow_category_name
    CharacterAbilityContentCategoryName = 0xC6D, // s_character_ability_content_category_name
    CharacterAbilityCharacterCategoryTooltip = 0xC6E, // s_character_ability_character_category_tooltip
    CharacterAbilityMonsterAndDungeonCategoryTooltip = 0xC6F, // s_character_ability_monster_and_dungeon_category_tooltip
    CharacterAbilityPlayAndFeatureCategoryTooltip = 0xC70, // s_character_ability_play_and_feature_category_tooltip
    CharacterAbilityQuestAndGrowCategoryTooltip = 0xC71, // s_character_ability_quest_and_grow_category_tooltip
    CharacterAbilityContentCategoryTooltip = 0xC72, // s_character_ability_content_category_tooltip
    CharacterAbilityErrNoAbilitypoint = 0xC73, // s_character_ability_err_no_abilitypoint
    CharacterAbilityErrNoMeso = 0xC74, // s_character_ability_err_no_meso
    CharacterAbilityErrNoMerat = 0xC75, // s_character_ability_err_no_merat
    CharacterAbilityPointInfoText = 0xC76, // s_character_ability_point_info_text
    CharacterAbilityMesoResetDesc = 0xC77, // s_character_ability_meso_reset_desc
    CharacterAbilityMesoResetButton = 0xC78, // s_character_ability_meso_reset_button
    CharacterAbilityMeratResetDesc = 0xC79, // s_character_ability_merat_reset_desc
    CharacterAbilityMeratResetButton = 0xC7A, // s_character_ability_merat_reset_button
    CharacterAbilityErrResetCooltime = 0xC7B, // s_character_ability_err_reset_cooltime
    CharacterAbilityDisabledQuestDesc = 0xC7C, // s_character_ability_disabled_quest_desc
    CharacterAbilityResetCooltime = 0xC7D, // s_character_ability_reset_cooltime
    CharacterAbilityResetCooltimeRequest = 0xC7E, // s_character_ability_reset_cooltime_request
    CharacterAbilityErrLevelResetCooltime = 0xC7F, // s_character_ability_err_level_reset_cooltime
    PartyRecallScrollBuy = 0xC80, // s_party_recall_scroll_buy
    MsgAutofishingExtend = 0xC81, // s_msg_autofishing_extend
    MsgAutofishingExtendDesc = 0xC82, // s_msg_autofishing_extend_desc
    MsgAutofishingExtendShowcurrentdurationDesc = 0xC83, // s_msg_autofishing_extend_showcurrentduration_desc
    SystemShopTitleExtendAutofishing = 0xC84, // s_system_shop_title_extend_autofishing
    NoticeBypass = 0xC85, // s_notice_bypass
    NoticeUnstableNetworkState = 0xC86, // s_notice_unstable_network_state
    UgcMapFunHostGravityChange = 0xC87, // s_ugcmap_fun_host_gravity_change
    UgcMapFunCardInfoUserOpen = 0xC88, // s_ugcmap_fun_card_info_user_open
    UgcMapFunCardInfoUserPrivate = 0xC89, // s_ugcmap_fun_card_info_user_private
    UgcMapFunCardInfoDeckOpen = 0xC8A, // s_ugcmap_fun_card_info_deck_open
    UgcMapFunCardInfoDeckPrivate = 0xC8B, // s_ugcmap_fun_card_info_deck_private
    UgcMapFunCardInfoMine = 0xC8C, // s_ugcmap_fun_card_info_mine
    UgcMapFunCardOpenMine = 0xC8D, // s_ugcmap_fun_card_open_mine
    UgcMapFunCardDiscardMine = 0xC90, // s_ugcmap_fun_card_discard_mine
    UgcMapFunCardDiscardOpen = 0xC8E, // s_ugcmap_fun_card_discard_open
    UgcMapFunCardDiscardPrivate = 0xC8F, // s_ugcmap_fun_card_discard_private
    UgcMapFunCardVerifyOwned = 0xC91, // s_ugcmap_fun_card_verify_owned
    UgcMapFunCardVerifyNotOwned = 0xC92, // s_ugcmap_fun_card_verify_not_owned
    UgcMapFunCardHandoverOpen = 0xC93, // s_ugcmap_fun_card_handover_open
    UgcMapFunCardHandoverPrivate = 0xC94, // s_ugcmap_fun_card_handover_private
    UgcMapFunCardHandoverSender = 0xC95, // s_ugcmap_fun_card_handover_sender
    UgcMapFunCardHandoverReceiver = 0xC96, // s_ugcmap_fun_card_handover_receiver
    UgcMapFunCardAdd = 0xC97, // s_ugcmap_fun_card_add
    UgcMapFunCardReceiveOpen = 0xC98, // s_ugcmap_fun_card_receive_open
    UgcMapFunCardReceivePrivate = 0xC99, // s_ugcmap_fun_card_receive_private
    UgcMapFunCardReceiveMine = 0xC9A, // s_ugcmap_fun_card_receive_mine
    UgcMapFunCardDeckNotExist = 0xC9B, // s_ugcmap_fun_card_deck_not_exist
    UgcMapFunCardDeckReset = 0xC9C, // s_ugcmap_fun_card_deck_reset
    UgcMapFunCardDeckResetEmpty = 0xC9D, // s_ugcmap_fun_card_deck_reset_empty
    UgcMapFunCardNotExist = 0xC9E, // s_ugcmap_fun_card_not_exist
    UgcMapFunCardEmptyInDeck = 0xC9F, // s_ugcmap_fun_card_empty_in_deck
    UgcMapFunCardTooManyInDeck = 0xCA0, // s_ugcmap_fun_card_too_many_in_deck
    UgcMapFunCardTargetNotExist = 0xCA1, // s_ugcmap_fun_card_target_not_exist
    UgcMapFunCardDeckNameEmpty = 0xCA2, // s_ugcmap_fun_card_deck_name_empty
    UgcMapFunCardDeckNameInvalid = 0xCA3, // s_ugcmap_fun_card_deck_name_invalid
    UgcMapFunCardDeckTooMany = 0xCA4, // s_ugcmap_fun_card_deck_too_many
    UgcMapFunCardDeckExistAlready = 0xCA5, // s_ugcmap_fun_card_deck_exist_already
    UgcMapFunCardDeckIsPermanent = 0xCA6, // s_ugcmap_fun_card_deck_is_permanent
    UgcMapFunCardDeckAdd = 0xCA7, // s_ugcmap_fun_card_deck_add
    UgcMapFunCardDeckDiscard = 0xCA8, // s_ugcmap_fun_card_deck_discard
    UgcMapFunSurveyOpen = 0xCA9, // s_ugcmap_fun_survey_open
    UgcMapFunSurveySecret = 0xCAA, // s_ugcmap_fun_survey_secret
    UgcMapFunSurveyAbstention = 0xCAB, // s_ugcmap_fun_survey_abstention
    UgcMapFunSurveyGuide = 0xCAC, // s_ugcmap_fun_survey_guide
    UgcMapFunSurveyInfoHead = 0xCAD, // s_ugcmap_fun_survey_info_head
    UgcMapFunSurveyInfoFooter = 0xCAE, // s_ugcmap_fun_survey_info_footer
    UgcMapFunSurveyCreateSuccess = 0xCAF, // s_ugcmap_fun_survey_create_success
    UgcMapFunSurveyCreateError = 0xCB0, // s_ugcmap_fun_survey_create_error
    UgcMapFunSurveyAddSuccess = 0xCB1, // s_ugcmap_fun_survey_add_success
    UgcMapFunSurveyAddError = 0xCB2, // s_ugcmap_fun_survey_add_error
    UgcMapFunSurveyStart = 0xCB3, // s_ugcmap_fun_survey_start
    UgcMapFunSurveyVote = 0xCB4, // s_ugcmap_fun_survey_vote
    UgcMapFunSurveyEnd = 0xCB5, // s_ugcmap_fun_survey_end
    UgcMapFunSurveyResult = 0xCB6, // s_ugcmap_fun_survey_result
    UgcMapFunSurveyCloseWithoutVote = 0xCB7, // s_ugcmap_fun_survey_close_without_vote
    UgcMapFunPortalNameDuplicated = 0xCB8, // s_ugcmap_fun_portal_name_duplicated
    RollDice = 0xCB9, // s_ugcmap_fun_roll
    UgcMapFunRollError = 0xCBA, // s_ugcmap_fun_roll_error
    UgcMapFunRandomGroup = 0xCBB, // s_ugcmap_fun_random_group
    PickRandomCharacterName = 0xCBC, // s_ugcmap_fun_random_pick
    UgcMapFunRandomPickSpecial = 0xCBD, // s_ugcmap_fun_random_pick_special
    UgcMapFunTypingReady = 0xCBE, // s_ugcmap_fun_typing_ready
    UgcMapFunTypingBegin = 0xCBF, // s_ugcmap_fun_typing_begin
    UgcMapFunTypingSubmit = 0xCC0, // s_ugcmap_fun_typing_submit
    UgcMapFunTypingEnd = 0xCC1, // s_ugcmap_fun_typing_end
    UgcMapFunTypingRanking = 0xCC2, // s_ugcmap_fun_typing_ranking
    UgcMapFunPvpFfaFinished = 0xCC3, // s_ugcmap_fun_pvp_ffa_finished
    UgcMapFunPvpFfaFinishedDraw = 0xCC4, // s_ugcmap_fun_pvp_ffa_finished_draw
    UgcMapFunPvpFfaWinnterName = 0xCC5, // s_ugcmap_fun_pvp_ffa_winnter_name
    UgcMapCantExtendAreaLevelAnymore = 0xCC6, // s_ugcmap_cant_extend_area_level_anymore
    UgcMapCantExtendHeightLevelAnymore = 0xCC7, // s_ugcmap_cant_extend_height_level_anymore
    UgcMapCubeLock = 0xCC8, // s_ugcmap_cube_lock
    UgcMapCantAdditionalbuy = 0xCC9, // s_ugcmap_cant_additionalbuy
    UgcMapAdminOnly = 0xCCA, // s_ugcmap_admin_only
    UgcMapNotAllowedItem = 0xCCB, // s_ugcmap_not_allowed_item
    ErrUgcMapNotEnoughMesoBalance = 0xCCC, // s_err_ugcmap_not_enough_meso_balance
    ErrUgcMapNotEnoughMeratBalance = 0xCCD, // s_err_ugcmap_not_enough_merat_balance
    ErrUgcMapCantFindDelegatorInThisMap = 0xCCE, // s_err_ugcmap_cant_find_delegator_in_this_map
    ErrUgcMapCantFullDelegatorUser = 0xCCF, // s_err_ugcmap_cant_full_delegator_user
    ErrUgcMapCantDuplicateDelegatorInThisMap = 0xCD0, // s_err_ugcmap_cant_duplicate_delegator_in_this_map
    ErrUgcMapCantBuildEmptyUgc = 0xCD1, // s_err_ugcmap_cant_build_empty_ugc
    ErrUgcMapShouldUseInHome = 0xCD2, // s_err_ugcmap_should_use_in_home
    ErrUgcMapConstructExpOvertime = 0xCD3, // s_err_ugcmap_construct_exp_overtime
    UgcMapAddDelegatorUser = 0xCD4, // s_ugcmap_add_delegator_user
    UgcMapRemoveDelegatorUser = 0xCD5, // s_ugcmap_remove_delegator_user
    UgcMapGiveDelegatorUser = 0xCD6, // s_ugcmap_give_delegator_user
    UgcMapReleaseDelegatorUser = 0xCD7, // s_ugcmap_release_delegator_user
    UgcMapRemoveallDelegatorUser = 0xCD8, // s_ugcmap_removeall_delegator_user
    ErrUgcMapBlueprintPreviewCubeActionDisabled = 0xCD9, // s_err_ugcmap_blueprint_preview_cube_action_disabled
    HomeTodayReward = 0xCDA, // s_home_today_reward
    HomeBillDescription = 0xCDB, // s_home_bill_description
    HomeInteriorGradeGiftTaken = 0xCDC, // s_home_interior_grade_gift_taken
    PlatformCommonErrorUnknownErrorCode = 0xCDD, // s_platform_common_error_unknown_error_code
    PlatformCommonErrorUnknown = 0xCDE, // s_platform_common_error_unknown
    PlatformCommonErrorInvalidParam = 0xCDF, // s_platform_common_error_invalid_param
    PlatformCommonErrorNotInitialize = 0xCE0, // s_platform_common_error_not_initialize
    PlatformCommonErrorUnstableInstall = 0xCE1, // s_platform_common_error_unstable_install
    PlatformCommonErrorUnstableInstallPath = 0xCE2, // s_platform_common_error_unstable_install_path
    PlatformCommonErrorUnstableInstallData = 0xCE3, // s_platform_common_error_unstable_install_data
    GamehelperGameOptimizeApply = 0xCE4, // s_gamehelper_game_optimize_apply
    GamehelperVoiceChatEnter = 0xCE5, // s_gamehelper_voice_chat_enter
    GamehelperVoiceChatLeave = 0xCE6, // s_gamehelper_voice_chat_leave
    PremiumExtended = 0xCE7, // s_vip_coupon_extend_msg
    PremiumActivated = 0xCE8, // s_vip_coupon_new_msg
    WordTabPetinfo = 0xCE9, // s_word_tab_petinfo
    WordTabPetcompose = 0xCEA, // s_word_tab_petcompose
    WordTabPetevolution = 0xCEB, // s_word_tab_petevolution
    WordTabPetcollect = 0xCEC, // s_word_tab_petcollect
    WordTabRemakeoption = 0xCED, // s_word_tab_remakeoption
    CharInputItemname = 0xCEE, // s_char_input_itemname
    TimeeventBossLifetimetext1 = 0xCEF, // s_timeevent_boss_lifetimetext1
    TimeeventBossLifetimetext2 = 0xCF0, // s_timeevent_boss_lifetimetext2
    WordPet = 0xCF1, // s_word_pet
    WordBattlePet = 0xCF2, // s_word_battle_pet
    LiveBroadcastSystemError = 0xCF3, // s_live_broadcast_system_error
    UgcoxHostCommissionMesoGet = 0xCF5, // s_ugcox_host_commission_meso_get
    UgcoxCreatePortal = 0xCF4, // s_ugcox_create_portal
    UgcoxEntryPrizeMesoGet = 0xCF6, // s_ugcox_entry_prize_meso_get
    UgcoxEntryFeeRefundMesoGet = 0xCF7, // s_ugcox_entry_fee_refund_meso_get
    UgcoxEnterFailFull = 0xCF8, // s_ugcox_enter_fail_full
    CoupleEmotionRequestRecv = 0xD01, // s_couple_emotion_request_recv
    CoupleEmotionRequestSuccess = 0xD02, // s_couple_emotion_request_success
    CoupleEmotionFailed = 0xD03, // s_couple_emotion_failed
    CoupleEmotionResponseAccept = 0xD04, // s_couple_emotion_response_accept
    CoupleEmotionResponseDecline = 0xD05, // s_couple_emotion_response_decline
    CoupleEmotionTargetUserWrongPosition = 0xD06, // s_couple_emotion_target_user_wrong_position
    CoupleEmotionRecvRequestInProgressed = 0xD07, // s_couple_emotion_recv_request_in_progressed
    CoupleEffectErrorOpenboxUnknown = 0xCF9, // s_couple_effect_error_openbox_unknown
    SpecifiedCharacterCouldNotBeFound = 0xCFA, // s_couple_effect_error_openbox_charname
    CoupleEffectErrorOpenboxMyselfChar = 0xCFB, // s_couple_effect_error_openbox_myself_char
    CoupleEffectErrorOpenboxMyselfAccount = 0xCFC, // s_couple_effect_error_openbox_myself_account
    CoupleEffectMailSender = 0xCFD, // s_couple_effect_mail_sender
    CoupleEffectMailTitleReceiver = 0xCFE, // s_couple_effect_mail_title_receiver
    CoupleEffectMailContentReceiver = 0xCFF, // s_couple_effect_mail_content_receiver
    YouMailedBuddyBadgeToOtherPlayer = 0xD00, // s_couple_effect_mail_send_partner
    CoupleEmotionFailedRequestNotExistSkill = 0xD0E, // s_couple_emotion_failed_request_not_exist_skill
    CoupleEmotionFailedAcceptRequestUserWrongState = 0xD0F, // s_couple_emotion_failed_accept_request_user_wrong_state
    CoupleEmotionFailedRequestAlreadyRecv = 0xD10, // s_couple_emotion_failed_request_already_recv
    CoupleEmotionFailedRequestAlreadyInAction = 0xD11, // s_couple_emotion_failed_request_already_in_action
    CoupleEmotionFailedAcceptCannotFindRequestUser = 0xD14, // s_couple_emotion_failed_accept_cannot_find_request_user
    CoupleEmotionFailedTeleportLimitDistance = 0xD15, // s_couple_emotion_failed_teleport_limit_distance
    CoupleEmotionFailedResponseWrongStateTargetUser = 0xD16, // s_couple_emotion_failed_response_wrong_state_target_user
    CoupleEmotionCannotRequestWrongState = 0xD08, // s_couple_emotion_cannot_request_wrong_state
    CoupleEmotionCannotRequestAlreadyInRecvState = 0xD09, // s_couple_emotion_cannot_request_already_in_recv_state
    CoupleEmotionCannotRequestBlockedTarget = 0xD0B, // s_couple_emotion_cannot_request_blocked_target
    CoupleEmotionCannotRequestLongDistance = 0xD0A, // s_couple_emotion_cannot_request_long_distance
    CoupleEmotionCannotRequestInThisMap = 0xD0C, // s_couple_emotion_cannot_request_in_this_map
    CoupleEmotionCannotResponseNotExistRequestUser = 0xD0D, // s_couple_emotion_cannot_response_not_exist_request_user
    CoupleEmotionFailedRequestAutoDecline = 0xD12, // s_couple_emotion_failed_requset_auto_decline
    CoupleEmotionFailedRequestWrongState = 0xD13, // s_couple_emotion_failed_request_wrong_state
    GalleryeventCannotOpenCard = 0xD17, // s_galleryevent_cannot_open_card
    GalleryeventInvalidEvent = 0xD18, // s_galleryevent_invalid_event
    MicrogameRpsOpenBannerFailedNotExistTicket = 0xD19, // s_microgame_rps_open_banner_failed_not_exist_ticket
    MicrogameRpsOpenBannerFailedActionKey = 0xD1A, // s_microgame_rps_open_banner_failed_action_key
    MicrogameRpsOpenBannerFailedWrongState = 0xD1B, // s_microgame_rps_open_banner_failed_wrong_state
    MicrogameRpsRequestFailedNotExistTicket = 0xD1C, // s_microgame_rps_request_failed_not_exist_ticket
    MicrogameRpsRequestFailedWrongDirection = 0xD1D, // s_microgame_rps_request_failed_wrong_direction
    MicrogameRpsRequestFailedWrongPosition = 0xD1E, // s_microgame_rps_request_failed_wrong_position
    MicrogameRpsRequestFailedWrongState = 0xD1F, // s_microgame_rps_request_failed_wrong_state
    MicrogameRpsRequestCancel = 0xD20, // s_microgame_rps_request_cancel
    MicrogameRpsPeerGameCancel = 0xD21, // s_microgame_rps_peer_game_cancel
    MicrogameRpsBannerFailedBlockedInThisField = 0xD22, // s_microgame_rps_banner_failed_blocked_in_this_field
    MicrogameRpsRequestFailedBlockedInThisField = 0xD23, // s_microgame_rps_request_failed_blocked_in_this_field
    MicrogameRpsRequestFailedBlockedUser = 0xD24, // s_microgame_rps_request_failed_blocked_user
    MicrogameRpsResponseFailedBlockedUser = 0xD25, // s_microgame_rps_response_failed_blocked_user
    MicrogameRpsRequestFailedPeerWrongState = 0xD26, // s_microgame_rps_request_failed_peer_wrong_state
    MicrogameRpsAcceptFailedPeerWrongState = 0xD27, // s_microgame_rps_accept_failed_peer_wrong_state
    MicrogameRpsClose = 0xD28, // s_microgame_rps_close
    MicrogameRpsWaiting = 0xD29, // s_microgame_rps_waiting
    MicrogameRpsRequestRecv = 0xD2A, // s_microgame_rps_request_recv
    MicrogameRpsResponseDecline = 0xD2B, // s_microgame_rps_response_decline
    MicrogameRpsResponseAccept = 0xD2C, // s_microgame_rps_response_accept
    MicrogameRpsFailed = 0xD2D, // s_microgame_rps_failed
    MicrogameRpsResultWin = 0xD2E, // s_microgame_rps_result_win
    MicrogameRpsResultLose = 0xD2F, // s_microgame_rps_result_lose
    MicrogameRpsResultDraw = 0xD30, // s_microgame_rps_result_draw
    SurvivalEventReduceSafezoneReady = 0xD31, // s_survival_event_reduce_safezone_ready
    SurvivalEventReduceSafezoneStart = 0xD32, // s_survival_event_reduce_safezone_start
    FunctionItemSurvivalScanInfo = 0xD33, // s_function_item_survival_scan_info
    FunctionItemSurvivalScanAnnounce = 0xD34, // s_function_item_survival_scan_announce
    TreewateringWatering = 0xD35, // s_treewatering_watering
    TreewateringEmotion = 0xD36, // s_treewatering_emotion
    TreewateringWateringCasting = 0xD37, // s_treewatering_watering_casting
    TreewateringEmotionCasting = 0xD38, // s_treewatering_emotion_casting
    TreewateringWateringreward = 0xD39, // s_treewatering_wateringreward
    TreewateringEmotionreward = 0xD3A, // s_treewatering_emotionreward
    TreewateringNoWaterpot = 0xD3B, // s_treewatering_no_waterpot
    TreewateringNomoreWateringReward = 0xD3C, // s_treewatering_nomore_watering_reward
    TreewateringNomoreEmotionReward = 0xD3D, // s_treewatering_nomore_emotion_reward
    NotifyAdventureLevelup = 0xD3E, // s_notify_adventure_levelup
    CashshopErrPurchaseSteamRestirctedCountry = 0xD3F, // s_cashshop_err_purchase_steam_restircted_country
    CashshopErrPurchaseProductInfoExpired = 0xD40, // s_cashshop_err_purchase_product_info_expired
    ClosetMsgSuccess = 0xD41, // s_closet_msg_success
    ClosetMsgItemNotExist = 0xD42, // s_closet_msg_item_not_exist
    ClosetMsgItemFailed = 0xD43, // s_closet_msg_item_failed
    SocketErrorCommon = 0xD44, // s_socket_error_common
    SocketError10004 = 0xD45, // s_socket_error_10004
    SocketError10013 = 0xD46, // s_socket_error_10013
    SocketError10014 = 0xD47, // s_socket_error_10014
    SocketError10022 = 0xD48, // s_socket_error_10022
    SocketError10024 = 0xD49, // s_socket_error_10024
    SocketError10035 = 0xD4A, // s_socket_error_10035
    SocketError10036 = 0xD4B, // s_socket_error_10036
    SocketError10037 = 0xD4C, // s_socket_error_10037
    SocketError10039 = 0xD4D, // s_socket_error_10039
    SocketError10040 = 0xD4E, // s_socket_error_10040
    SocketError10048 = 0xD4F, // s_socket_error_10048
    SocketError10050 = 0xD50, // s_socket_error_10050
    SocketError10051 = 0xD51, // s_socket_error_10051
    SocketError10052 = 0xD52, // s_socket_error_10052
    SocketError10053 = 0xD53, // s_socket_error_10053
    SocketError10054 = 0xD54, // s_socket_error_10054
    SocketError10055 = 0xD55, // s_socket_error_10055
    SocketError10056 = 0xD56, // s_socket_error_10056
    SocketError10058 = 0xD57, // s_socket_error_10058
    SocketError10060 = 0xD58, // s_socket_error_10060
    SocketError10061 = 0xD59, // s_socket_error_10061
    SocketError10064 = 0xD5A, // s_socket_error_10064
    SocketError10065 = 0xD5B, // s_socket_error_10065
    SocketError10067 = 0xD5C, // s_socket_error_10067
    SocketError10101 = 0xD5D, // s_socket_error_10101
    SocketError11001 = 0xD5E, // s_socket_error_11001
    SocketError11002 = 0xD5F, // s_socket_error_11002
    SteamPurchaseRestrictionAdventureLevel = 0xD60, // s_steam_purchase_restriction_adventure_level
    SteamPurchaseRestrictionCharacterLevel = 0xD61, // s_steam_purchase_restriction_character_level
    SteamPurchaseRestrictionAccountCreateDays = 0xD62, // s_steam_purchase_restriction_account_create_days
    CommonBlockForSpamerNotEnoughMaxLevel = 0xD63, // s_common_block_for_spamer_not_enough_max_level
    CommonBlockForSpamerNotEnoughAdventureLevel = 0xD64, // s_common_block_for_spamer_not_enough_adventure_level
    WeddingMailTitleReceiver = 0xD65, // s_wedding_mail_title_receiver
    WeddingMailContentsReceiver = 0xD66, // s_wedding_mail_contents_receiver
    WeddingMailChangeTitleReceiver = 0xD67, // s_wedding_mail_change_title_receiver
    WeddingMailChangeContentsReceiver = 0xD68, // s_wedding_mail_change_contents_receiver
    WeddingMailCancelTitleReceiver = 0xD69, // s_wedding_mail_cancel_title_receiver
    WeddingMailCancelContentsReceiver = 0xD6A, // s_wedding_mail_cancel_contents_receiver
    PaybackErrorRewardTime = 0xD6B, // s_payback_error_reward_time
    HideandseekRemainUser = 0xD6C, // s_hideandseek_remain_user
    ItemgachaDialogTitle = 0xD6D, // s_itemgacha_dialog_title
    ItemgachaDialogGachaTypeSkin = 0xD6E, // s_itemgacha_dialog_gacha_type_skin
    ItemgachaDialogGachaTypeLook = 0xD6F, // s_itemgacha_dialog_gacha_type_look
    ItemgachaDialogGachaTypeSpecup = 0xD70, // s_itemgacha_dialog_gacha_type_specup
    ItemgachaDialogGachaTypeSpecial = 0xD71, // s_itemgacha_dialog_gacha_type_special
}
